<?php
  define('DEFAULT_ADMIN_MID', 'index');

  class Admin extends Zeroboard{

    var $main_menu_list = array(
          'site_manager',
          'module_manager',
          'plugin_manager',
          'page_manager',
          'layout_manager',
          'menu_manager',
          'member_manager',
          'server_manager',
          'article_manager',
        );

    var $mid = null;
    var $sid = null;

    var $my_info = null;
    var $member_srl = 0;

    var $newest_version = '';
    var $center_contents = '';

    function &instance($mid = '') {
      if(!$mid) $mid = $_REQUEST['mid'];
      
      $mid = Admin::_checkMid($mid?$mid:DEFAULT_ADMIN_MID);

      if(!$GLOBALS['_ZB_ADMIN'][$mid]) {
        switch($mid) {
          case 'site_manager' :
              require_class("Admin_Site_Manager");
              $GLOBALS['_ZB_ADMIN'][$mid] = new Admin_Site_Manager($mid);
            break;
          case 'server_manager' :
              require_class("Admin_Server_Manager");
              $GLOBALS['_ZB_ADMIN'][$mid] = new Admin_Server_Manager($mid);
            break;
          case 'menu_manager' :
              require_class("Admin_Menu_Manager");
              $GLOBALS['_ZB_ADMIN'][$mid] = new Admin_Menu_Manager($mid);
            break;
          case 'layout_manager' :
              require_class("Admin_Layout_Manager");
              $GLOBALS['_ZB_ADMIN'][$mid] = new Admin_Layout_Manager($mid);
            break;
          case 'module_manager' :
              require_class("Admin_Module_Manager");
              $GLOBALS['_ZB_ADMIN'][$mid] = new Admin_Module_Manager($mid);
            break;
          case 'page_manager' :
              require_class("Admin_Page_Manager");
              $GLOBALS['_ZB_ADMIN'][$mid] = new Admin_Page_Manager($mid);
            break;
          case 'plugin_manager' :
              require_class("Admin_Plugin_Manager");
              $GLOBALS['_ZB_ADMIN'][$mid] = new Admin_Plugin_Manager($mid);
            break;
          case 'member_manager' :
              require_class("Admin_Member_Manager");
              $GLOBALS['_ZB_ADMIN'][$mid] = new Admin_Member_Manager($mid);
            break;
          case 'article_manager' :
              require_class("Admin_Article_Manager");
              $GLOBALS['_ZB_ADMIN'][$mid] = new Admin_Article_Manager($mid);
            break;
          default :
              require_class("Admin_Index");
              $GLOBALS['_ZB_ADMIN'][$mid] = new Admin_Index($mid);
            break;
        }
      }

      return $GLOBALS['_ZB_ADMIN'][$mid];
    }

    function Admin($mid) {
      GLOBAL $lang;
      parent::Zeroboard();

      if(!$this->isInstalled()) {
        $this->installProc();
        exit();
      }

      $this->addLang(ADMIN_LANG_DIR);
      $this->addLang(FONTLIST_LANG_DIR);
      $this->addCssFile(ADMIN_CSS_DIR.'common.css');

      switch($this->lang_type) {
        default :
            $this->addCssFile(ADMIN_CSS_DIR.'lang.ko.css');
          break;
      }

      $this->mid = $mid;
      $oMember = &zMember::instance();
      if(!$oMember->isLogged()) $this->_printLoginHtml();
      if(!$oMember->isLevel(ADMINISTRATOR)) $this->_printMessageHTML();

      $this->my_info = $oMember->getMemberInfo();
      $this->member_srl = $this->my_info->member_srl;

      $this->_getCenterInfo();
    }

    function _checkMid($mid) {
      switch($mid) {
        case 'site_manager' :
        case 'module_manager' :
        case 'layout_manager' :
        case 'menu_manager' :
        case 'member_manager' :
        case 'page_manager' :
        case 'plugin_manager' :
        case 'server_manager' :
        case 'article_manager' :
            return $mid;
        default :
            return DEFAULT_ADMIN_MID;
      }
    }

    function _getCenterInfo() {
      if($GLOBALS['_check_center']) return;
      $GLOBALS['_check_center'] = true;

      $filename = FILES_DIR.'center_info.tmp.php';

      if(file_exists($filename)&&filemtime($filename)>time()-60*30) {
        $f = fopen($filename,"r");
        $buff = fread($f, filesize($filename));
        fclose($f);
        $tmp_str = unserialize(base64_decode($buff));
        $this->newest_version = $tmp_str->newest_version;
        $this->center_contents = $tmp_str->center_contents;
        return;
      }

      $fp = fsockopen("center.zeroboard.com",80,$errno,$errstr);
      if(!$fp) return;

      fputs($fp, "GET /server/server.php?lang={$this->lang_type} HTTP/1.0\r\n");
      fputs($fp, "Host: center.zeroboard.com\r\n\r\n");
      
      $start = false;
      while(!feof($fp)) {
        $line_buff = fgets($fp, 1024);
        if($start) $buff .= $line_buff;
        if(!trim($line_buff)) $start = true;
      }
      fclose($fp);

      $f = fopen($filename,"w");
      fwrite($f,$buff);
      fclose($f);

      $tmp_str = unserialize(base64_decode($buff));
      $this->newest_version = $tmp_str->newest_version;
      $this->center_contents = $tmp_str->center_contents;
    }

    function _getHtmlLayout() {
      $this->tpl->header = $this->oSmarty->assign_fetch(ADMIN_TPL_DIR.'header.tpl', $this);
      $this->tpl->footer = $this->oSmarty->assign_fetch(ADMIN_TPL_DIR.'footer.tpl', $this);
    }

    function _printHtml() {
      $this->_getHtmlLayout();
      $this->tpl->menu_header = $this->oSmarty->assign_fetch(ADMIN_TPL_DIR.'menu_header.tpl', $this);
      $this->tpl->menu_footer = $this->oSmarty->assign_fetch(ADMIN_TPL_DIR.'menu_footer.tpl', $this);
      print $this->oSmarty->assign_fetch(ADMIN_TPL_DIR.'index.tpl', $this);
    }

    function _printLoginHtml() {
      $this->_getHtmlLayout();
      $this->tpl->content = $this->oSmarty->assign_fetch(ADMIN_TPL_DIR.'login_form.tpl', $this);
      print $this->oSmarty->assign_fetch(ADMIN_TPL_DIR.'index.tpl', $this);
      exit();
    }

    function _printMessageHTML() {
      $this->_getHtmlLayout();
      $this->tpl->content = $this->oSmarty->assign_fetch(ADMIN_TPL_DIR.'message.tpl', $this);
      print $this->oSmarty->assign_fetch(ADMIN_TPL_DIR.'index.tpl', $this);
      exit();
    }
  }

?>
