<?php

  class Admin_Article_Manager extends Admin {

    var $article_menu_list = array('article_order_by_newest','article_order_by_modified','article_reported_move','article_reported_delete');
    var $comment_menu_list = array('comment_order_by_newest','comment_reported_delete');
    var $file_menu_list = array('used_file','unused_file');

    var $module_list = null;

    var $list_cnt = 20;

    var $type = null;

    function Admin_Article_Manager($mid) {
      parent::Admin($mid);
      $this->sid = $_REQUEST['sid']&&in_array($_REQUEST['sid'], array_merge($this->article_menu_list,$this->comment_menu_list,$this->file_menu_list))?$_REQUEST['sid']:'article_order_by_newest';
    }

    function proc($action = '', $obj = '') {

      switch($action) {
        default :
            $this->_getList();
            $this->_printListHtml();
          break;
      }
    }

    function _getList() {

      $this->oDB->select('*','module_manager',null,'module_category_srl');
      while($tmp = $this->oDB->fetch()) {
        $this->module_list[$tmp->module_srl] = $tmp;
      }

      $table_list = null;
      $cond_list = null;

      switch($this->sid) {
        case 'article_order_by_modified' :
            $table_list = 'articles';
            $cond_list[] = "modify_order < 0";
            $order_list = 'modify_order';
          break;

        case 'article_reported_move' :
            $table_list = array('articles a','report_log b');

            $cond_list[] = "b.listorder < 0";
            $cond_list[] = "a.article_srl = b.article_srl";
            $cond_list[] = "b.comment_srl = 0";
            $cond_list[] = "b.target_module_srl > 0";
            $order_list = 'b.listorder';
            $this->type = 'move';
          break;

        case 'article_reported_delete' :
            $table_list = array('articles a','report_log b');

            $cond_list[] = "b.listorder < 0";
            $cond_list[] = "a.article_srl = b.article_srl";
            $cond_list[] = "b.comment_srl = 0";
            $cond_list[] = "b.target_module_srl = 0";
            $order_list = 'b.listorder';
          break;

        case 'comment_order_by_newest' :
            $table_list = 'comment';
            $cond_list[] = "listorder > 0";
            $order_list = 'listorder desc';
          break;

        case 'comment_reported_delete' :
            $table_list = array('comment a','report_log b');
            $cond_list[] = "b.listorder < 0";
            $cond_list[] = "a.comment_srl = b.comment_srl";
            $order_list = 'b.listorder';
          break;

        case 'used_file' :
            $table_list = 'file';
            $cond_list[] = "listorder < 0";
            $cond_list[] = "is_used = 'Y'";
            $order_list = 'listorder';
          break;

        case 'unused_file' :
            $table_list = 'file';
            $cond_list[] = "listorder < 0";
            $cond_list[] = "is_used = 'N'";
            $order_list = 'listorder';
          break;

        default :
            $table_list = 'articles';
            $cond_list = "article_srl > 0";
            $order_list = 'article_srl desc';
          break;
      }

      $this->total_count = $this->oDB->getCount($table_list,$cond_list);
      $this->page_nav = Zeroboard::getPageNav($this->total_count, $this->list_cnt, 10);

      if(in_array($this->sid, $this->file_menu_list)) {
        $file_server = $this->oDB->select('*','server_manager',"server_type='file'");
        while($tmp = $this->oDB->fetch()) {
          $hostname = $tmp->hostname;
          if($tmp->port!='80') $hostname .= ":".$tmp->port;
          $server_info[$tmp->server_srl] = sprintf('http://%s%s%s',$hostname,$tmp->path,'file_download.php');
        }

        $this->oDB->select('*',$table_list, $cond_list, $order_list, $this->page_nav->start_cnt, $this->page_nav->list_cnt);
        $member_list = array();
        while($tmp = $this->oDB->fetch()) {
          $tmp->download_url = $server_info[$tmp->server_srl]."?filename=".$tmp->filename;
          $tmp->article_url = "./?article_srl=".$tmp->article_srl;
          if(in_array($tmp->ext,array('gif','jpeg','jpg','png'))) {
            $tmp->thumbnail_url = $tmp->download_url."&amp;type=thumbnail";
            $tmp->is_image = true;
          } else $tmp->is_image = false;
          $this->list[] = $tmp;
          if(!in_array($tmp->member_srl,$member_list)) $member_list[] = $tmp->member_srl;
        }
        if(count($member_list)) {
          $member_srls = implode(',',$member_list);
          $this->oDB->select(array('member_srl','nick_name','user_id'),'member_list',"member_srl in ({$member_srls})");
          while($tmp = $this->oDB->fetch()) {
            $member_info[$tmp->member_srl] = $tmp;
          }
          for($i=0;$i<count($this->list);$i++) {
            $member_srl = $this->list[$i]->member_srl;
            $this->list[$i]->nick_name = $member_info[$member_srl]->nick_name;
            $this->list[$i]->user_id = $member_info[$member_srl]->user_id;
          }
        }
      } else {
        $this->oDB->select('*',$table_list, $cond_list, $order_list, $this->page_nav->start_cnt, $this->page_nav->list_cnt);
        while($tmp = $this->oDB->fetch()) {
          if($this->type == 'move') $tmp->move_target = $this->module_list[$tmp->target_module_srl]->title;
          $this->list[] = $tmp;
        }
      }
    }

    function _printListHtml() {
      $this->page_nav_tpl = $this->oSmarty->assign_fetch(ADMIN_TPL_DIR."page_nav.include.tpl", $this);

      if(in_array($this->sid, $this->article_menu_list))  $tpl_filename = "article_manager_article.tpl";
      elseif(in_array($this->sid, $this->comment_menu_list))  $tpl_filename = "article_manager_comment.tpl";
      elseif(in_array($this->sid, $this->file_menu_list))  $tpl_filename = "article_manager_file.tpl";
      $this->list_tpl = $this->oSmarty->assign_fetch(ADMIN_TPL_DIR.$tpl_filename, $this);

      $this->tpl->content = $this->oSmarty->assign_fetch(ADMIN_TPL_DIR.'article_manager.tpl', $this);

      $this->_printHtml();
    }

    function _printHtml() {
      parent::_printHtml();
    }

  }
?>
