<?php

  class Admin_Index extends Admin {

    var $total_member = 0;
    var $today_member = 0;
    var $total_visitor = 0;
    var $total_pageview = 0;
    var $today_visitor = 0;
    var $today_pageview = 0;

    var $total_status = null;
    var $selected_status = null;
    var $query_list = null;
    var $total_query_list = null;

    var $module_list = null;

    var $admin_contents = null;

    var $sel_type = 'time';
    var $sel_year = null;
    var $sel_month = null;
    var $sel_day = null;

    function Admin_Index($mid) {
      parent::Admin($mid);
      $this->mid = 'summary';
      $this->sid = $_REQUEST['sid']?$_REQUEST['sid']:null;
      $this->sel_type = in_array($_REQUEST['sel_type'],array('time','day','month'))?$_REQUEST['sel_type']:'time';

      $this->sel_date = $_REQUEST['sel_date']?$_REQUEST['sel_date']:null;

      if(!$this->sel_date) {
        $this->sel_year = $_REQUEST['sel_year']>=2005&&$_REQUEST['sel_year']<=date("Y")?$_REQUEST['sel_year']:date("Y");
        $this->sel_month = $_REQUEST['sel_month']>=1&&$_REQUEST['sel_month']<=12?$_REQUEST['sel_month']:date("m");
        $this->sel_day = $_REQUEST['sel_day']>=1&&$_REQUEST['sel_day']<=31?$_REQUEST['sel_day']:date("d");
      } else {
        $this->sel_year = substr($this->sel_date,0,4)?substr($this->sel_date,0,4):date("Y");
        $this->sel_month = substr($this->sel_date,4,2)?substr($this->sel_date,4,2):date("m");
        $this->sel_day = substr($this->sel_date,6,2)?substr($this->sel_date,6,2):date("d");
      }
      $this->sel_date = sprintf("%04d%02d%02d", $this->sel_year, $this->sel_month, $this->sel_day);
    }

    function proc() {

      switch($this->sid) {

        case 'view_menu' :
            $this->_getSimpleStatus();
            $this->_getMenuStatus();
            $this->_printHtml();
          break;

        case 'view_query' :
            $this->_getSimpleStatus();
            $this->_getQueryStatus();
            $this->_printHtml();
          break;

        case 'view_status' :
            $this->_getSimpleStatus();
            $this->_getStatusDetail();
            $this->_printHtml();
          break;

        default : 
            $this->_getSimpleStatus();
            $this->_getIndexContent();
            $this->_printHtml();
          break;
      }
    }

    function _getIndexContent() {
      $this->admin_contents = $this->oSmarty->assign_fetch(ADMIN_TPL_DIR.'admin_index_content.tpl', $this);
    }

    function _getSimpleStatus() {
      $today = date("Ymd");

      $this->total_member = $this->oDB->getCount("member_list");
      $this->today_member = $this->oDB->getCount("member_list","regdate like '{$today}%'");

      $site_status = $this->oDB->selectList(array('regdate','unique','view'),'analytics',"regdate in ('00000000','{$today}')",'regdate');
      $this->total_visitor = $site_status->list[0]->unique;
      $this->total_pageview = $site_status->list[0]->view;
      $this->today_visitor = $site_status->list[1]->unique;
      $this->today_pageview = $site_status->list[1]->view;

      $oModule = &Admin::instance('module_manager');
      if($oModule->module_list) {
        foreach($oModule->module_list as $module => $value) {
          if(!$value->title) continue;
          $title = $value->title;
          unset($obj);
          $obj->module = $module;
          $obj->title = $title;
          if(!$oModule->check_install_status($module)) {
            $obj->installed = false;
            $this->module_list->$module = $obj;
          }
        }
      } 

      $fields_list = array("keyword","count(*) as cnt");
      $table_list = "search_keyword";
      $order_list = "cnt desc";
      $group_list = "keyword";
      $this->oDB->selectGroup($fields_list,$table_list,null,$order_list,$group_list,0,5);
      while($tmp = $this->oDB->fetch()) {
        $this->query_list[] = $tmp;
      }

      $tmp = $this->oDB->selectList('*','menu_tree',null,'view_cnt desc',0,5);
      $this->menu_list = $tmp->list;
    }

    function _getMenuStatus() {
      $tmp = $this->oDB->selectList('*','menu_tree',null,'view_cnt desc');
      $this->total_query_list = $tmp->list;
      $this->admin_contents = $this->oSmarty->assign_fetch(ADMIN_TPL_DIR.'admin_index_menu.tpl',$this);
    }


    function _getQueryStatus() {
      $fields_list = array("keyword","count(*) as cnt");
      $table_list = "search_keyword";
      $order_list = "cnt desc";
      $group_list = "keyword";
      $this->oDB->selectGroup($fields_list,$table_list,null,$order_list,$group_list,0,100);
      while($tmp = $this->oDB->fetch()) {
        $this->total_query_list[] = $tmp;
      }
      $this->admin_contents = $this->oSmarty->assign_fetch(ADMIN_TPL_DIR.'admin_index_query.tpl',$this);
    }

    function _getStatusDetail() {
      $this->total_status = $this->_arrangeStatus($this->oDB->selectOne('*','analytics',"regdate = 0"));
      switch($this->sel_type) {
        case 'month' :
            $sel_date = $this->oDB->addquotes(substr($this->sel_date,0,4));
            $this->oDB->select(array('regdate','unique','view'),'analytics',"regdate like '{$sel_date}%'",'regdate');
            $this->selected_status = $this->_arrangeStatusMonth();
          break;
        case 'day' :
            $sel_date = $this->oDB->addquotes(substr($this->sel_date,0,6));
            $this->oDB->select(array('regdate','unique','view'),'analytics',"regdate like '{$sel_date}%'",'regdate');
            $this->selected_status = $this->_arrangeStatusDay();
          break;
        default :
            $sel_date = $this->oDB->addquotes($this->sel_date);
            $this->selected_status = $this->_arrangeStatus($this->oDB->selectOne('*','analytics',"regdate = '{$sel_date}'"));
          break;
      }

      $this->admin_contents = $this->oSmarty->assign_fetch(ADMIN_TPL_DIR.'admin_index_status.tpl', $this);
    }

    function _arrangeStatusMonth() {
      $ret_obj->unique = $ret_obj->view = 0;
      while($tmp = $this->oDB->fetch()) {
        $regdate = substr($tmp->regdate,0,6);
        $unique = $tmp->unique;
        $view = $tmp->view;
        $ret_obj->unique += $unique;
        $ret_obj->view += $view;
        $ret_obj->list->{$regdate}->unique += $unique;
        $ret_obj->list->{$regdate}->view += $view;
      }

      if($ret_obj->unique && $ret_obj->view && $ret_obj->list) 
        foreach($ret_obj->list as $date=>$data) {
          $ret_obj->list->{$date}->unique_per = round(($data->unique / $ret_obj->unique)*100);
          $ret_obj->list->{$date}->view_per = round(($data->view / $ret_obj->view)*100);
        }
      else unset($ret_obj);
      return $ret_obj;
    }

    function _arrangeStatusDay() {
      $ret_obj->unique = $ret_obj->view = 0;
      while($tmp = $this->oDB->fetch()) {
        $regdate = $tmp->regdate;
        $unique = $tmp->unique;
        $view = $tmp->view;
        $ret_obj->unique += $unique;
        $ret_obj->view += $view;
        $ret_obj->list->{$regdate}->unique = $unique;
        $ret_obj->list->{$regdate}->view = $view;
      }

      if($ret_obj->unique && $ret_obj->view && $ret_obj->list) 
        foreach($ret_obj->list as $date=>$data) {
          $ret_obj->list->{$date}->unique_per = round(($data->unique / $ret_obj->unique)*100);
          $ret_obj->list->{$date}->view_per = round(($data->view / $ret_obj->view)*100);
        }
      else unset($ret_obj);
      return $ret_obj;
    }

    function _arrangeStatus($obj) {
      if(!$obj || !$obj->view) return;
      unset($obj->regdate);
      $max_unique = $max_view = 0;
      foreach($obj as $key => $val) {
        if(in_array($key, array('unique','view'))) $ret_obj->{$key}= $val;
        else {
          $headfix = substr($key,0,1);
          if($headfix == 'u') {
            $headfix = 'unique';
            if($max_unique<$val) $max_unique = $val;
          } else {
            $headfix = 'view';
            if($max_view<$val) $max_view= $val;
          }
          $hour = substr($key,1,strlen($key));
          $ret_obj->list->{$hour}->{$headfix} = $val;
        }
      }
      foreach($ret_obj->list as $hour=>$data) {
        $ret_obj->list->{$hour}->unique_per = round(($data->unique / $max_unique)*100);
        $ret_obj->list->{$hour}->view_per = round(($data->view / $max_view)*100);
      }
      return $ret_obj;
    }

    function _getHtmlLayout() {
      parent::_getHtmlLayout();
    }

    function _printHtml() {
      $this->tpl->content = $this->oSmarty->assign_fetch(ADMIN_TPL_DIR.'admin_index.tpl', $this);
      parent::_printHtml();
    }

  }
?>
