<?php

  class Admin_Layout_Manager extends Admin {

    var $sid = null;

    var $list =  array();

    var $layout_list = null;
    var $extends_var = null;

    var $columns_layout_manager = array(
          'layout_srl',
          'title',
          'comment',
          'layout',
          'theme',
          'val',
          'regdate'
        );

    function Admin_Layout_Manager($mid) {
      parent::Admin($mid);
      $this->sid = $_REQUEST['sid']?$_REQUEST['sid']:null;

      $this->_getLayoutList();
    }

    function proc($action = '', $obj = '') {

      switch($action) {
        case 'get_extends_info' :
            return $this->_getExtendsInfo($obj);
          break;
        case 'insert_layout' :
            return $this->_insertLayout($obj);
          break;
        case 'delete_layout' :
            return $this->_deleteLayout($obj);
          break;
        case 'update_layout' :
            return $this->_updateLayout($obj);
          break;
        case 'get_info_layout' :
            return $this->_getInfoLayout($obj);
          break;
        default :
            $this->_getList();
            $this->_printListHtml();
          break;
      }
    }

    function _getLayoutList() {
      $list = zFile::getDirectoryList(LAYOUT_DIR);
      for($i=0;$i<count($list);$i++) {
        unset($layout);
        $layout_name = $list[$i];
        @include(LAYOUT_DIR.$layout_name.'/require.var.php');
        if(!$layout) continue;
        $this->addLang(LAYOUT_DIR.$layout_name.'/lang/');
        $layout->title = $this->lang->layout->title;
        $this->layout_list[$layout_name] = $layout;
      }
    }

    function _getList() {
      $this->oDB->select('*','layout_manager',null,array('layout','layout_srl'));
      while($tmp = $this->oDB->fetch()) {
        $tmp->layout_title = $this->layout_list[$tmp->layout]->title;
        $this->list[] = $tmp;
      }
    }

    function _getExtendsInfo($obj) {
      @include LAYOUT_DIR.$obj->layout.'/require.var.php';
      $this->addLang(LAYOUT_DIR.$obj->layout.'/lang/');

      $this->announce = $this->lang->layout->announce;
      $image_key_list = array();

      $oDB = &zDB::instance();
      $tmp = $oDB->selectList(array('menu_srl','menu_name'),'menu_manager');
      if($tmp) foreach($tmp->list as $_k => $_v) {
        $menu_list[$_v->menu_srl] = $_v->menu_name;
      }

      $this->extends_var = $layout;
      foreach($this->extends_var as $key=>$val) {
        if(in_array($key, array('title','require_depth','announce'))) continue;

        $text_name = $val['text'];
        $trans_lang_val = $this->lang->layout->$text_name;
        $this->extends_var->{$key}['text'] = $trans_lang_val;
        $this->extends_var->{$key}['value'] = $this->extends_var->{$key}['default'];

        if($val['type'] == 'image') {
          $image_key_list[$key] = $key.'|@|';
        }

        if($val['type'] == 'menu_list') $this->extends_var->{$key}['menu_list'] = $menu_list;
      }
      
      $layout_srl = $this->oDB->addquotes($obj->layout_srl);

      if($obj->layout_srl) {
        $tmp = $this->oDB->selectOne('*','layout_manager',"layout_srl = '{$layout_srl}'");
        $tmp_val = unserialize(base64_decode($tmp->val));
        if(count($tmp_val)&&$tmp_val) foreach($tmp_val as $key => $val) {
          if($this->extends_var->{$key}) {
            $this->extends_var->{$key}['value'] = $val; 

            if($this->extends_var->{$key}['type']=='plugin' && $val>0) {
              $plugin_data = $this->oDB->selectOne('*','plugin_manager',"plugin_srl='{$val}'");
              $this->extends_var->{$key}['plugin_title'] = $plugin_data->title;
            }

            if($this->extends_var->{$key}['type']=='image') $image_key_list[$key] .= $val;
          }
        }
      }

      if(is_dir(LAYOUT_DIR.$obj->layout.'/theme')) {
        $theme_list = zFile::getDirectoryList(LAYOUT_DIR.$obj->layout.'/theme');
        $output->theme_list = implode('|@|',$theme_list);
      }

      $output->error = 0;
      $output->message = 'success';
      $output->tpl = $this->oSmarty->assign_fetch(COMMON_TPL_DIR."extends_form.include.tpl", $this);
      $output->image_key_list = implode(',',$image_key_list);
      return $output;
    }

    function _updateLayout($obj) {
      $layout_srl = $this->oDB->addquotes($obj->layout_srl);

      $obj->val = $this->oDB->addquotes(base64_encode(serialize($this->unsetKey($this->columns_layout_manager, $obj))));

      $obj = $this->delDummy($this->columns_layout_manager, $obj);

      unset($obj->layout_srl);

      $output = $this->oDB->update('layout_manager',$obj,"layout_srl = '{$layout_srl}'");
      $output->layout_srl = $layout_srl;

      return $output;
    }

    function _insertLayout($obj) {
      $obj->val = $this->oDB->addquotes(base64_encode(serialize($this->unsetKey($this->columns_layout_manager, $obj))));
      $obj->regdate = date('YmdHis');
      $obj->layout_srl = $this->oDB->getNextSequence();
      $obj = $this->delDummy($this->columns_layout_manager, $obj);

      $output = $this->oDB->insert('layout_manager',$obj);
      $output->layout_srl = $obj->layout_srl;
      return $output;
    }

    function _deleteLayout($obj) {
      $layout_srl = $this->oDB->addquotes($obj->layout_srl);

      $cnt = $this->oDB->getCount('menu_manager',"layout_srl = '{$layout_srl}'");
      if($cnt>0) return $this->getOutput(-1,$this->lang->admin->msg_layout_can_not_delete);

      $cnt = $this->oDB->getCount('menu_tree',"layout_srl = '{$layout_srl}'");
      if($cnt>0) return $this->getOutput(-1,$this->lang->admin->msg_layout_can_not_delete);

      $output = $this->oDB->delete('layout_manager',"layout_srl = '{$layout_srl}'");
      $output->layout_srl = $obj->layout_srl;
      return $output;
    }

    function _getInfoLayout($obj) {
      $layout_srl = $this->oDB->addquotes($obj->layout_srl);
      $output = $this->oDB->selectOne('*','layout_manager',"layout_srl = '{$layout_srl}'");

      if($this->layout_list[$output->layout]) {
        $tmp_output = $this->_getExtendsInfo($output);
        $output->tpl = $tmp_output->tpl;
        $output->image_key_list = $tmp_output->image_key_list;
        if($tmp_output->error!=0) return $this->getOutput($tmp_output->error,$tmp_output->message);
      } else {
        $output->layout = '';
        $output->tpl = '';
      }

      if($output->layout&& is_dir(LAYOUT_DIR.$output->layout.'/theme')) {
        $theme_list = zFile::getDirectoryList(LAYOUT_DIR.$output->layout.'/theme');
        $output->theme_list = implode('|@|',$theme_list);
      } else {
        $output->theme_list = '';
      }

      $output->error = 0;
      $output->message = 'success';

      unset($output->val);
      unset($output->regdate);
      return $output;
    }

    function uploadFile() {
      $layout_srl = $this->oDB->addquotes($_REQUEST['layout_srl']);
      if(!$layout_srl) exit();

      $tmp = $this->oDB->selectOne('*','layout_manager',"layout_srl = '{$layout_srl}'");
      $tmp_val = unserialize(base64_decode($tmp->val));

      foreach($_FILES as $key => $val) {

        if($_REQUEST['_delete_'.$key] == 'Y' && $tmp_val->{$key}) {
          $tmp_val->{$key} = '';
          zFile::deleteImageFile($tmp_val->{$key});
        }
        if($val['name'] && $val['size']) {
          if($tmp_val->{$key}) zFile::deleteImageFile($tmp_val->{$key});
          $tmp_val->{$key} = zFile::uploadImage($this->member_srl, $val);
        }
      }

      $val = base64_encode(serialize($tmp_val));
      $query_obj->val = $val;
      $this->oDB->update('layout_manager',$query_obj,"layout_srl='{$layout_srl}'");

      return "<script type='text/javascript'>top.location.replace(top.location.href);</script>";
    }

    function _printListHtml() {
      $this->tpl->content = $this->oSmarty->assign_fetch(ADMIN_TPL_DIR."layout_manager.tpl", $this);
      $this->_printHtml();
    }

    function _printHtml() {
      parent::_printHtml();
    }

  }
?>
