<?php

  class Admin_Member_Manager extends Admin {

    var $level_srl = null;

    var $search_target = array('user_id','user_name','nick_name');

    var $search_kind = null;
    var $search_keyword = null;
    var $search_expand = null;

    var $member_list_cnt = 14;

    var $member_list =  array();
    var $total_member_cnt = 0;
    var $member_info = null;
    var $member_srl = 0;

    var $level_list = array();
    var $simple_level_list = array();

    var $page_nav = null;
    var $page_nav_tpl = '';

    var $check_is_used = array('user_id','nick_name','email_address');
    var $check_not_empty_key = array('user_id','passwd','user_name','nick_name','email','email_host');

    var $columns_member_list = array(
          'member_srl',
          'listorder',
          'user_id',
          'passwd',
          'user_name',
          'nick_name',
          'email_address',
          'email',
          'email_host',
          'extend_val',
          'new_message',
          'point',
          'allowed',
          'denied',
          'mailing',
          'manager_message',
          'regdate',
          'last_signin',
          'image_nick',
          'image_mark',
          'profile_image',
          'sign',
        );

    var $columns_member_signup_manager = array(
          'form_srl',
          'name',
          'title',
          'type',
          'default_value',
          'value_list',
          'value',
          'check',
          'description',
          'listorder'
        );

    var $signup_form_list = null;
    var $signup_form_item = null;

    function Admin_Member_Manager($mid) {
      parent::Admin($mid);

      $this->level_srl = $_REQUEST['level_srl']==='0'||$_REQUEST['level_srl']?(int)$_REQUEST['level_srl']:null;
      $this->member_srl = $_REQUEST['member_srl']?(int)$_REQUEST['member_srl']:0;
      $this->search_kind = $_REQUEST['search_kind']&&in_array($_REQUEST['search_kind'],$this->search_target)?$_REQUEST['search_kind']:null;
      $this->search_keyword = $_REQUEST['search_keyword']?$_REQUEST['search_keyword']:null;
      $this->search_expand = $_REQUEST['search_expand']=='Y'?'Y':'N';

      $this->_getLevelList();
      $this->_getSignupForm();
    }

    function proc($action = '', $obj = '') {

      switch($action) {
        case 'insert_member' :
            return $this->_insertMember($obj);
          break;
        case 'update_member' :
            return $this->_updateMember($obj);
          break;
        case 'delete_member' :
            return $this->_deleteMember($obj);
          break;
        case 'get_member_info' :
            return $this->_getMemberInfo($obj);
          break;
        case 'get_selected_level_list' :
            return $this->_getSelectedLevelList($obj);
          break;
        case 'get_selected_level_info' :
            return $this->_getSelectedLevelInfo($obj);
          break;
        case 'get_member_level_info' :
            return $this->_getMemberLevelInfo($obj);
          break;
        case 'get_member_info_tpl' :
            return $this->_getMemberInfoTpl($obj);
          break;
        case 'get_level_list_tpl' :
            return $this->_getLevelListTpl($obj);
          break;
        case 'insert_level' :
            return $this->_insertLevel($obj);
          break;
        case 'delete_level' :
            return $this->_deleteLevel($obj);
          break;
        case 'update_level' :
            return $this->_updateLevel($obj);
          break;
        case 'get_level_info' :
            return $this->_getLevelInfo($obj);
          break;
        case 'get_signup_form_list_tpl' :
            return $this->_getSignupFormListTpl($obj);
          break;
        case 'get_signup_form_item' :
            return $this->_getSignupFormItem($obj);
          break;
        case 'add_signup_form_item' :
            return $this->_addSignupFormItem($obj);
          break;
        case 'delete_signup_form_item' :
            return $this->_deleteSignupFormItem($obj);
          break;
        case 'modify_signup_form_item' :
            return $this->_modifySignupFormItem($obj);
          break;
        case 'move_updown_signup_form_item' :
            return $this->_moveUpDownSignupFormItem($obj);
          break;
        default :
            $this->_getList();
            $this->_printListHtml();
          break;
      }
    }

    function _getLevelList() {
      $this->oDB->select('*','member_level_manager',null,array('level','level_srl'));
      while($tmp = $this->oDB->fetch()) {
        $this->level_list[$tmp->level][$tmp->level_srl] = $tmp;
        $this->simple_level_list[$tmp->level_srl] = $tmp;
      }
    }

    function _getSignupForm() {
      $output = $this->oDB->select('*','member_signup_manager',null,'listorder');
      if($output->error!=0) return $output;

      while($tmp = $this->oDB->fetch()) {
        if(strpos($tmp->value_list,'|@|')) $tmp->value_list = explode('|@|', $tmp->value_list);
        $this->signup_form_list[] = $tmp;
      }
    }

    function _insertMemberLevel($member_srl, $level_srl_list) {

      $this->oDB->delete('member_level',"member_srl='{$member_srl}'");

      $level_list = array();
      for($i=0;$i<count($level_srl_list);$i++) {
        $level_srl = trim($level_srl_list[$i]);
        if($level_srl) $level_list[] = $level_srl;
      }

      if(!count($level_list)) {
        $tmp = $this->oDB->selectOne('*','site_manager');
        $level_srl = $tmp->join_level_srl;
        $level_list[] = $level_srl;
      }

      for($i=0;$i<count($level_list);$i++) {
        $query_obj->member_srl = $member_srl;
        $query_obj->level_srl = $level_list[$i];
        $this->oDB->insert('member_level',$query_obj);
        unset($query_obj);
      }
    }

    function _checkMemberEmptyKey($obj) {
      for($i=0;$i<count($this->check_not_empty_key);$i++) {
        $key = $this->check_not_empty_key[$i];
        $val = $obj->{$key};
        if(!$val) return $this->getOutput(-1, $this->lang->admin->{"notice_member_fo_".$key});
      }

      $output->error = 0;
      $output->message = 'success';
      return $output;
    }

    function _checkMemberUniqueKey($obj) {
      $member_srl = $this->oDB->addquotes($obj->member_srl);
      for($i=0;$i<count($this->check_is_used);$i++) {
        $key = $this->check_is_used[$i];
        $val = $obj->{$key};

        if(!$member_srl) $cnt = $this->oDB->getCount('member_list',"{$key}='{$val}'");
        else $cnt = $this->oDB->getCount('member_list',array("{$key}='{$val}'","member_srl!='{$member_srl}'"));

        if($output->cnt>0) return $this->getOutput(-1,$this->lang->admin->{"notice_member_used_".$key});
      }

      $output->error = 0;
      $output->message = 'success';
      return $output;
    }

    function _insertMember($obj) {
      $level_srl_list = explode('|@|',$obj->level_srls);
      $query_obj->denied = $obj->denied;
      $query_obj->allowed = $obj->allowed;

      $oMember = &zMember::instance();
      $output = $oMember->proc('insert_member', $obj);
      if($output->error!=0) return $output;

      $member_srl = $output->member_srl;

      $this->oDB->update('member_list',$query_obj,"member_srl='{$member_srl}'");

      $this->_insertMemberLevel($member_srl, $level_srl_list);

      $output = Zeroboard::getOutput();
      $output->member_srl = $member_srl;
      return $output;
    }

    function _updateMember($obj) {
      $level_srl_list = explode('|@|',$obj->level_srls);
      $query_obj->denied = $obj->denied;
      $query_obj->allowed = $obj->allowed;

      $member_srl = $this->oDB->addquotes($obj->member_srl);

      $oMember = &zMember::instance();
      $output = $oMember->proc('update_member', $obj);
      if($output->error!=0) return $output;

      $this->oDB->update('member_list',$query_obj,"member_srl='{$member_srl}'");
      $this->_insertMemberLevel($member_srl, $level_srl_list);

      $this->_forceDoLogout($member_srl);

      $output = Zeroboard::getOutput();
      $output->member_srl = $member_srl;
      return $output;
    }

    function uploadFile() {
      $file_list = array(
          array('image_nick',120,26),
          array('image_mark',20,20),
          array('profile_image',120,120),
      );
      $member_srl = $this->oDB->addquotes($_REQUEST['member_srl']);
      if(!$member_srl || !$this->member_srl) return;

      $member_info = $this->oDB->selectOne(array('member_srl','image_nick','image_mark','profile_image'),'member_list',"member_srl='{$member_srl}'");
      if($member_info->member_srl!=$member_srl) return;

      for($i=0;$i<count($file_list);$i++) {
        $filename = $file_list[$i][0];
        $width = $file_list[$i][1];
        $height = $file_list[$i][2];

        if($_REQUEST['_delete_'.$filename] == 'Y' && $member_info->{$filename}) {
          $query_obj->{$filename}= '';
          zFile::deleteImageFile($member_info->{$filename});
        }
        if($_FILES[$filename]['name'] && $_FILES[$filename]['size']) {
          if($member_info->{$filename}) zFile::deleteImageFile($member_info->{$filename});
          $query_obj->{$filename} = zFile::uploadImage($this->member_srl, $_FILES[$filename], $width, $height);
        }
      }
      $this->oDB->update('member_list',$query_obj,"member_srl='{$member_srl}'");

      return "
          <script type='text/javascript'>
            var regx = /member_srl=[0-9]+/g;
            var url = top.location.href.replace(regx,'');
            top.location.href = url;
          </script>";
    }

    function _deleteMember($obj) {
      $member_srl = $this->oDB->addquotes($obj->member_srl);
      if($member_srl == $this->my_info->member_srl) return $this->getOutput();
      $output = $this->oDB->delete('member_list',"member_srl='{$member_srl}'");
      $this->_forceDoLogout($member_srl);
      return $output;
    }

    function _getMemberInfo($obj) {
      $member_srl = $this->oDB->addquotes($obj->member_srl);
      $output = $this->oDB->selectOne('*','member_list',"member_srl='{$member_srl}'");
      if($output->error!=0) return $output;

      if(!$output->member_srl) return $this->getOutput(-1,$this->lang->admin->notice_member_is_not_exists);

      $extend_val = unserialize(base64_decode($output->extend_val));

      for($i=0;$i<count($this->signup_form_list);$i++) {
        $signup_obj = $this->signup_form_list[$i];
        $name = $signup_obj->name;
        $type = $signup_obj->type;
        $value = $extend_val->{$name};
        switch($type) {
          case 'address' :
          case 'phone_number' :
          case 'checkbox' :
              $output->{$name} = explode('|@|',$value);
            break;
          default :
              $output->{$name} = $value;
            break;
        }
      }

      $tmp = $this->_getMemberLevelInfo($obj);
      $output->level_srls = $tmp->level_srls;
      $output->level_title = $tmp->level_title;

      $output->error = 0;
      $output->message = 'success';
      return $output;
    }

    function _getSelectedLevelInfo($obj) {
      $level_list = array();
      $level_title = array();

      if($obj->level_srls) {
        $level_srls = explode('|@|',$obj->level_srls);
        for($i=0;$i<count($level_srls);$i++) {
          $level_srl = trim($level_srls[$i]);
          if($level_srl) {
            $level_list[] = $level_srl;
            $level_title[] = $this->simple_level_list[$level_srl]->level_title;
          }
        }
      }

      $output->error = 0;
      $output->message = 'success';
      $output->level_srls = implode('|@|',$level_list);
      $output->level_title = implode(',',$level_title);
      if(!$output->level_title) $output->level_title = $this->lang->admin->fld_acclv[0];
      if(!$output->level_srls) $output->level_srls = 0;
      return $output;
    }

    function _getSelectedLevelList($obj) {
      $obj->level_list = $this->level_list;
      $obj->lang = $this->lang;
      $level_srl_list = explode('|@|',$obj->level_srls);
      for($i=0;$i<count($level_srl_list);$i++) {
        $level_srl = trim($level_srl_list[$i]);
        if($level_srl) $obj->selected_level_list[$level_srl] = true;
      }
      $output->error = 0;
      $output->message = 'success';
      $output->tpl = $this->oSmarty->assign_fetch(ADMIN_TPL_DIR."member_manager_level_select.include.tpl", $obj);
      return $output;
    }

    function _getMemberLevelInfo($obj) {
      $member_srl = $this->oDB->addquotes($obj->member_srl);
      if(!$member_srl) {
        $tmp = $this->oDB->selectOne('*','site_manager');
        $join_level_srl = $tmp->join_level_srl;
        if(!$join_level_srl) $join_level_srl = 0;
        $level_srl = array($join_level_srl);
        $level_title = array("");
      } else {
        $table_list = array('member_level a','member_level_manager b');
        $cond_list = array(
          "a.member_srl = '{$member_srl}'",
          "a.level_srl = b.level_srl",
        );
        $order_list = array(
          "b.level asc",
          "b.level_srl"
        );
        $output = $this->oDB->select('*',$table_list,$cond_list,$order_list);
        while($tmp = $this->oDB->fetch()) {
          $level_srl[] = $tmp->level_srl;
          $level_title[] = $tmp->level_title;
        }
      }
      $output->level_srls = implode("|@|",$level_srl);
      $output->level_title = implode(",",$level_title);
      return $output;
    }

    function _getMemberInfoTpl($obj) {
      if($obj->member_srl) $this->member_info = $this->_getMemberInfo($obj);
      $output->error  = 0;
      $output->message = 'success';
      $output->member_srl = $this->member_info->member_srl;
      $output->tpl = $this->oSmarty->assign_fetch(ADMIN_TPL_DIR."member_manager_form.include.tpl", $this);
      $output->image_nick = $this->member_info->image_nick;
      $output->image_mark = $this->member_info->image_mark;
      $output->profile_image = $this->member_info->profile_image;
      return $output;
    }

    function _getLevelListTpl($obj) {
      $output->error  = 0;
      $output->message = 'success';
      $output->tpl = $this->oSmarty->assign_fetch(ADMIN_TPL_DIR."member_manager_level_list.include.tpl", $this);
      return $output;
    }

    function _insertLevel($obj) {
      $level_title = $this->oDB->addquotes($obj->level_title);
      $cnt = $this->oDB->getCount('member_level_manager',"level_title='{$level_title}'");
      if($cnt > 0) return $this->getOutput(-1,$this->lang->admin->notice_member_level_exists);

      $query_obj->level_srl = $this->oDB->getNextSequence();
      $query_obj->level = $obj->level;
      $query_obj->level_title = $obj->level_title;
      return $this->oDB->insert('member_level_manager',$query_obj);
    }

    function _deleteLevel($obj) {
      $level_srl = $this->oDB->addquotes($obj->level_srl);
      $cnt = $this->oDB->getCount('site_manager',"join_level_srl='{$level_srl}'");
      if($cnt > 0) return $this->getOutput(-1,$this->lang->admin->notice_member_level_is_used);

      $cnt = $this->oDB->getCount('member_level',"level_srl='{$level_srl}'");
      if($cnt > 0) return $this->getOutput(-1,$this->lang->admin->notice_member_level_is_used);

      return $this->oDB->delete('member_level_manager',"level_srl='{$level_srl}'");
    }

    function _updateLevel($obj) {
      $level_title = $this->oDB->addquotes($obj->level_title);
      $level_srl = $this->oDB->addquotes($obj->level_srl);

      $cond_list = array(
        "level_title = '{$level_title}'",
        "level_srl != '{$level_srl}'",
      );

      $cnt = $this->oDB->getCount('member_level_manager',$cond_list);
      if($cnt > 0) $this->getOutput(-1,$this->lang->admin->notice_member_level_exists);

      $query_obj->level = $obj->level;
      $query_obj->level_title = $obj->level_title;
      $query_obj->level_srl = $obj->level_srl;
      return $this->oDB->update('member_level_manager',$query_obj,"level_srl='{$level_srl}'");
    }

    function _getLevelInfo($obj) {
      $level_srl = $this->oDB->addquotes($obj->level_srl);
      $output = $this->oDB->selectOne('*','member_level_manager',"level_srl='{$level_srl}'");
      $output->error = 0;
      $output->message = 'success';
      return $output;
    }


    function _getList($cur_page = '') {
      $this->level_srl = $this->oDB->addquotes($this->level_srl);
      $this->search_kind = $this->oDB->addquotes($this->search_kind);
      $this->search_keyword = $this->oDB->addquotes($this->search_keyword);

      $cond_list = array();

      if($this->search_keyword && $this->search_kind) {
        if($this->search_expand == 'Y') $cond_list[] = "a.{$this->search_kind} like '%{$this->search_keyword}%'";
        else $cond_list[] = "a.{$this->search_kind} = '{$this->search_keyword}'";
      }

      if($this->level_srl) {
        $table_list = array('member_list a','member_level b');
        array_unshift($cond_list,"a.member_srl = b.member_srl","b.level_srl = '{$this->level_srl}'");
        $cnt = $this->oDB->getCount($table_list,$cond_list);
      } else {
        $cnt = $this->oDB->getCount('member_list a',$cond_list);
      }
      $this->total_member_cnt = $cnt;
      $this->page_nav = $this->getPageNav($this->total_member_cnt, $this->member_list_cnt, 10, $cur_page);

      array_unshift($cond_list,"a.listorder < 0");

      if($this->level_srl) {
        $table_list = array('member_list a','member_level b');
        $output = $this->oDB->selectList('*',$table_list, $cond_list,'a.listorder',$this->page_nav->start_cnt,$this->page_nav->list_cnt);
      } else {
        $output = $this->oDB->selectList('*','member_list a',$cond_list,'a.listorder',$this->page_nav->start_cnt,$this->page_nav->list_cnt);
      }

      $this->member_list = $output->list;
    }

    function _getSignupFormListTpl($obj) {
      $output->tpl = $this->oSmarty->assign_fetch(ADMIN_TPL_DIR."member_signup_formlist.include.tpl", $this);
      $output->error = 0;
      $output->message = 'success';

      return $output;
    }

    function _getSignupFormItem($obj, $include_tpl = true) {
      $form_srl = $this->oDB->addquotes($obj->form_srl);
      $output = $this->oDB->selectOne('*','member_signup_manager',"form_srl = '{$form_srl}'");
      if(strpos($output->value_list,'|@|')) $output->value_list = explode('|@|', $output->value_list);
      $this->signup_form_item = $output;
      if($include_tpl) $output->tpl = $this->oSmarty->assign_fetch(ADMIN_TPL_DIR."member_signup_form_item_info.include.tpl", $this);
      $output->form_srl = $obj->form_srl;
      $output->error = 0;
      $output->message = 'success';
      return $output;
    }

    function _addSignupFormItem($obj) {
      $name = $this->oDB->addquotes($obj->name);

      if(in_array($name, $this->columns_member_list)) return $this->getOutput(-1,$this->lang->admin->notice_member_name_is_not_valid);

      $cnt = $this->oDB->getCount('member_signup_manager',"name='{$name}'");
      if($cnt > 0) return $this->getOutput(-1,$this->lang->admin->notice_signup_name_is_exists);

      $listorder = $this->oDB->getMax('member_signup_manager','listorder');

      if($listorder) $obj->listorder = $output->listorder+1;
      else $obj->listorder = 1;
      if($obj->check!='Y') $obj->check = 'N';

      $obj = $this->delDummy($this->columns_member_signup_manager, $obj);
      $obj->form_srl = $this->oDB->getNextSequence();
      $output = $this->oDB->insert('member_signup_manager',$obj);
      if($output->error!=0) return $output;

      $output->form_srl = $obj->form_srl;
      return $output;
    }

    function _deleteSignupFormItem($obj) {
      $form_srl = $this->oDB->addquotes($obj->form_srl);
      return $this->oDB->delete('member_signup_manager',"form_srl='{$form_srl}'");
    }

    function _modifySignupFormItem($obj) {
      $form_srl = $this->oDB->addquotes($obj->form_srl);

      if(substr($obj->value_list,-3)=='|@|') $obj->value_list = substr($obj->value_list,0,strlen($obj->value_list)-3);
      if($obj->check!='Y') $obj->check = 'N';

      $obj = $this->delDummy($this->columns_member_signup_manager, $obj);
      $output = $this->oDB->update('member_signup_manager',$obj,"form_srl='{$form_srl}'");
      if($output->error!=0) return $output;
      $output->form_srl = $obj->form_srl;
      return $output;
    }

    function _moveUpDownSignupFormItem($obj) {
      $item_info = $this->_getSignupFormItem($obj, false);
      if($item_info->error!=0) return $item_info;
      $listorder = $this->oDB->addquotes($item_info->listorder);
      $form_srl = $this->oDB->addquotes($obj->form_srl);

      if($obj->direct == 'down') $output->listorder = $this->oDB->getMin('member_signup_manager','listorder',"listorder>'{$listorder}'");
      else $output->listorder = $this->oDB->getMax('member_signup_manager','listorder',"listorder<'{$listorder}'");
      if($output->error!=0) return $output;

      if($output->error!=0) {
        $output->error = 0;
        $output->message = 'success';
        $output->form_srl = $form_srl;
        return $output;
      }

      $tmp_listorder = $output->listorder;

      $query_obj->listorder = $listorder;
      $output = $this->oDB->update('member_signup_manager',$query_obj,"listorder='{$tmp_listorder}'");
      if($output->error!=0) return $output;

      $query_obj->listorder = $tmp_listorder;
      $output = $this->oDB->update('member_signup_manager',$query_obj,"form_srl='{$form_srl}'");
      if($output->error!=0) return $output;

      $output->form_srl = $form_srl;

      return $output;
    }

    function _forceDoLogout($member_srl) {
      $member_srl = $this->oDB->addquotes($member_srl);

      $oMember = &zMember::instance();
      if($member_srl == $oMember->getMemberSrl()) return;

      $this->oDB->delete('session',"member_srl = '{$member_srl}'");
    }

    function _printListHtml() {
      $this->page_nav_tpl = $this->oSmarty->assign_fetch(ADMIN_TPL_DIR."page_nav.include.tpl", $this);
      $this->tpl->content = $this->oSmarty->assign_fetch(ADMIN_TPL_DIR."member_manager.tpl", $this);
      $this->_printHtml();
    }

    function _printHtml() {
      parent::_printHtml();
    }

  }
?>
