<?php

  class Admin_Menu_Manager extends Admin {

    var $sid = null;
    var $menu_srl = null;
    var $node_srl = null;

    var $menu_info = null;
    var $tree_list = null;
    var $simple_tree_list = null;

    var $layout_list = null;

    var $columns_menu_manager = array(
          'menu_srl',
          'menu_name',
          'depth',
          'layout_srl',
          'comment',
          'tree_list',
          'simple_tree_list',
          'regdate',
          'cache_interval'
        );
    var $columns_menu_tree = array(
          'node_srl',
          'menu_srl',
          'p_node_srl',
          'node_name',
          'layout_srl',
          'module_srl',
          'page_srl',
          'menu_type',
          'link_url',
          'page_path',
          'use_succession',
          'use_image',
          'img_normal',
          'img_hover',
          'img_select',
          'access_level',
          'show_level',
          'hidden',
          'depth',
          'comment',
          'listorder',
          'view_cnt',
          'regdate',
          'lastupdate',
        );

    function Admin_Menu_Manager($mid) {
      parent::Admin($mid);
      $this->sid = $_REQUEST['sid']?$_REQUEST['sid']:null;
      $this->menu_srl = $_REQUEST['menu_srl']?$_REQUEST['menu_srl']:null;
      $this->node_srl = $_REQUEST['node_srl']?$_REQUEST['node_srl']:null;
      $this->_getLayoutList();
    }

    function proc($action = '', $obj = '') {

      switch($action) {
        case 'insert_menu' :
            $output = $this->_insertMenu($obj);
            zMenu::updateNodeList($obj->menu_srl, &$tmp);
            return $output;
          break;

        case 'get_menu_info' :
            return $this->_getMenuInfo($obj);
          break;

        case 'update_menu' :
            $output = $this->_updateMenu($obj);
            zMenu::updateNodeList($obj->menu_srl, &$tmp);
            return $output;
          break;

        case 'delete_menu' :
            return $this->_deleteMenu($obj);
          break;

        case 'get_menu_info_tpl' :
            return $this->_getMenuInfoTpl($obj);
          break;

        case 'get_menu_tree_tpl' :
            return $this->_getMenuTreeTpl($obj);
          break;

        case 'get_parent_node_info' :
            return $this->_getParentNodeInfo($obj);
          break;

        case 'get_node_info' :
            return $this->_getNodeInfo($obj);
          break;

        case 'get_node_info_tpl' :
            return $this->_getNodeInfoTpl($obj);
          break;

        case 'insert_node' :
            $output = $this->_insertNode($obj);
            zMenu::updateNodeList($obj->menu_srl, &$tmp);
            return $output;
          break;

        case 'update_node' :
            $output = $this->_updateNode($obj);
            zMenu::updateNodeList($obj->menu_srl, &$tmp);
            return $output;
          break;

        case 'delete_node' :
            $output = $this->_deleteNode($obj);
            zMenu::updateNodeList($obj->menu_srl, &$tmp);
            return $output;
          break;

        case 'move_updown_node' :
            $output = $this->_moveUpdownNode($obj);
            zMenu::updateNodeList($obj->menu_srl, &$tmp);
            return $output;
          break;

        default :

            switch($this->sid) {
              case 'view_tree' :
                  $tmp_obj->menu_srl = $this->menu_srl;
                  $this->menu_info = $this->_getMenuInfo($tmp_obj);
                  $this->_printDetailHtml();
                break;

              default :
                  $this->_getList();
                  $this->_printListHtml();
                break;
            }
          break;
      }
    }

    function _insertMenu($obj) {
      $obj->regdate = date('YmdHis');
      if(!$obj->depth) $obj->depth = 0;
      $obj = $this->delDummy($this->columns_menu_manager, $obj);
      $obj->menu_srl = $this->oDB->getNextSequence();
      return $this->oDB->insert('menu_manager',$obj);
    }

    function _updateMenu($obj) {
      $apply_layout_all = $obj->apply_layout_all;
      $obj = $this->delDummy($this->columns_menu_manager, $obj);

      $menu_srl = $this->oDB->addquotes($obj->menu_srl);

      $output = $this->oDB->update('menu_manager',$obj,"menu_srl = '{$menu_srl}'");
      if($output->error!=0) return $output;

      if($apply_layout_all=='Y') {
        $query_obj->layout_srl = $this->oDB->addquotes($obj->layout_srl);
        $output = $this->oDB->update('menu_tree',$query_obj,"menu_srl = '{$menu_srl}'");
        if($output->error!=0) return $output;
      }

      $output->error  = 0;
      $output->message = 'success';
      $output->menu_srl = $obj->menu_srl;
      $output->p_node_srl = $obj->p_node_srl;
      $output->node_srl = $obj->node_srl;

      return $output;
    }

    function _insertNode($obj) {

      $obj->regdate = date('YmdHis');
      if(!$obj->p_node_srl) $obj->depth = 1;
      else {
        $node_srl = $this->oDB->addquotes($obj->p_node_srl);
        $output = $this->oDB->selectOne('*','menu_tree',"node_srl = '{$node_srl}'");
        $obj->depth = $output->depth+1;
      }

      $p_node_srl = $this->oDB->addquotes($obj->p_node_srl);
      $obj->listorder = $this->oDB->getMax('menu_tree','listorder', "p_node_srl = '{$p_node_srl}'") + 1;

      if($obj->link_url && !eregi(":\/\/",$obj->link_url)) $obj->link_url = 'http://'.$obj->link_url;

      $obj = $this->delDummy($this->columns_menu_tree, $obj);
      $obj->node_srl = $this->oDB->getNextSequence();
      $output = $this->oDB->insert('menu_tree',$obj);
      if($output->error!=0) return $output;

      $output->error  = 0;
      $output->message = 'success';
      $output->menu_srl = $obj->menu_srl;
      $output->p_node_srl = $obj->p_node_srl;
      $output->node_srl = $obj->node_srl;
      $this->_arrangeNode($output->menu_srl) ;

      if($obj->module_srl) {
        $query_obj->menu_srl = $this->oDB->addquotes($output->menu_srl);
        $query_obj->node_srl = $this->oDB->addquotes($output->node_srl);
        $module_srl = $this->oDB->addquotes($obj->module_srl);
        $this->oDB->update('module_manager',$query_obj,"module_srl = '{$module_srl}'");
      }

      return $output;
    }

    function _updateNode($obj) {
      $node_info = $this->_getNodeInfo($obj);
      $module_srl = $this->oDB->addquotes($obj->module_srl);
      if($obj->link_url && !eregi(":\/\/",$obj->link_url)) $obj->link_url = 'http://'.$obj->link_url;
      $obj = $this->delDummy($this->columns_menu_tree, $obj);
      $node_srl = $this->oDB->addquotes($obj->node_srl);

      $output = $this->oDB->update('menu_tree',$obj,"node_srl = '{$node_srl}'");
      if($output->error!=0) return $output;

      $output->error  = 0;
      $output->message = 'success';
      $output->menu_srl = $obj->menu_srl;
      $output->p_node_srl = $obj->p_node_srl;
      $output->node_srl = $obj->node_srl;

      if($node_info->module_srl && (!$module_srl || $module_srl != $node_info->module_srl) ) {
        $query_obj->menu_srl = 0;
        $query_obj->node_srl = 0;
        $this->oDB->update('module_manager',$query_obj,"module_srl = '{$node_info->module_srl}'");
        unset($query_obj);
      } 
      
      if($module_srl) {
        $query_obj->menu_srl = $node_info->menu_srl;
        $query_obj->node_srl = $node_info->node_srl;
        $this->oDB->update('module_manager',$query_obj,"module_srl = '{$module_srl}'");
      }

      return $output;
    }

    function _deleteNode($obj) {
      $node_info = $this->_getNodeInfo($obj);
      if($node_info->error!=0) return $node_info;

      $node_srl = $this->oDB->addquotes($obj->node_srl);
      $menu_srl = $this->oDB->addquotes($node_info->menu_srl);
      $p_node_srl = $this->oDB->addquotes($node_info->p_node_srl);

      $cnt = $this->oDB->getCount('menu_tree',"p_node_srl='{$node_srl}'");
      if($cnt > 0) return $this->getOutput(-1,$this->lang->admin->notice_menu_have_some_child);

      $output = $this->oDB->delete('menu_tree',"node_srl = '{$node_srl}'");
      if($output->error!=0) return $output;

      $output->error = 0;
      $output->message = 'success';
      $output->menu_srl = $menu_srl;
      $output->p_node_srl = $p_node_srl;
      $this->_arrangeNode($menu_srl);

      if($node_info->module_srl) {
        $query_obj->menu_srl = 0;
        $query_obj->node_srl = 0;
        $module_srl = $this->oDB->addquotes($node_info->module_srl);
        $this->oDB->update('module_manager',$query_obj,"module_srl = '{$module_srl}'");
      }

      return $output;
    }

    function _arrangeNode($menu_srl) {
      $menu_srl = $this->oDB->addquotes($menu_srl);
      $query_obj->depth = $this->oDB->getMax('menu_tree','depth',"menu_srl = '{$menu_srl}'");
      $this->oDB->update('menu_manager',$query_obj,"menu_srl = '{$menu_srl}'");
    }

    function _moveUpdownNode($obj) {
      $node_info = $this->_getNodeInfo($obj);
      if($node_info->error!=0) return $node_info;

      $menu_srl = $this->oDB->addquotes($node_info->menu_srl);
      $p_node_srl = $this->oDB->addquotes($node_info->p_node_srl);
      $node_srl = $this->oDB->addquotes($node_info->node_srl);
      $listorder = $this->oDB->addquotes($node_info->listorder);

      if($obj->direct == 'down') {
        $cond_list = array(
          "menu_srl = '{$menu_srl}'",
          "p_node_srl = '{$p_node_srl}'",
          "listorder > '{$listorder}'",
        );
        $tmp_listorder = $this->oDB->getMin('menu_tree','listorder', $cond_list);
        unset($cond_list);
      } else {
        $cond_list = array(
          "menu_srl = '{$menu_srl}'",
          "p_node_srl = '{$p_node_srl}'",
          "listorder < '{$listorder}'",
        );
        $tmp_listorder = $this->oDB->getMax('menu_tree','listorder', $cond_list);
        unset($cond_list);
      }

      $query_obj->listorder = $listorder;
      $cond_list = array(
        "menu_srl = '{$menu_srl}'",
        "p_node_srl = '{$p_node_srl}'",
        "listorder = '{$tmp_listorder}'",
      );
      $output = $this->oDB->update('menu_tree',$query_obj,$cond_list);
      if($output->error) return $output;

      $query_obj->listorder = $tmp_listorder;
      $cond_list = array(
        "menu_srl = '{$menu_srl}'",
        "p_node_srl = '{$p_node_srl}'",
        "node_srl = '{$node_srl}'",
      );
      $output = $this->oDB->update('menu_tree',$query_obj,$cond_list);
      $output->menu_srl = $menu_srl;
      $output->node_srl = $node_srl;
      return $output;
    }

    function _getMenuInfoTpl($obj) {
      $this->menu_srl = $obj->menu_srl;
      $output->error  = 0;
      $output->message = 'success';
      $this->menu_info = $this->_getMenuInfo($obj);
      $output->tpl = $this->oSmarty->assign_fetch(ADMIN_TPL_DIR."menu_manager_root_node.include.tpl", $this);
      return $output;
    }

    function _getMenuTreeTpl($obj) {
      $this->menu_srl = $obj->menu_srl;
      $this->menu_info = $this->_getMenuInfo($obj);

      $this->tree_list = unserialize(base64_decode($this->menu_info->tree_list));
      $this->simple_tree_list = unserialize(base64_decode($this->menu_info->simple_tree_list));

      /*
      if(!$this->tree_list) {
        $oMenu = new zMenu();
        $oMenu->_getTreeList($this->menu_srl);
        $this->tree_list = $oMenu->tree_list;
        $oMenu->_getTreeListSImply($this->tree_list, 0);
      }
      */

      $output->error  = 0;
      $output->message = 'success';
      $output->tpl = $this->oSmarty->assign_fetch(ADMIN_TPL_DIR."menu_manager_tree_list.include.tpl", $this);
      $output->node_srl = $obj->node_srl;
      return $output;
    }

    function _getNodeInfoTpl($obj) {
      $this->node_info = $this->_getNodeInfo($obj);
      $output->error  = 0;
      $output->message = 'success';
      $output->node_srl = $obj->node_srl;
      $output->tpl = $this->oSmarty->assign_fetch(ADMIN_TPL_DIR."menu_manager_node_info.include.tpl", $this);

      return $output;
    }

    function _getMenuInfo($obj) {
      $menu_srl = $this->oDB->addquotes($obj->menu_srl);
      $output = $this->oDB->selectOne('*','menu_manager',"menu_srl='{$menu_srl}'");
      $output->layout_title = $this->layout_list[$output->layout_srl]->title;
      $output->layout = $this->layout_list[$output->layout_srl]->layout;
      $output->error  = 0;
      $output->message = 'success';
      return $output;
    }

    function _getNodeInfo($obj) {
      $menu_srl = $this->oDB->addquotes($obj->menu_srl);
      $node_srl = $this->oDB->addquotes($obj->node_srl);
      $cond_list = array(
        "menu_srl = '{$menu_srl}'",
        "node_srl = '{$node_srl}'",
      );
      $output = $this->oDB->selectOne('*','menu_tree',$cond_list);
      if($output->module_srl>0) {
        $module_srl = $output->module_srl;
        $tmp = $this->oDB->selectOne('*','module_manager',"module_srl='{$module_srl}'");
        $output->module_title = $tmp->title;
      } elseif($output->page_srl>0) {
        $page_srl = $output->page_srl;
        $tmp = $this->oDB->selectOne('*','page_manager',"page_srl='{$page_srl}'");
        $output->page_title = $tmp->title;
      } else {
        $output->module_title = $output->page_title = '';
        $output->module_srl = $output->page_srl = 0;
      }

      $output->layout_title = $this->layout_list[$output->layout_srl]->title;
      $output->layout = $this->layout_list[$output->layout_srl]->layout;
      $p_node_info = $this->_getParentNodeInfo($output);
      $output->p_node_name = $p_node_info->p_node_name;

      $oMemberManager = &Admin::instance('member_manager');
      {
        $tmp_obj->level_srls = $output->access_level;
        $tmp = $oMemberManager->_getSelectedLevelInfo($tmp_obj);
        $output->access_level_title = $tmp->level_title;
        $output->access_level = $tmp->level_srls;

        $tmp_obj->level_srls = $output->show_level;
        $tmp = $oMemberManager->_getSelectedLevelInfo($tmp_obj);
        $output->show_level_title = $tmp->level_title;
        $output->show_level = $tmp->level_srls;
      }

      $output->error  = 0;
      $output->message = 'success';

      return $output;
    }

    function _getParentNodeInfo($obj) {

      $menu_srl = $this->oDB->addquotes($obj->menu_srl);
      $p_node_srl = $this->oDB->addquotes($obj->p_node_srl);
      $obj=$this->oDB->addquotes($obj);

      if(!$p_node_srl) {
        $output = $this->oDB->selectOne('*','menu_manager',"menu_srl = '{$menu_srl}'");
        $output->p_node_name = $output->menu_name;
        $output->p_node_srl = 0;
        $output->access_level_title = $output->show_level_title = '';
        $output->access_level = $output->show_level = 0;
        $output->layout_srl = 0;
      } else {
        $output = $this->oDB->selectOne('*','menu_tree',"node_srl='{$p_node_srl}'");
        $output->p_node_srl = $output->node_srl;
        $output->p_node_name = $output->node_name;
        unset($output->node_srl);
        unset($output->node_name);

        $oMemberManager = &Admin::instance('member_manager');
        {
          $tmp_obj->level_srls = $output->access_level;
          $tmp = $oMemberManager->_getSelectedLevelInfo($tmp_obj);
          $output->access_level_title = $tmp->level_title;
          $output->access_level = $tmp->level_srls;

          $tmp_obj->level_srls = $output->show_level;
          $tmp = $oMemberManager->_getSelectedLevelInfo($tmp_obj);
          $output->show_level_title = $tmp->level_title;
          $output->show_level = $tmp->level_srls;
        }
      }
      $output->error  = 0;
      $output->message = 'success';
      return $output;
    }

    function _deleteMenu($obj) {
      $menu_info = $this->_getMenuInfo($obj);
      $menu_srl = $this->oDB->addquotes($obj->menu_srl);
      $cnt = $this->oDB->getCount('menu_tree',"menu_srl='{$menu_srl}'");
      if($cnt>0) return $this->getOutput(-1,$this->lang->admin->notice_menu_can_not_delete);
      return $this->oDB->delete('menu_manager',"menu_srl='{$menu_srl}'");
    }

    function _getList() {
      $output = $this->oDB->select('*','menu_manager',null,'menu_srl');
      while($tmp = $this->oDB->fetch()) {
        $tmp->layout_title = $this->layout_list[$tmp->layout_srl]->title;
        $tmp->layout = $this->layout_list[$tmp->layout_srl]->layout;
        $this->list[$tmp->menu_srl] = $tmp; 
      }
    }

    function uploadFile() {
      $file_list = array('img_normal','img_hover','img_select');
      $node_srl = $this->oDB->addquotes($_REQUEST['node_srl']);
      if(!$node_srl || !$this->member_srl) return;

      $node_info = $this->oDB->selectOne('*','menu_tree',"node_srl='{$node_srl}'");

      if($node_info->node_srl!=$node_srl) return;
      for($i=0;$i<count($file_list);$i++) {
        $filename = $file_list[$i];

        if($_REQUEST['_delete_'.$filename] == 'Y' && $node_info->{$filename}) {
          $query_obj->{$filename}= '';
          zFile::deleteImageFile($node_info->{$filename});
        }
        if($_FILES[$filename]['name'] && $_FILES[$filename]['size']) {
          if($node_info->{$filename}) zFile::deleteImageFile($node_info->{$filename});
          $query_obj->{$filename} = zFile::uploadImage($this->member_srl, $_FILES[$filename]);
        }
      }
      $this->oDB->update('menu_tree',$query_obj,"node_srl='{$node_srl}'");

      zMenu::updateNodeList($node_info->menu_srl, &$tmp);

      return "<script type='text/javascript'>top.admin_menu_show_tree({$node_srl});</script>";
    }

    function _getLayoutList() {
      $this->oDB->select('*','layout_manager',null,array('layout','layout_srl desc'));
      while($tmp = $this->oDB->fetch()) {
        $this->layout_list[$tmp->layout_srl] = $tmp; 
      }
    }

    function _printListHtml() {
      $this->tpl->content = $this->oSmarty->assign_fetch(ADMIN_TPL_DIR."menu_manager.tpl", $this);
      $this->_printHtml();
    }

    function _printDetailHtml() {
      $this->tpl->content = $this->oSmarty->assign_fetch(ADMIN_TPL_DIR."menu_manager_detail.tpl", $this);
      $this->_printHtml();
    }

    function _printHtml() {
      parent::_printHtml();
    }

  }
?>
