<?php

  class Admin_Module_Manager extends Admin {

    var $sid = null;

    var $category_srl = null;
    var $search_keyword = null;
    var $check_using = 0;
    var $list_cnt = 14;

    var $list =  array();

    var $extends_var = null;

    var $page_nav = null;
    var $page_nav_tpl = '';

    var $module_list = null;
    var $module_srl = 0;
    var $category_list = null;
    var $server_list = null;

    var $columns_module_manager = array(
          'module_srl',
          'module_category_srl',
          'web_server_srl',
          'web_server_host',
          'file_server_srl',
          'title',
          'comment',
          'module',
          'menu_srl',
          'node_srl',
          'val',
          'skin',
          'theme',
          'access_level',
          'write_level',
          'view_level',
          'comment_level',
          'manager_level',
          'survey_level',
          'upload_level',
          'download_level',
          'upload_max_size',
          'image_width',
          'point',
          'regdate'
        );

    function Admin_Module_Manager($mid) {
      parent::Admin($mid);

      $this->sid = $_REQUEST['sid']?$_REQUEST['sid']:null;
      $this->module_srl = $_REQUEST['module_srl']?(int)$_REQUEST['module_srl']:0;
      $this->category_srl = $_REQUEST['category_srl']==='0'||$_REQUEST['category_srl']?(int)$_REQUEST['category_srl']:null;
      $this->search_keyword = $_REQUEST['search_keyword']?$_REQUEST['search_keyword']:null;
      $this->check_using = (int)$_REQUEST['check_using']?1:0;

      $this->server_max_upload_size = ini_get('upload_max_filesize');

      $this->_getServerList();
      $this->_getModuleList();
    }

    function proc($action = '', $obj = '') {

      switch($action) {
        case 'get_extends_info' :
            return $this->_getExtendsInfo($obj);
          break;
        case 'insert_module' :
            return $this->_insertModule($obj);
          break;
        case 'insert_modules' :
            return $this->_insertModules($obj);
          break;
        case 'delete_module' :
            return $this->_deleteModule($obj);
          break;
        case 'update_module' :
            return $this->_updateModule($obj);
          break;
        case 'get_module_info' :
            return $this->_getModuleInfo($obj);
          break;
        case 'insert_module_category' :
            return $this->_insertModuleCategory($obj);
          break;
        case 'delete_module_category' :
            return $this->_deleteModuleCategory($obj);
          break;
        case 'update_module_category' :
            return $this->_updateModuleCategory($obj);
          break;
        case 'get_module_category_list_tpl' :
            $this->_getModuleCategoryList();
            return $this->_getModuleCategoryListTpl($obj);
          break;
        case 'get_module_category_info' :
            return $this->_getModuleCategoryInfo($obj);
          break;
        case 'get_module_list_tpl' :
            $this->_getModuleCategoryList();
            return $this->_getModuleListTpl($obj);
          break;
        case 'get_theme' :
            return $this->_getColorset($obj,true);
          break;
        case 'install_module' :
            return $this->_installModule($obj);
          break;
        default :
            $this->_getModuleCategoryList();
            $this->_getList();
            $this->_printListHtml();
          break;
      }
    }

    function _getServerList() {
      $output = $this->oDB->select('*','server_manager',null,array('server_type','server_srl'));
      while($tmp = $this->oDB->fetch()) {
        $this->server_list->{$tmp->server_type}[$tmp->server_srl] = $tmp;
      }
    }

    function _getModuleList() {
      $list = zFile::getDirectoryList(MODULE_DIR);
      for($i=0;$i<count($list);$i++) {
        unset($module);
        $module_name = $list[$i];
        @include(MODULE_DIR.$module_name.'/require.var.php');
        $this->addLang(MODULE_DIR.$module_name.'/lang/');
        if(!$module) continue;
        $module->title = $this->lang->module->title;
        $this->module_list[$module_name] = $module;
      }
    }

    function _getModuleListTpl($obj) {
        $this->category_srl = $obj->category_srl==='0'||$obj->category_srl?(int)$obj->category_srl:null;
        $this->search_keyword = $obj->search_keyword;
        $this->check_using = $obj->filter_used;
        $this->list_cnt = $obj->list_cnt;
        $this->_getList($obj->page);
        $output->error = 0;
        $output->message = 'success';
        $output->tpl = $this->oSmarty->assign_fetch(ADMIN_TPL_DIR."module_manager_module_list.include.tpl", $this);
        return $output;
    }

    function _getList($cur_page = '') {
      $this->category_srl = $this->oDB->addquotes($this->category_srl);
      $this->search_keyword = $this->oDB->addquotes($this->search_keyword);

      if($this->category_srl != null) $cond_list[] = "module_category_srl = '{$this->category_srl}'";
      if($this->search_keyword != null) $cond_list[] = "title like '%{$this->search_keyword}%'";
      if($this->check_using == 1) $cond_list[] = "menu_srl != 0";
      elseif($this->check_using == 2) $cond_list[] = "menu_srl = 0";

      $total_cnt = $this->oDB->getCount('module_manager', $cond_list);

      $this->page_nav = $this->getPageNav($total_cnt, $this->list_cnt, 10, $cur_page);

      $this->oDB->select('*','module_manager',$cond_list, 'module_srl desc', $this->page_nav->start_cnt, $this->page_nav->list_cnt);
      while($tmp = $this->oDB->fetch()) {
        $module_category_srl = $tmp->module_category_srl;
        if($module_category_srl) $tmp->category_title = $this->category_list[$module_category_srl]->category_title;
        else $tmp->category_title = $this->lang->admin->fld_module_default_category;

        if($tmp->menu_srl > 0) {
          $tmp->mid = 'menu_manager';
          $tmp->sid = 'view_tree';
        }
        $tmp->module_title = $this->module_list[$tmp->module]->title;
        $this->list[] = $tmp;
      }
    }

    function _getExtendsInfo($obj) {
      @include MODULE_DIR.$obj->module.'/require.var.php';
      $this->addLang(MODULE_DIR.$obj->module.'/lang/');
      $this->announce = $this->lang->module->announce;
      $this->extends_var = $module;
      foreach($this->extends_var as $key=>$val) {
        if(in_array($key, array('title','require_depth'))) continue;

        $text_name = $val['text'];
        $trans_lang_val = $this->lang->module->$text_name;
        $this->extends_var->{$key}['text'] = $trans_lang_val;
        $this->extends_var->{$key}['value'] = $this->extends_var->{$key}['default'];
      }

      if($obj->module_srl) {
        $obj->module_srl = $this->oDB->addquotes($obj->module_srl);
        $tmp = $this->oDB->selectOne('*','module_manager',"module_srl = '{$obj->module_srl}'");
        $tmp_val = unserialize(base64_decode($tmp->val));
        foreach($tmp_val as $key => $val) {
          if($this->extends_var->{$key}) {
            $this->extends_var->{$key}['value'] = $val; 

            if($this->extends_var->{$key}['type']=='plugin' && $val>0) {
              $plugin_data = $this->oDB->selectOne('*','plugin_manager',"plugin_srl='{$val}'");
              $this->extends_var->{$key}['plugin_title'] = $plugin_data->title;
            }

            if($this->extends_var->{$key}['type']=='image') $image_key_list[$key] .= $val;
          }
        }
      }
      $output = $this->getOutput();
      $output->tpl = $this->oSmarty->assign_fetch(COMMON_TPL_DIR."extends_form.include.tpl", $this);

      $skin_tmp = $this->_getSkins($obj, true);
      $output->skin_list = $skin_tmp->list;

      return $output;
    }

    function _getWebServerHost($web_server_srl) {
      $web_server_srl = $this->oDB->addquotes($web_server_srl);
      $host_info = $this->oDB->selectOne('*','server_manager',"server_srl = '{$web_server_srl}'");

      $host = $host_info->hostname;
      $port = $host_info->port;
      if($port != 80) $host .= ":{$port}";
      $path = $host_info->path;

      return sprintf("http://%s%s",$host, $path);
    }

    function _insertModule($obj) {
      $obj->val = $this->oDB->addquotes(base64_encode(serialize($this->unsetKey($this->columns_module_manager, $obj))));
      $obj->regdate = date('YmdHis');
      $obj->web_server_host = $this->_getWebServerHost($obj->web_server_srl);

      require_class("zPoint");
      $obj->point = zPoint::serializePoint($obj);

      $obj = $this->delDummy($this->columns_module_manager, $obj);
      if(!$obj->image_width) $obj->image_width = 540;
      $obj->module_srl = $this->oDB->getNextSequence();

      $output = $this->oDB->insert('module_manager',$obj);

      if($obj->menu_srl) zMenu::updateNodeList($obj->menu_srl);

      return $output;
    }

    function _insertModules($obj) {
      $module_srl = $this->oDB->addquotes($obj->module_srl);

      $tmp = explode('|@|',$obj->module_title);
      for($i=0;$i<count($tmp);$i++) if($tmp[$i]) $module_list[] = trim($tmp[$i]);

      $module_info = $this->_getModuleInfo($obj);
      unset($module_info->tpl);
      unset($module_info->error);
      unset($module_info->message);
      $module_info->module_srl = '';
      $module_info->menu_srl = 0;
      $module_info->node_srl = 0;
      $val = unserialize(base64_decode($module_info->val));
      foreach($val as $key=>$value) $module_info->{$key} = $value;
      unset($module_info->val);

      for($i=0;$i<count($module_list);$i++) {
        $module_info->title = $module_list[$i];
        $this->_insertModule($module_info);
      }

      return $this->getOutput();
    }

    function _updateModule($obj) {
      $module_srl = $this->oDB->addquotes($obj->module_srl);
      $obj->val = $this->oDB->addquotes(base64_encode(serialize($this->unsetKey($this->columns_module_manager, $obj))));
      $obj->web_server_host = $this->_getWebServerHost($obj->web_server_srl);

      require_class("zPoint");
      $obj->point = zPoint::serializePoint($obj);

      $obj = $this->delDummy($this->columns_module_manager, $obj);
      if(!$obj->image_width) $obj->image_width = 540;

      $output = $this->oDB->update('module_manager',$obj,"module_srl = '{$module_srl}'");
      if($obj->menu_srl) zMenu::updateNodeList($obj->menu_srl);
      return $output;
    }


    function _deleteModule($obj) {
      $module_srl = $this->oDB->addquotes($obj->module_srl);

      $tmp = $this->oDB->selectOne('*','module_manager',"module_srl = '{$module_srl}'");
      if($tmp->menu_srl || $tmp->node_srl) return $this->getOutput(-1, $this->lang->admin->msg_module_can_not_delete);

      $output = $this->oDB->delete('module_manager',"module_srl = '{$module_srl}'");
      if($obj->menu_srl) zMenu::updateNodeList($obj->menu_srl);
      return $output;
    }

    function _getSkins($obj, $join_array = false) {
      $module = $obj->module;

      $module_path = MODULE_DIR.$module.'/skins';

      $list = zFile::getDirList($module_path);
      for($i=0;$i<count($list);$i++) if($list[$i]=='CVS') unset($list[$i]);
      if($join_array) $list = implode('|@|', $list);

      $output = $this->getOutput();
      $output->list = $list;
      return $output;
    }

    function _getColorset($obj, $join_array = false) {
      $skin_path = MODULE_DIR.$obj->module.'/skins/'.$obj->skin.'/';
      $theme_path = $skin_path.'theme/';

      $list = zFile::getDirList($theme_path);

      for($i=0;$i<count($list);$i++) if($list[$i]=='CVS') unset($list[$i]);
      if($join_array) $list = implode('|@|', $list);

      if(file_exists($skin_path.'require.var.php')) {
        $this->addLang($skin_path.'lang/');
        $this->announce = $this->lang->skin->announce;
        @include $skin_path.'/require.var.php';
        unset($this->extends_var);
        $this->extends_var = $skin;
        foreach($this->extends_var as $key=>$val) {
          if(in_array($key, array('title','require_depth'))) continue;

          $text_name = $val['text'];
          $trans_lang_val = $this->lang->skin->$text_name;
          $this->extends_var->{$key}['text'] = $trans_lang_val;
          $this->extends_var->{$key}['value'] = $this->extends_var->{$key}['default'];
        }

        if($obj->module_srl) {
          $tmp_val = unserialize(base64_decode($obj->val));
          foreach($tmp_val as $key => $val) {
            if($this->extends_var->{$key}) {
              $this->extends_var->{$key}['value'] = $val; 

              if($this->extends_var->{$key}['type']=='plugin' && $val>0) {
                $plugin_data = $this->oDB->selectOne('*','plugin_manager',"plugin_srl='{$val}'");
                $this->extends_var->{$key}['plugin_title'] = $plugin_data->title;
              }

              if($this->extends_var->{$key}['type']=='image') $image_key_list[$key] .= $val;
            }
          }
        }

        $tpl = $this->oSmarty->assign_fetch(COMMON_TPL_DIR."extends_form.include.tpl", $this);
      }

      $output = $this->getOutput();
      $output->skin_tpl = $tpl;
      $output->theme_list = $list;
      return $output;
    }

    function _getModuleInfo($obj) {
      $module_srl = $this->oDB->addquotes($obj->module_srl);

      $output = $this->oDB->selectOne('*','module_manager',"module_srl = '{$module_srl}'");

      require_class("zPoint");
      $tmp_obj = zPoint::unserializePoint($output->point);
      foreach($tmp_obj as $k => $v) $output->{$k} = $v;

      if($this->module_list[$output->module]) {
        $tmp_output = $this->_getExtendsInfo($output);
        if($tmp_output->error!=0) return $tmp_output;

        $output->tpl = $tmp_output->tpl;
      } else {
        $output->module = '';
        $output->tpl = '';
      }

      $oMemberManager = &Admin::instance('member_manager');
      {
        $tmp_obj->level_srls = $output->access_level;
        $tmp = $oMemberManager->_getSelectedLevelInfo($tmp_obj);
        $output->access_level_title = $tmp->level_title;
        $output->access_level = $tmp->level_srls;

        $tmp_obj->level_srls = $output->write_level;
        $tmp = $oMemberManager->_getSelectedLevelInfo($tmp_obj);
        $output->write_level_title = $tmp->level_title;
        $output->write_level = $tmp->level_srls;

        $tmp_obj->level_srls = $output->view_level;
        $tmp = $oMemberManager->_getSelectedLevelInfo($tmp_obj);
        $output->view_level_title = $tmp->level_title;
        $output->view_level = $tmp->level_srls;

        $tmp_obj->level_srls = $output->comment_level;
        $tmp = $oMemberManager->_getSelectedLevelInfo($tmp_obj);
        $output->comment_level_title = $tmp->level_title;
        $output->comment_level = $tmp->level_srls;

        $tmp_obj->level_srls = $output->manager_level;
        $tmp = $oMemberManager->_getSelectedLevelInfo($tmp_obj);
        if($tmp->level_srls) $output->manager_level_title = $tmp->level_title;
        $output->manager_level = $tmp->level_srls;

        $tmp_obj->level_srls = $output->survey_level;
        $tmp = $oMemberManager->_getSelectedLevelInfo($tmp_obj);
        if($tmp->level_srls) $output->survey_level_title = $tmp->level_title;
        $output->survey_level = $tmp->level_srls;

        $tmp_obj->level_srls = $output->upload_level;
        $tmp = $oMemberManager->_getSelectedLevelInfo($tmp_obj);
        if($tmp->level_srls) $output->upload_level_title = $tmp->level_title;
        $output->upload_level = $tmp->level_srls;

        $tmp_obj->level_srls = $output->download_level;
        $tmp = $oMemberManager->_getSelectedLevelInfo($tmp_obj);
        if($tmp->level_srls) $output->download_level_title = $tmp->level_title;
        $output->download_level = $tmp->level_srls;
      }
      $output->error = 0;
      $output->message = 'success';

      $skin_tmp = $this->_getSkins($output, true);
      $output->skin_list = $skin_tmp->list;

      $theme_tmp = $this->_getColorset($output, true);
      $output->theme_list = $theme_tmp->theme_list;
      $output->skin_tpl = $theme_tmp->skin_tpl;

      return $output;

    }

    function _insertModuleCategory($obj) {
      $category_title = $this->oDB->addquotes($obj->category_title);
      $tmp = $this->oDB->getCount('*','module_category',"category_title = '{$category_title}'");
      if($tmp->cnt > 0) return $this->getOutput(-1,$this->lang->admin->msg_module_category_title_exists);

      $query_obj->module_category_srl = $this->oDB->getNextSequence();
      $query_obj->category_title = $obj->category_title;
      $this->oDB->insert('module_category',$query_obj);
      return Zeroboard::getOutput(0,'success');
    }

    function _deleteModuleCategory($obj) {
      $module_category_srl = $this->oDB->addquotes($obj->module_category_srl);
      $cnt = $this->oDB->getCount('module_manager', "module_category_srl = '{$module_category_srl}'");
      if($cnt > 0) return $this->getOutput(-1,$this->lang->admin->msg_module_can_not_delete_category);

      return $this->oDB->delete('module_category', "module_category_srl = '{$module_category_srl}'");
    }

    function _updateModuleCategory($obj) {
      $category_title = $this->oDB->addquotes($obj->category_title);
      $module_category_srl = $this->oDB->addquotes($obj->module_category_srl);
      $cond_list = array("category_title = '{$category_title}'","module_category_srl != '{$module_category_srl}'");
      $tmp = $this->oDB->getCount('*','module_category',$cond_list);
      if($tmp->cnt > 0) return $this->getOutput(-1,$this->lang->admin->msg_module_category_title_exists);

      $query_obj->category_title = $obj->category_title;
      return $this->oDB->update('module_category',$query_obj,"module_category_srl = '{$module_category_srl}'");
    }

    function _getModuleCategoryList() {
      $this->oDB->select('*','module_category',null,'module_category_srl');
      while($tmp = $this->oDB->fetch()) {
        $this->category_list[$tmp->module_category_srl] = $tmp;
      }
    }

    function _getModuleCategoryListTpl($obj) {
      $output->error  = 0;
      $output->message = 'success';
      $output->tpl = $this->oSmarty->assign_fetch(ADMIN_TPL_DIR."module_manager_category_list.include.tpl", $this);

      return $output;
    }

    function _getModuleCategoryInfo($obj) {
      $module_category_srl = $this->oDB->addquotes($obj->module_category_srl);
      $output = $this->oDB->selectOne('*','module_category',"module_category_srl = '{$module_category_srl}'");
      $output->error = 0;
      $output->message = 'success';

      return $output;
    }

    function check_install_status($module) {
      $classFile = sprintf("%s%s/module.class.php",MODULE_DIR,$module);
      if(!file_exists($classFile)) return;

      require_once($classFile);
      eval('$oModule = new '.$module.'();');
      return $oModule->installed();
    }

    function _installModule($obj) {
      $module = $obj->module;

      $classFile = sprintf("%s%s/%s.class.php",MODULE_DIR,$module,$module);
      if(!file_exists($classFile)) return;

      require_once($classFile);
      $oModule = new zModule();
      return $oModule->install();
    }

    function _printListHtml() {
      $this->page_nav_tpl = $this->oSmarty->assign_fetch(ADMIN_TPL_DIR."page_nav.include.tpl", $this);
      $this->tpl->content = $this->oSmarty->assign_fetch(ADMIN_TPL_DIR."module_manager.tpl", $this);
      $this->_printHtml();
    }

    function _printHtml() {
      parent::_printHtml();
    }

  }
?>
