<?php

  class Admin_Page_Manager extends Admin {

    var $sid = null;

    var $category_srl = null;
    var $search_keyword = null;
    var $check_using = 0;
    var $list_cnt = 14;

    var $list =  array();

    var $extends_var = null;

    var $page_srl = 0;

    var $page_nav = null;
    var $page_nav_tpl = '';

    var $page_list = null;
    var $category_list = null;

    var $columns_page_manager = array(
          'page_srl',
          'page_category_srl',
          'title',
          'cache_interval',
          'regdate'
        );

    function Admin_Page_Manager($mid) {
      parent::Admin($mid);

      $this->sid = $_REQUEST['sid']?$_REQUEST['sid']:null;
      $this->category_srl = $_REQUEST['category_srl']==='0'||$_REQUEST['category_srl']?(int)$_REQUEST['category_srl']:null;
      $this->search_keyword = $_REQUEST['search_keyword']?$_REQUEST['search_keyword']:null;
      $this->page_srl = $_REQUEST['page_srl']?(int)$_REQUEST['page_srl']:0;
    }

    function proc($action = '', $obj = '') {

      switch($action) {
        case 'insert_page' :
            return $this->_insertPage($obj);
          break;
        case 'delete_page' :
            return $this->_deletePage($obj);
          break;
        case 'update_page' :
            return $this->_updatePage($obj);
          break;
        case 'get_page_info' :
            return $this->_getPageInfo($obj);
          break;
        case 'get_plugin_info' :
            return $this->_getPluginInfo($obj);
          break;
        case 'insert_page_category' :
            return $this->_insertPageCategory($obj);
          break;
        case 'delete_page_category' :
            return $this->_deletePageCategory($obj);
          break;
        case 'update_page_category' :
            return $this->_updatePageCategory($obj);
          break;
        case 'get_page_category_list_tpl' :
            $this->_getPageCategoryList();
            return $this->_getPageCategoryListTpl($obj);
          break;
        case 'get_page_category_info' :
            return $this->_getPageCategoryInfo($obj);
          break;
        case 'get_page_list_tpl' :
            $this->_getPageCategoryList();
            return $this->_getPageListTpl($obj);
          break;
        default :
            $this->_getPageCategoryList();
            $this->_getList();
            $this->_printListHtml();
          break;
      }
    }

    function _getPageListTpl($obj) {
        $this->category_srl = $obj->category_srl==='0'||$obj->category_srl?(int)$obj->category_srl:null;
        $this->search_keyword = $obj->search_keyword;
        $this->check_using = $obj->filter_used;
        $this->list_cnt = $obj->list_cnt;
        $this->_getList($obj->page);
        $output->error = 0;
        $output->message = 'success';
        $output->tpl = $this->oSmarty->assign_fetch(ADMIN_TPL_DIR."page_manager_page_list.include.tpl", $this);
        return $output;
    }

    function _getList($cur_page = '') {
      $this->category_srl = $this->oDB->addquotes($this->category_srl);
      $this->search_keyword = $this->oDB->addquotes($this->search_keyword);

      if($this->category_srl != null) $cond_list[] = "page_category_srl = '{$this->category_srl}'";
      if($this->search_keyword != null) $cond_list[] = "title like '%{$this->search_keyword}%'";

      $total_cnt = $this->oDB->getCount('page_manager', $cond_list);

      $this->page_nav = $this->getPageNav($total_cnt, $this->list_cnt, 10, $cur_page);

      $this->oDB->select('*','page_manager',$cond_list, 'page_srl desc', $this->page_nav->start_cnt, $this->page_nav->list_cnt);
      while($tmp = $this->oDB->fetch()) {
        $page_category_srl = $tmp->page_category_srl;
        if($page_category_srl) $tmp->category_title = $this->category_list[$page_category_srl]->category_title;
        else $tmp->category_title = $this->lang->admin->fld_page_default_category;

        $this->list[] = $tmp;
      }
    }

    function _insertPage($obj) {
      $tmp_obj = $this->unsetKey($this->columns_page_manager, $obj);
      $obj = $this->delDummy($this->columns_page_manager, $obj);
      $obj->regdate = date('YmdHis');
      $obj->page_srl = $this->oDB->getNextSequence();

      $this->oDB->insert('page_manager',$obj);
      $page_srl = $obj->page_srl;
      $this->_insertPagePlugins($page_srl, $tmp_obj);

      return $this->getOutput();
    }

    function _updatePage($obj) {
      $page_srl = $this->oDB->addquotes($obj->page_srl);
      $tmp_obj = $this->unsetKey($this->columns_page_manager, $obj);
      $obj = $this->delDummy($this->columns_page_manager, $obj);
      $obj->cache_data = '';

      $this->oDB->update('page_manager',$obj,"page_srl = '{$page_srl}'");

      $this->_insertPagePlugins($page_srl, $tmp_obj);

      return $this->getOutput();
    }

    function _insertPagePlugins($page_srl, $obj) {
      $this->oDB->delete('page_plugin',"page_srl = '{$page_srl}'");

      $tmp_plugin_srl_list = explode('|@|', $obj->plugin_srls);
      $tmp_plugin_attributes = explode('|@|', $obj->plugin_attrs);
      for($i=0;$i<count($tmp_plugin_srl_list);$i++) {
        unset($plugin_obj);
        $plugin_obj->plugin_srl = $tmp_plugin_srl_list[$i];

        $tmp = explode(",",$tmp_plugin_attributes[$i]);
        $plugin_obj->page_plugin_srl = $this->oDB->getNextSequence();
        $plugin_obj->width = $tmp[0];
        $plugin_obj->padding = $tmp[1];
        $plugin_obj->float = $tmp[2];
        $plugin_obj->height = str_replace('px','',$tmp[3]);
        $plugin_obj->page_srl = $page_srl;

        $this->oDB->insert('page_plugin',$plugin_obj);
      }
    }

    function _deletePage($obj) {
      $page_srl = $this->oDB->addquotes($obj->page_srl);
      $tmp = $this->oDB->selectOne('*','page_manager',"page_srl = '{$page_srl}'");
      $this->oDB->delete('page_manager',"page_srl = '{$page_srl}'");
      $this->oDB->delete('page_plugin',"page_srl = '{$page_srl}'");
    }

    function _getPageInfo($obj) {
      $page_srl = $this->oDB->addquotes($obj->page_srl);
      $output = $this->oDB->selectOne('*','page_manager',"page_srl = '{$page_srl}'");

      $table_list = array('page_plugin a left out join plugin_manager b on a.plugin_srl = b.plugin_srl');
      $cond_list = array("a.page_srl = '{$page_srl}'");
      $plugin_list = $this->oDB->selectList('*',$table_list, $cond_list,'a.page_plugin_srl');

      for($i=0;$i<count($plugin_list->list);$i++) {
        $plugin_obj = $plugin_list->list[$i];
        $plugin_srls[] = $plugin_obj->plugin_srl;
        $plugin_attrs[] = implode(',',array($plugin_obj->width,$plugin_obj->padding,$plugin_obj->float,$plugin_obj->height));
      }
      if(count($plugin_srls)) $output->plugin_srls = implode('|@|',$plugin_srls);
      else $output->plugin_srls = '';
      if(count($plugin_attrs)) $output->plugin_attrs = implode('|@|',$plugin_attrs);
      else $output->plugin_attrs = '';
      $output->error = 0;
      $output->message = 'success';
      return $output;
    }

    function _getPageTpl($obj) {
      $oPluginManager = &Admin::instance('plugin_manager');

      $page_srl = $this->oDB->addquotes($obj->page_srl);

      $output = $this->oDB->selectOne('*','page_manager',"page_srl = '{$page_srl}'");

      $table_list = array('page_plugin a','plugin_manager b');
      $cond_list = array("a.page_srl = '{$page_srl}'","a.plugin_srl = b.plugin_srl");
      $plugin_list = $this->oDB->selectList('*',$table_list, $cond_list,'a.page_plugin_srl');

      $output->tpl = '';

      for($i=0;$i<count($plugin_list->list);$i++) {
        $tmp_obj = $plugin_list->list[$i];
        $tmp_tpl = $oPluginManager->_getPluginTpl($plugin_list->list[$i]);
        if($tmp_tpl->output==0) $output->tpl .= $tmp_tpl->tpl;
      }

      $output->error = 0;
      $output->message = 'success';
      return $output;
    }

    function _insertPageCategory($obj) {
      $category_title = $this->oDB->addquotes($obj->category_title);
      $cnt = $this->oDB->getCount('page_category',"category_title = '{$category_title}'");
      if($cnt > 0) return $this->getOutput(-1,$this->lang->admin->msg_page_category_title_exists);

      $query_obj->page_category_srl = $this->oDB->getNextSequence();
      $query_obj->category_title = $obj->category_title;
      return $this->oDB->insert('page_category',$query_obj);
    }

    function _deletePageCategory($obj) {
      $page_category_srl = $this->oDB->addquotes($obj->page_category_srl);
      $cnt = $this->oDB->getCount('page_manager', "page_category_srl = '{$page_category_srl}'");
      if($cnt > 0) return $this->getOutput(-1,$this->lang->admin->msg_page_can_not_delete_category);

      return $this->oDB->delete('page_category', "page_category_srl = '{$page_category_srl}'");
    }

    function _updatePageCategory($obj) {
      $category_title = $this->oDB->addquotes($obj->category_title);
      $page_category_srl = $this->oDB->addquotes($obj->page_category_srl);
      $cond_list = array("category_title = '{$category_title}'","page_category_srl != '{$page_category_srl}'");
      $cnt = $this->oDB->getCount('page_category',$cond_list);
      if($cnt > 0) return $this->getOutput(-1,$this->lang->admin->msg_page_category_title_exists);

      $query_obj->category_title = $obj->category_title;
      return $this->oDB->update('page_category',$query_obj,"page_category_srl = '{$page_category_srl}'");
    }

    function _getPageCategoryList() {
      $this->oDB->select('*','page_category',null,'page_category_srl');
      while($tmp = $this->oDB->fetch()) {
        $this->category_list[$tmp->page_category_srl] = $tmp;
      }
    }

    function _getPageCategoryListTpl($obj) {
      $output->error  = 0;
      $output->message = 'success';
      $output->tpl = $this->oSmarty->assign_fetch(ADMIN_TPL_DIR."page_manager_category_list.include.tpl", $this);
      return $output;
    }

    function _getPageCategoryInfo($obj) {
      $page_category_srl = $this->oDB->addquotes($obj->page_category_srl);
      $output = $this->oDB->selectOne('*','page_category',"page_category_srl = '{$page_category_srl}'");
      $output->error = 0;
      $output->message = 'success';

      return $output;
    }

    function _printListHtml() {
      $this->page_nav_tpl = $this->oSmarty->assign_fetch(ADMIN_TPL_DIR."page_nav.include.tpl", $this);
      $this->tpl->content = $this->oSmarty->assign_fetch(ADMIN_TPL_DIR."page_manager.tpl", $this);
      $this->_printHtml();
    }

    function _printHtml() {
      parent::_printHtml();
    }

  }
?>
