<?php

  class Admin_Plugin_Manager extends Admin {

    var $sid = null;

    var $category_srl = null;
    var $search_keyword = null;
    var $list_cnt = 14;

    var $list =  array();

    var $extends_var = null;

    var $page_nav = null;
    var $page_nav_tpl = '';

    var $plugin_list = null;
    var $category_list = null;

    var $columns_plugin_manager = array(
          'plugin_srl',
          'plugin_category_srl',
          'title',
          'comment',
          'plugin',
          'theme',
          'val',
          'cache_interval',
          'cache_data',
          'regdate'
        );

    var $plugin_classes = array();

    function Admin_Plugin_Manager($mid) {
      parent::Admin($mid);

      $this->sid = $_REQUEST['sid']?$_REQUEST['sid']:null;
      $this->category_srl = $_REQUEST['category_srl']==='0'||$_REQUEST['category_srl']?(int)$_REQUEST['category_srl']:null;
      $this->search_keyword = $_REQUEST['search_keyword']?$_REQUEST['search_keyword']:null;

      $this->_getPluginList();
    }

    function proc($action = '', $obj = '') {
      switch($action) {
        case 'get_extends_info' :
            return $this->_getExtendsInfo($obj);
          break;
        case 'insert_plugin' :
            return $this->_insertPlugin($obj);
          break;
        case 'insert_plugins' :
            return $this->_insertPlugins($obj);
          break;
        case 'delete_plugin' :
            return $this->_deletePlugin($obj);
          break;
        case 'update_plugin' :
            return $this->_updatePlugin($obj);
          break;
        case 'get_plugin_info' :
            return $this->_getPluginInfo($obj);
          break;
        case 'insert_plugin_category' :
            return $this->_insertPluginCategory($obj);
          break;
        case 'delete_plugin_category' :
            return $this->_deletePluginCategory($obj);
          break;
        case 'update_plugin_category' :
            return $this->_updatePluginCategory($obj);
          break;
        case 'get_plugin_category_list_tpl' :
            $this->_getPluginCategoryList();
            return $this->_getPluginCategoryListTpl($obj);
          break;
        case 'get_plugin_category_info' :
            return $this->_getPluginCategoryInfo($obj);
          break;
        case 'get_plugin_list_tpl' :
            $this->_getPluginCategoryList();
            return $this->_getPluginListTpl($obj);
          break;
        case 'get_plugin_tpl' :
            return $this->_getPluginTpl($obj);
        default :
            $this->_getPluginCategoryList();
            $this->_getList();
            $this->_printListHtml();
          break;
      }
    }

    function _getPluginObject($obj) {
      $plugin = $obj->plugin;

      if(!is_object($this->plugin_classes[$plugin])) {
        $classFile = sprintf("%s%s/%s.class.php",PLUGIN_DIR,$plugin,$plugin);
        if(!file_exists($classFile)) return $this->getOutput('-1',$this->lang->admin->msg_plugin_not_found);
        require_once($classFile);
        $this->addLang(PLUGIN_DIR.$plugin.'/lang/');
        $this->plugin_classes[$plugin] = $pluginObj;
      }
      return $this->plugin_classes[$plugin];
    }

    function _getPluginTpl($obj) {

      if($obj->plugin_srl > 0) {
        $plugin_info = $this->_getPluginInfo($obj);
        $pObj = $this->_getPluginObject($plugin_info);
        $obj->tpl = $pObj->getTpl($plugin_info);
      } else {
        $obj->tpl = "";
      }
      $output->error = 0;
      $output->message = 'success';
      $output->plugin_srl = $obj->plugin_srl;
      $output->tpl = $this->oSmarty->assign_fetch(ADMIN_TPL_DIR."page_manager_plugin_output.include.tpl", $obj);
      if($obj->plugin_srl) {
        $output->tpl = sprintf("<link rel='StyleSheet' HREF='%s%s/theme/%s/plugin.css' type='text/css' />",PLUGIN_DIR,$plugin_info->plugin,$plugin_info->theme).$output->tpl;

        preg_match_all("!<\!--StyleSheet:.*?-->!is", $output->tpl, $match);
        if(count($match[0])) {
          $output->tpl = preg_replace("!<\!--StyleSheet:.*?-->!is", "", $output->tpl);
          for($i=0;$i<count($match[0]);$i++) {
            $tstr = trim($match[0][$i]);
            $css_file = str_replace(array("<!--StyleSheet:","-->"),"",$tstr);
            $output->tpl = sprintf("<link rel='StyleSheet' HREF='%s' type='text/css' />",$css_file).$output->tpl;
          }
        }
      }

      return $output;
    }


    function _getPluginList() {
      $list = zFile::getDirectoryList(PLUGIN_DIR);
      for($_i=0;$_i<count($list);$_i++) {
        unset($plugin);
        $plugin_name = $list[$_i];
        @include(PLUGIN_DIR.$plugin_name.'/require.var.php');
        $this->addLang(PLUGIN_DIR.$plugin_name.'/lang/');
        $plugin->title = $this->lang->plugin->title;
        $this->plugin_list[$plugin_name] = $plugin;
      }
    }

    function _getPluginListTpl($obj) {
        $this->category_srl = $obj->category_srl==='0'||$obj->category_srl?(int)$obj->category_srl:null;
        $this->search_keyword = $obj->search_keyword;
        $this->list_cnt = $obj->list_cnt;
        $this->field_obj_id = $obj->field_obj_id;
        $this->zone_title_id = $obj->zone_title_id;
        $this->zone_list_id = $obj->zone_list_id;
        $this->call_manager = $obj->call_manager;

        $this->_getList($obj->page);

        $output->error = 0;
        $output->message = 'success';
        $output->tpl = $this->oSmarty->assign_fetch(ADMIN_TPL_DIR."plugin_manager_plugin_list.include.tpl", $this);
        return $output;
    }

    function _getList($cur_page = '') {
      $this->category_srl = $this->oDB->addquotes($this->category_srl);
      $this->search_keyword = $this->oDB->addquotes($this->search_keyword);

      if($this->category_srl != null) $cond_list[] = "plugin_category_srl = '{$this->category_srl}'";
      if($this->search_keyword != null) $cond_list[] = "title like '%{$this->search_keyword}%'";

      $total_cnt = $this->oDB->getCount('plugin_manager', $cond_list);

      $this->page_nav = $this->getPageNav($total_cnt, $this->list_cnt, 10, $cur_page);

      $this->oDB->select('*','plugin_manager',$cond_list, 'plugin_srl desc', $this->page_nav->start_cnt, $this->page_nav->list_cnt);
      while($tmp = $this->oDB->fetch()) {
        $plugin_category_srl = $tmp->plugin_category_srl;
        if($plugin_category_srl) $tmp->category_title = $this->category_list[$plugin_category_srl]->category_title;
        else $tmp->category_title = $this->lang->admin->fld_plugin_default_category;
        $tmp->plugin_title = $this->plugin_list[$tmp->plugin]->title;
        $this->list[] = $tmp;
      }
    }

    function _getExtendsInfo($obj) {
      @include PLUGIN_DIR.$obj->plugin.'/require.var.php';
      $this->addLang(PLUGIN_DIR.$obj->plugin.'/lang/');
      $this->extends_var = $plugin;

      $oDB = &zDB::instance();
      $tmp = $oDB->selectList(array('menu_srl','menu_name'),'menu_manager');
      foreach($tmp->list as $_k => $_v) {
        $menu_list[$_v->menu_srl] = $_v->menu_name;
      }

      $this->announce = $this->lang->plugin->announce;
      $image_key_list = array();
      if(count($this->extends_var)) foreach($this->extends_var as $key=>$val) {
        if(in_array($key, array('title','require_depth'))) continue;

        $text_name = $val['text'];
        $trans_lang_val = $this->lang->plugin->$text_name;
        $this->extends_var->{$key}['text'] = $trans_lang_val;
        $this->extends_var->{$key}['value'] = $this->extends_var->{$key}['default'];

        if($val['type'] == 'image') {
          $image_key_list[$key] = $key.'|@|';
        };

        if($val['type'] == 'menu_list') $this->extends_var->{$key}['menu_list'] = $menu_list;
      }

      if($obj->plugin_srl) {
        $obj->plugin_srl = $this->oDB->addquotes($obj->plugin_srl);
        $tmp = $this->oDB->selectOne('*','plugin_manager',"plugin_srl = '{$obj->plugin_srl}'");
        $tmp_val = unserialize(base64_decode($tmp->val));

        foreach($tmp_val as $key => $val) {
          if($this->extends_var->{$key}) {
            $this->extends_var->{$key}['value'] = $val; 

            if($this->extends_var->{$key}['type']=='module' && $val>0) {
              $module_data = $this->oDB->selectOne('*','module_manager',"module_srl='{$val}'");
              $this->extends_var->{$key}['module_title'] = $module_data->title;
            } elseif($this->extends_var->{$key}['type']=='page' && $val>0) {
              $page_data = $this->oDB->selectOne('*','page_manager',"page_srl='{$val}'");
              $this->extends_var->{$key}['page_title'] = $page_data->title;
            } else if($this->extends_var->{$key}['type']=='image') {
              $image_key_list[$key] .= $val;
            } else if($this->extends_var->{$key}['type']=='multi_select' && $val) {
              $tmp_arr = explode("\n",$val);
              foreach($tmp_arr as $_k => $_v) {
                $_tmp = explode('|@|',$_v);    
                unset($_obj);
                $_obj->url = $_tmp[0];
                $_obj->text = $_tmp[1];
                $_tmp_val[] = $_obj;
              }
              $this->extends_var->{$key}['value'] = $_tmp_val;
            }
          }
        }
      }
      $output = $this->getOutput();
      $output->tpl = $this->oSmarty->assign_fetch(COMMON_TPL_DIR."extends_form.include.tpl", $this);

      if(count($this->extends_var)) foreach($this->extends_var as $key => $info) {
        if($info['type']=='richtext') {
          $output->richtext_key = $key;
          $output->richtext_val = $info['value'];
          break;
        }
      }
      $output->image_key_list = implode(',',$image_key_list);

      if(is_dir(PLUGIN_DIR.$obj->plugin.'/theme')) {
        $theme_list = zFile::getDirectoryList(PLUGIN_DIR.$obj->plugin.'/theme');
        $output->theme_list = implode('|@|',$theme_list);
      }
      return $output;
    }

    function _insertPlugins($obj) {
      $plugin_srl = $this->oDB->addquotes($obj->plugin_srl);

      $tmp = explode('|@|',$obj->plugin_title);
      for($i=0;$i<count($tmp);$i++) if($tmp[$i]) $plugin_list[] = trim($tmp[$i]);

      $plugin_info = $this->_getPluginInfo($obj);
      unset($plugin_info->tpl);
      unset($plugin_info->error);
      unset($plugin_info->message);
      $plugin_info->plugin_srl = '';
      $val = unserialize(base64_decode($plugin_info->val));
      foreach($val as $key=>$value) $plugin_info->{$key} = $value;
      unset($plugin_info->val);

      for($i=0;$i<count($plugin_list);$i++) {
        $plugin_info->title = $plugin_list[$i];
        $this->_insertPlugin($plugin_info);
      }

      return $this->getOutput();
    }

    function _insertPlugin($obj) {
      $obj->val = $this->oDB->addquotes(base64_encode(serialize($this->unsetKey($this->columns_plugin_manager, $obj))));
      $obj->regdate = date('YmdHis');

      $obj = $this->delDummy($this->columns_plugin_manager, $obj);
      $obj->plugin_srl = $this->oDB->getNextSequence();

      $output = $this->oDB->insert('plugin_manager',$obj);
      $output->plugin_srl = $obj->plugin_srl;
      return $output;
    }

    function _updatePlugin($obj) {
      $plugin_srl = $this->oDB->addquotes($obj->plugin_srl);
      $obj->val = $this->oDB->addquotes(base64_encode(serialize($this->unsetKey($this->columns_plugin_manager, $obj))));

      $obj = $this->delDummy($this->columns_plugin_manager, $obj);
      $obj->cache_data = '';

      $output = $this->oDB->update('plugin_manager',$obj,"plugin_srl = '{$plugin_srl}'");
      $output->plugin_srl = $plugin_srl;
      return $output;
    }


    function _deletePlugin($obj) {
      $plugin_srl = $this->oDB->addquotes($obj->plugin_srl);

      $tmp = $this->oDB->selectOne('*','plugin_manager',"plugin_srl = '{$plugin_srl}'");

      return $this->oDB->delete('plugin_manager',"plugin_srl = '{$plugin_srl}'");
    }

    function _getPluginInfo($obj) {
      $plugin_srl = $this->oDB->addquotes($obj->plugin_srl);

      $output = $this->oDB->selectOne('*','plugin_manager',"plugin_srl = '{$plugin_srl}'");

      if($this->plugin_list[$output->plugin]) {
        $tmp_output = $this->_getExtendsInfo($output);
        if($tmp_output->error!=0) return $tmp_output;

        $output->tpl = $tmp_output->tpl;
        $output->richtext_key = $tmp_output->richtext_key;
        $output->richtext_val = $tmp_output->richtext_val;
        $output->image_key_list = $tmp_output->image_key_list;
      } else {
        $output->plugin = '';
        $output->tpl = '';
      }

      if($output->plugin && is_dir(PLUGIN_DIR.$output->plugin.'/theme')) {
        $theme_list = zFile::getDirectoryList(PLUGIN_DIR.$output->plugin.'/theme');
        $output->theme_list = implode('|@|',$theme_list);
      } else {
        $output->theme_list = '';
      }

      $output->info = unserialize(base64_decode($output->val));
      $output->error = 0;
      $output->message = 'success';
      return $output;

    }

    function _insertPluginCategory($obj) {
      $category_title = $this->oDB->addquotes($obj->category_title);
      $cnt = $this->oDB->getCount('plugin_category',"category_title = '{$category_title}'");
      if($cnt > 0) return $this->getOutput(-1,$this->lang->admin->msg_plugin_category_title_exists);

      $query_obj->plugin_category_srl = $this->oDB->getNextSequence();
      $query_obj->category_title = $obj->category_title;
      return $this->oDB->insert('plugin_category',$query_obj);
    }

    function _deletePluginCategory($obj) {
      $plugin_category_srl = $this->oDB->addquotes($obj->plugin_category_srl);
      $cnt = $this->oDB->getCount('plugin_manager', "plugin_category_srl = '{$plugin_category_srl}'");
      if($cnt > 0) return $this->getOutput(-1,$this->lang->admin->msg_plugin_can_not_delete_category);

      return $this->oDB->delete('plugin_category', "plugin_category_srl = '{$plugin_category_srl}'");
    }

    function _updatePluginCategory($obj) {
      $category_title = $this->oDB->addquotes($obj->category_title);
      $plugin_category_srl = $this->oDB->addquotes($obj->plugin_category_srl);
      $cond_list = array("category_title = '{$category_title}'","plugin_category_srl != '{$plugin_category_srl}'");
      $cnt = $this->oDB->getCount('plugin_category',$cond_list);
      if($cnt > 0) return $this->getOutput(-1,$this->lang->admin->msg_plugin_category_title_exists);

      $query_obj->category_title = $obj->category_title;
      return $this->oDB->update('plugin_category',$query_obj,"plugin_category_srl = '{$plugin_category_srl}'");
    }

    function _getPluginCategoryList() {
      $this->oDB->select('*','plugin_category',null,'plugin_category_srl');
      while($tmp = $this->oDB->fetch()) {
        $this->category_list[$tmp->plugin_category_srl] = $tmp;
      }
    }

    function _getPluginCategoryListTpl($obj) {
      $output->error  = 0;
      $output->message = 'success';
      $output->tpl = $this->oSmarty->assign_fetch(ADMIN_TPL_DIR."plugin_manager_category_list.include.tpl", $this);

      return $output;
    }

    function _getPluginCategoryInfo($obj) {
      $plugin_category_srl = $this->oDB->addquotes($obj->plugin_category_srl);
      $output = $this->oDB->selectOne('*','plugin_category',"plugin_category_srl = '{$plugin_category_srl}'");
      $output->error = 0;
      $output->message = 'success';

      return $output;
    }

    function uploadFile() {
      $plugin_srl = $this->oDB->addquotes($_REQUEST['plugin_srl']);
      if(!$plugin_srl) exit();
      $tmp = $this->oDB->selectOne('*','plugin_manager',"plugin_srl = '{$plugin_srl}'");
      $tmp_val = unserialize(base64_decode($tmp->val));

      foreach($_FILES as $key => $val) {

        if($_REQUEST['_delete_'.$key] == 'Y' && $tmp_val->{$key}) {
          $tmp_val->{$key} = '';
          zFile::deleteImageFile($tmp_val->{$key});
        }
        if($val['name'] && $val['size']) {
          if($tmp_val->{$key}) zFile::deleteImageFile($tmp_val->{$key});
          $tmp_val->{$key} = zFile::uploadImage($this->member_srl, $val);
        }
      }

      $val = base64_encode(serialize($tmp_val));
      $query_obj->val = $val;
      $this->oDB->update('plugin_manager',$query_obj,"plugin_srl='{$plugin_srl}'");

      return "<script type='text/javascript'>top.location.replace(top.location.href);</script>";
    }


    function _printListHtml() {
      $this->page_nav_tpl = $this->oSmarty->assign_fetch(ADMIN_TPL_DIR."page_nav.include.tpl", $this);
      $this->tpl->content = $this->oSmarty->assign_fetch(ADMIN_TPL_DIR."plugin_manager.tpl", $this);
      $this->_printHtml();
    }

    function _printHtml() {
      parent::_printHtml();
    }

  }
?>
