<?php

  class Admin_Server_Manager extends Admin {

    var $sid = null;

    var $list =  array();

    var $menu_list = array(
          'total_server_list',
          'web_server_list',
          'file_server_list',
        );

    var $columns_server_manager = array(
          'server_srl',
          'server_type',
          'server_name',
          'hostname',
          'port',
          'path',
          'comment',
          'is_default',
          'regdate'
        );

    function Admin_Server_Manager($mid) {
      parent::Admin($mid);
      $this->sid = $_REQUEST['sid']&&in_array($_REQUEST['sid'], $this->menu_list)?$_REQUEST['sid']:'total_server_list';
    }

    function proc($action = '', $obj = '') {

      switch($action) {
        case 'insert' :
            return $this->_insert($obj);
          break;
        case 'get_info' :
            return $this->_getInfo($obj);
          break;
        case 'update' :
            return $this->_update($obj);
          break;
        case 'delete' :
            return $this->_delete($obj);
          break;
        case 'set_default_server' :
            return $this->_setDefaultServer($obj);
          break;
        default :
            $this->_getList();
            $this->_printListHtml();
          break;
      }
    }

    function _insert($obj) {
      $obj->regdate = date('YmdHis');
      if(substr($obj->path,-1)!='/') $obj->path .= '/';
      $obj = $this->delDummy($this->columns_server_manager,$obj);
      $obj->server_srl = $this->oDB->getNextSequence();
      $output = $this->oDB->insert('server_manager',$obj);
      if($output->error!=0) return $output;
      if($obj->is_default == 'Y') {
        $up_obj->is_default = 'N';
        $server_srl = $obj->server_srl;
        $cond_list = array("server_srl!={$server_srl}","server_type='{$obj->server_type}'");
        $this->oDB->update('server_manager',$up_obj,$cond_list);
      }
      return $output;
    }

    function _update($obj) {
      $server_srl = $this->oDB->addquotes($obj->server_srl);
      if(substr($obj->path,-1)!='/') $obj->path .= '/';
      $obj = $this->delDummy($this->columns_server_manager,$obj);
      $output = $this->oDB->update('server_manager',$obj,"server_srl='{$server_srl}'");
      if($output->error!=0) return $output;

      if($obj->server_type == 'web') {
        $host = $obj->hostname;
        $port = $obj->port;
        if($port != 80) $host .= ":{$port}";
        $path = $obj->path;

        $query_obj->web_server_host = sprintf("http://%s%s",$host, $path);
        $this->oDB->update('module_manager',$query_obj,"web_server_srl='{$server_srl}'");
      }

      if($obj->is_default == 'Y') {
        $up_obj->is_default = 'N';
        $cond_list = array("server_srl!={$server_srl}","server_type='{$obj->server_type}'");
        $this->oDB->update('server_manager',$up_obj,$cond_list);
      }

      return $output;
    }

    function _getInfo($obj) {
      $server_srl = $this->oDB->addquotes($obj->server_srl);
      return $this->oDB->selectOne('*','server_manager', "server_srl='{$server_srl}'");
    }

    function _delete($obj) {
      $server_srl = $this->oDB->addquotes($obj->server_srl);

      $cnt = $this->oDB->getCount('module_manager',"web_server_srl = '{$server_srl}' or file_server_srl = '{$server_srl}'");
      if($cnt>0) return $this->getOutput(-1,$this->lang->admin->notice_server_have_some_module);

      $server_info = $this->_getInfo($obj);
      $server_type = $this->oDB->addquotes($server_info->server_type);
      $cnt = $this->oDB->getCount('server_manager',"server_type = '{$server_type}'");
      if($cnt<=1) return $this->getOutput(-1, $this->lang->admin->notice_not_delete_least_one);

      if($server_info->is_default == 'Y') return $this->getOutput(-1,$this->lang->admin->notice_server_no_delete_is_default);

      return $this->oDB->delete('server_manager',"server_srl='{$obj->server_srl}'");
    }

    function _setDefaultServer($obj) {
      $obj->hostname = $_SERVER['SERVER_NAME'];
      $obj->port = $_SERVER['SERVER_PORT'];
      $obj->path = str_replace('server.php','',$_SERVER['SCRIPT_NAME']);

      $obj->server_type = 'web';
      $obj->server_name = 'default web server';
      $this->_insert($obj);

      $obj->server_type = 'file';
      $obj->server_name = 'default file server';
      $this->_insert($obj);

      return $this->getOutput();
    }


    function _getList() {
      switch($this->sid) {
        case 'web_server_list' :
            $this->oDB->select('*','server_manager',"server_type='web'","is_default desc");
          break;
        case 'file_server_list' :
            $this->oDB->select('*','server_manager',"server_type='file'","is_default desc");
          break;
        default :
            $this->oDB->select('*','server_manager',null,"is_default desc");
          break;
      }
      while($tmp = $this->oDB->fetch()) {
        $this->list[$tmp->server_srl] = $tmp; 
      }
    }

    function _printListHtml() {
      $this->tpl->content = $this->oSmarty->assign_fetch(ADMIN_TPL_DIR."server_manager.tpl", $this);
      $this->_printHtml();
    }

    function _printHtml() {
      parent::_printHtml();
    }

  }
?>
