<?php

  class Admin_Site_Manager extends Admin {

    var $site_info = null;
    var $layout_list = null;
    var $menu_list = null;
    var $level_list = null;

    var $columns_site_manager = array(
          'title',
          'keywords',
          'description',
          'email',
          'hidden',
          'layout_srl',
          'access_level',
          'join_level_srl',
          'auto_login_time',
          'auth_type',
          'use_image_nick',
          'use_image_mark',
          'use_profile_image',
          'use_sign',
          'use_exp',
        );

    function Admin_Site_Manager($mid) {
      parent::Admin($mid);
      $this->_getSiteInfo();
    }

    function proc($action = '', $obj = '') {

      switch($action) {
        case 'update' :
            return $this->_update($obj);
          break;
        default :
            $this->_getLevelList();
            $this->_getMenuList();
            $this->_getLayoutList();
            $this->_printHtml();
          break;
      }
    }

    function _update($obj) {
      $query_agreement->type = 'agreement';
      $query_agreement->message = $obj->agreement;

      $query_auth_mail->type = 'auth_mail';
      $query_auth_mail->title = $obj->auth_mail_title;
      $query_auth_mail->message = $obj->auth_mail_message;

      $query_find_passwd->type = 'find_passwd';
      $query_find_passwd->title = $obj->find_passwd_title;
      $query_find_passwd->message = $obj->find_passwd_message;

      $obj = $this->delDummy($this->columns_site_manager, $obj);
      $cnt = $this->oDB->getCount('site_manager');

      if(!$cnt) $output = $this->oDB->insert('site_manager',$obj);
      else $output = $this->oDB->update('site_manager',$obj);
      if($output->error!=0) return $output;

      $this->oDB->delete('site_message');

      $this->oDB->insert('site_message',$query_agreement);
      $this->oDB->insert('site_message',$query_auth_mail);
      $this->oDB->insert('site_message',$query_find_passwd);

      return $this->getOutput();
    }

    function _getLayoutList() {
      $output = $this->oDB->select('*','layout_manager',null,array('layout','layout_srl desc'));
      if($output->error!=0) return $output;

      while($obj = $this->oDB->fetch()) {
        $layout_srl = $obj->layout_srl;
        $title = $obj->title;
        $this->layout_list[$layout_srl] = $title;
      }
    }

    function _getMenuList() {
      $output = $this->oDB->select('*','menu_manager',null,'menu_srl');
      if($output->error!=0) return $output;

      while($obj = $this->oDB->fetch()) {
        $menu_srl = $obj->menu_srl;
        $menu_name = $obj->menu_name;
        $this->menu_list[$menu_srl] = $menu_name;
      }
    }

    function _getLevelList() {
      $output = $this->oDB->select('*','member_level_manager','level=1','level_srl');
      if($output->error!=0) return $output;
      
      while($obj = $this->oDB->fetch()) {
        $level_srl = $obj->level_srl;
        $level_title = $obj->level_title;
        $this->level_list[$level_srl] = $level_title; 
      }
    }

    function _getSiteInfo() {
      $this->site_info = $this->oDB->selectOne('*','site_manager');

      $this->oDB->select('*','site_message');
      while($tmp = $this->oDB->fetch()) {
        $this->site_info->{$tmp->type} = $tmp;
      }
    }

    function _printHtml() {
      $this->tpl->content = $this->oSmarty->assign_fetch(ADMIN_TPL_DIR."site_manager.tpl", $this);
      parent::_printHtml();
    }

  }
?>
