<?php

  class Zeroboard {

    var $oSmarty = null;
    var $oDB = null;

    var $lang_type = 'ko';

    var $tpl = null;
    var $lang = null;
    var $included_lang = array();

    var $css_list = array();
    var $js_list = array();

    var $admin_file = 'admin.php';

    var $cur_url = null;

    var $richtext_form_tpl = 'richtext_form.include.tpl';

    var $file_server = './file_upload.php';

    var $zb5_version = 'zb5 beta 0.0.1';

    function Zeroboard() {
      global $lang;
      $this->lang = &$lang;
      $this->oSmarty = zSmarty::instance();
      $this->oDB = zDB::instance();

      $this->lang_type = $this->getLangType();

      $this->richtext_form_tpl = COMMON_TPL_DIR.$this->richtext_form_tpl;

      $server = $this->oDB->selectOne('*','server_manager',array("server_type='file'","is_default='Y'"));
      $this->file_server = sprintf("http://%s:%s%s%s",$server->hostname,$server->port,$server->path,'file_upload.php');
    }

    function isInstalled() {
      return file_exists(DB_CONFIG_FILE);
    }

    function installProc() {
      header('location:./');
    }

    function addLang($path) {
      global $lang;

      $filename = sprintf("%s%s.lang.php",$path, $this->lang_type);
      if(!file_exists($filename)) $filename = sprintf("%s%s.lang.php",$path, 'ko');
      if(!file_exists($filename)) return;

      if(in_array($filename, $this->included_lang)) return;
      $this->include_lang[] = $filename;

      include($filename);
    }

    function addCssFile($filename) {
      if(eregi("^\.\/",$filename)&&!file_exists($filename)) return;
      if(!in_array($filename, $this->css_list)) $this->css_list[] = $filename;
    }

    function addJsFile($filename) {
      if(eregi("^\.\/",$filename)&&!file_exists($filename)) return;
      if(!in_array($filename, $this->js_list)) $this->js_list[] = $filename;
    }

    function getPageNav($total_cnt, $list_cnt = 20, $page_nav_cnt = 10, $cur_page = '', $t_obj = null) {
      $page_regx = "/page=([0-9]+)/i";
      $cur_url = zUrl::getUrl($t_obj);
      $total_page = (int)( ($total_cnt-1)/$list_cnt )+1;
      if(!$cur_page) {
        preg_match($page_regx,$cur_url, $matches); 
        if(!count($matches)) {
          $cur_page = 1;
          $cur_url .= '&amp;page=1';
        } else $cur_page = $matches[1];
      } else {
        if(!eregi("page={$cur_page}",$cur_url)) $cur_url .= "&amp;page={$cur_page}";
      }

      if($cur_page<1) $cur_page = 1;
      elseif($cur_page>$total_page) $cur_page = $total_page;

      if($cur_page > $total_page - round($page_nav_cnt/2)) {
        $end_page = $total_page;
        $start_page = $end_page - $page_nav_cnt +1;
        if($start_page<1) $start_page = 1;
      } else {
        $start_page = $cur_page - round($page_nav_cnt/2);
        if($start_page<1) $start_page = 1;

        $end_page = $start_page + $page_nav_cnt -1;
        if($end_page>$total_page) $end_page = $total_page;
      }

      if($cur_page>1) {
        $obj->prev_page = preg_replace($page_regx, 'page='.($cur_page-1), $cur_url);
        $obj->prev_page_no = $cur_page-1;
        $obj->first_page = preg_replace($page_regx, 'page=1', $cur_url);
      }

      if($cur_page<$total_page) {
        $obj->next_page = preg_replace($page_regx, 'page='.($cur_page+1), $cur_url);
        $obj->next_page_no = $cur_page+1;
        $obj->last_page = preg_replace($page_regx, 'page='.$total_page, $cur_url);
      }

      for($i=$start_page;$i<=$end_page;$i++) {
        $obj->page_list[$i] = preg_replace($page_regx, 'page='.$i, $cur_url);
        $obj->page_no_list[] = $i;
      }

      $obj->cur_page = $cur_page;

      $obj->start_cnt = ($cur_page-1)*$list_cnt;
      $obj->list_cnt  = $list_cnt;

      $obj->v_no = $total_cnt - ( ($cur_page-1)*$list_cnt);

      $obj->total_page = $total_page;
      $obj->total_cnt = $total_cnt;

      return $obj;
    }

    function getOutput($error=0, $message='success') {
      $obj->error = $error;
      $obj->message = $message;
      return $obj;
    }

    function delDummy($keylist, $obj) {
      foreach($obj as $key => $val) {
        if(!in_array($key, $keylist)) unset($obj->{$key});
      }
      unset($obj->methodcall);
      unset($obj->method_name);
      unset($obj->action);
      return $obj;
    }

    function unsetKey($keylist, $obj) {
      for($i=0;$i<count($keylist);$i++) {
        unset($obj->{$keylist[$i]});
      }
      unset($obj->passwd_1);
      unset($obj->passwd_2);
      unset($obj->methodname);
      unset($obj->method_name);
      unset($obj->action);
      unset($obj->methodcall);
      return $obj;
    }

    function getLangType() {
      if($this->oDB->lang_type) return $this->lang_type;

      if($_COOKIE['zlang']) return $_COOKIE['zlang'];

      $lang_type = array('ko','en','ja');
      for($i=0;$i<count($lang_type);$i++) {
        $lang = $lang_type[$i];
        if(ereg(' '.$lang, $_SERVER['HTTP_USER_AGENT'])>0) return $lang;
      }

      return 'ko';
    }

    function registerUser() {
      $oDB = &zDB::instance();

      $key = $oDB->addquotes($_REQUEST['key']);
      $tmp = $oDB->selectOne('*','member_mail', "`key`='{$key}'");
      if(!$tmp->key) return Zeroboard::getOutput(-1, $this->lang->common->notice_invalid_mail_key);

      $member_srl = $oDB->addquotes($tmp->member_srl);
      $member_info = $oDB->selectOne('*','member_list',"member_srl='{$member_srl}'");
      if($member_info->denied == 'Y') return Zeroboard::getOutput(-1, $this->lang->common->login_fail_denied);

      $query_obj->allowed = 'Y';
      $oDB->update('member_list',$query_obj,"member_srl='{$member_srl}'");

      $oDB->delete('member_mail',"`key`='{$key}'");

      return Zeroboard::getOutput(0, $this->lang->common->notice_success_register_user);
    }

    function changePassword() {
      $oDB = &zDB::instance();

      $key = $oDB->addquotes($_REQUEST['key']);
      $tmp = $oDB->selectOne('*','member_mail', "`key`='{$key}'");
      if(!$tmp->key) return Zeroboard::getOutput(-1, $this->lang->common->notice_invalid_mail_key);

      $member_srl = $oDB->addquotes($tmp->member_srl);
      $member_info = $oDB->selectOne('*','member_list',"member_srl='{$member_srl}'");
      if($member_info->denied == 'Y') return Zeroboard::getOutput(-1, $this->lang->common->login_fail_denied);

      $query_obj->passwd = md5($tmp->new_password);
      $oDB->update('member_list',$query_obj,"member_srl='{$member_srl}'");

      $oDB->delete('member_mail',"`key`='{$key}'");

      return Zeroboard::getOutput(0, $this->lang->common->notice_success_change_passwd);
    }

    function hCutStr($str, $len, $tail='...') {

      if(!$str || !$len) return;

      $unicode_str = iconv("UTF-8","UCS-2",$str);
      if(strlen($unicode_str) < $len*2) return $str;

      $output_str = substr($unicode_str, 0, $len*2);
      $str = iconv("UCS-2","UTF-8",$output_str).$tail;

      return $str;
    }

    function debugPrint($msg) {
      $f = fopen('/tmp/debug','a');
      fwrite($f, "\n========================================================\n");
      fwrite($f, print_r($msg,true));
      fwrite($f, "\n");
      fclose($f);
    }

    function highlight_keyword($source, $keyword) {
      $block_code = '@@@ZB:TAGS@@@';
      preg_match_all("!<[^>]+>!is", $source, $match);
      $blocks = $match[0];
      $source = preg_replace("!<[^>]+>!is", $block_code, $source);

      $keyword_list = explode(' ',$keyword);
      foreach($keyword_list as $k => $v) {
        $key = '!'.preg_quote($v).'!u';
        $source = preg_replace($key, "<span class='search_highlight'>".$v."</span>", $source);
      }

      $_len = strlen($block_code);
      $_pos = 0;

      for ($_i=0, $_count=count($blocks); $_i<$_count; $_i++)
          if (($_pos=strpos($source, $block_code, $_pos))!==false)
              $source = substr_replace($source, $blocks[$_i], $_pos, $_len);
          else break;


      return $source;
    }

  }
?>
