<?php

  class zArticle extends zDocument {

    function &instance($oModule) {
      if(!$GLOBLAS['_zArticle_']) $GLOBLAS['_zArticle_'] = new zArticle($oModule);
      return $GLOBLAS['_zArticle_'];
    }

    function zArticle($oModule) {
      parent::zDocument($oModule);
    }

    function getArticle($article_srl, &$article, &$cur_page) {
      if(!$article_srl || !$this->oModule->view_enable) return null;

      $oDB = &zDB::instance();

      $article_srl = $oDB->addquotes($article_srl);
      $article = $oDB->selectOne('*','articles',"article_srl='{$article_srl}'");
      if(!$article) return;

      $this->workArticle(&$article);

      $cur_page = $this->getCurPage($article);
    }

    function workArticle($article) {
      $this->_checkReadCnt(&$article);
      $this->_getSurveyInfo(&$article);
      $this->_checkGrant(&$article);
      $this->_checkUrl(&$article);
      $this->_checkTag(&$article);
      $this->_checkHighlightKeyword(&$article);

      if($article->member_srl) $this->_addUserInfo(&$article);
      if($article->serial_srl) $this->_addSerialInfo(&$article);
      if($article->file_cnt) $this->_addFileInfo(&$article);

      $article->node_history = $this->oModule->getNodeHistory($article->module_srl);
    }

    function simpleWorkArticle($article) {
      $this->_checkUrl(&$article);
      $this->_checkHighlightKeyword(&$article);
      if($article->member_srl) $this->_addUserInfo(&$article);
      if($article->serial_srl) $this->_addSerialInfo(&$article);

      $article->node_history = $this->oModule->getNodeHistory($article->module_srl);
    }

    function getCurPage($article) {
      if($this->oModule->search_keyword || $this->oModule->cur_page>1) return $this->oModule->cur_page;

      $oDB = &zDB::instance();

      $module_srl = $oDB->addquotes($article->module_srl);
      $article_srl = $oDB->addquotes($article->article_srl);
      $listorder = $oDB->addquotes($article->listorder);

      $list_cnt = $this->oModule->list_cnt;

      if(!$this->oModule->child_module_list) {
        $cond_list[] = "module_srl = '{$module_srl}'";
      } else {
        $child_module_list = implode(',',$this->oModule->child_module_list);
        $cond_list[] = "module_srl in ({$child_module_list})";
      }
      $cond_list[] = "listorder < '{$listorder}'";

      $prev_cnt = $oDB->getCount('articles',$cond_list);

      $cur_page = (int)($prev_cnt / $list_cnt) + 1;

      return $cur_page;
    }

    function setOrderType($order_type = 'listorder') {
      $this->order_type = $order_type == 'modify_order'?'modify_order':'listorder';
    }

    function getArticleList($total_articles, $article_list, $oPageNav, $do_work = false) {
      if(!$this->oModule->view_enable) return null;

      require_class('zSearch');
      $oSearch = new zSearch();
      $oSearch->setSid($this->sid);

      if($this->oModule->serial_srl) $oSearch->setSerialSrl($this->oModule->serial_srl);
      else {
        if($this->oModule->child_module_list) $oSearch->setModuleSrlList($this->oModule->child_module_list);
        else $oSearch->setModuleSrl($this->oModule->module_srl);
      }

      if($this->oModule->tag) $oSearch->setTag($this->oModule->tag);
      elseif($this->oModule->archive) $oSearch->setArchive($this->oModule->archive);
      else $oSearch->setSearchType($this->oModule->search_keyword, $this->oModule->st, $this->oModule->sc, $this->oModule->sw, $this->oModule->sg, $this->oModule->sa);

      $oSearch->setOrderType($this->order_type);
      $output = $oSearch->searchArticle($this->oModule->list_cnt, $this->oModule->page_cnt, $this->oModule->cur_page, $this->sid);

      $total_articles = $output->total_articles;
      $article_list = $output->article_list;
      $oPageNav = $output->oPageNav;

      if(count($article_list)) foreach($article_list as $article_srl => $val) {
        if($do_work) $this->workArticle(&$article_list[$article_srl]);
        else $this->simpleWorkArticle(&$article_list[$article_srl]);
      }

      $this->_getUserInfo();
      $this->_getFileInfo();
      $this->_getSerialInfo();
    }

    function insertArticle($obj) {

      $source_obj = $obj;

      if(!$this->oModule->write_enable) return Zeroboard::getOutput(-1, $this->lang->common->notice_access_denied_title);

      $article_srl = $obj->article_srl;

      if(!$this->is_logged) {
        require_class('zImageNumber');
        $number = zImageNumber::getNumber();
        if($obj->image_number!=$number) return Zeroboard::getOutput(-1,$this->lang->common->notice_member_fo_image_number_is_invalid);
      }

      if($article_srl) {
        $this->getArticle($article_srl, &$article, &$cur_page);
        if(!$article) return;

        if(!$article->modify_enable) return Zeroboard::getOutput(-1, $this->lang->common->notice_access_denied_title);
        if(!$this->member_srl) {
          $check_articles = unserialize($_SESSION['check_articles']);
          if(!is_array($check_articles)) $check_articles = array();
          if(!in_array($article_srl, $check_articles)) return Zeroboard::getOutput(-1, $this->lang->common->notice_access_denied_title);
        }
      }

      $oDB = &zDB::instance();

      if($obj->use_trackback == 'Y' && $obj->trackback_address) {
        $trackback_obj->charset = $obj->charset;
        $trackback_obj->address = $obj->trackback_address;
        $trackback_obj->short_text = $obj->short_text;
      } 

      if($obj->send_to_center == 'Y' && $obj->tag) $send_to_center = true;

      if($obj->file_list) $upload_file_list = explode(',',$obj->file_list);
      else $upload_file_list = null;

      $obj = Zeroboard::delDummy($this->column_article, $obj);

      if(!$this->oModule->is_admin) $obj->is_notice = 'N';
      if($obj->use_serial != 'Y') {
        $obj->use_serial ='N';
        $obj->serial_srl = 0;
      }

      if($this->oModule->upload_enable && count($upload_file_list)) {
        if($this->member_srl) {
          $oPoint = new zPoint($this->oModule->module_srl,$this->member_srl, 'upload', $article_srl);
          $oPoint->add_point();
        }
        $obj->file_cnt = count($upload_file_list);
      } else $obj->file_cnt = 0;

      if($obj->summary && !$obj->summary_div) $obj->summary_div = $this->lang->common->fld_summary_div_default;

      if($obj->tag) $obj->tag = str_replace(' ','', trim($obj->tag));

      if($obj->article_srl) {
        $mode = 'modify';

        if($this->oModule->is_admin) {
          if($obj->is_notice == 'Y') $obj->listorder = -9999999999;
          else $obj->listorder = $obj->article_srl * -1;
        }

        if(!$this->is_logged) $obj->passwd = md5($obj->passwd);
        else {
          if($this->oModule->serial_enable) {
            if($this->article->use_serial == 'Y' && $obj->use_serial == 'N') {
              $this->_removeSerial();
              $obj->use_serial = 'N';
              $obj->serial_srl = $obj->prev_serial_srl = $obj->next_serial_srl = 0;
            } elseif($obj->use_serial == 'Y' && $this->article->serial_srl != $obj->serial_srl) {
              if($this->article->use_serial == 'Y') $this->_removeSerial();
              $serial_obj = $this->_insertSerial(&$obj);
            }
          }
        }
      } else {
        $mode = 'insert';
        $seq = $oDB->getNextSequence();
        $obj->article_srl = $seq;
        $obj->listorder = $obj->modify_order = $seq * -1;
        $obj->regdate = date("YmdHis");

        if($this->is_logged) {
          $obj->writer = $this->member_info->nick_name;
          $obj->user_id = $this->member_info->user_id;
          $obj->passwd = $this->member_info->passwd;
          $obj->member_srl = $this->member_info->member_srl;
          if($this->oModule->survey_enable) {
            $obj->survey = $this->_doInsertSurvey($obj->article_srl, $obj->member_srl, $source_obj);
            if($obj->survey) $obj->use_survey = 'Y';
            else $obj->use_survey = 'N';
          }

          if($this->oModule->serial_enable && $obj->use_serial == 'Y' && $obj->serial_srl) $this->_insertSerial(&$obj);
        } else {
          if(!$obj->writer||!$obj->passwd) return Zeroboard::getOutput(-1, $this->lang->common->notice_access_denied_title);
          $obj->passwd = md5($obj->passwd);
        }

        if($this->oModule->is_admin) {
          if($obj->is_notice == 'Y') $obj->listorder = -9999999999;
          else $obj->listorder = $obj->article_srl * -1;
        }

      }

      $obj->module_srl = $this->oModule->module_srl;
      $obj->ipaddress = $_SERVER['REMOTE_ADDR'];

      if($mode=='modify') $output = $oDB->update('articles',$obj,"article_srl = '{$obj->article_srl}'");
      else {
        $output = $oDB->insert('articles',$obj);
        if(!$this->is_logged) {
          $check_articles = unserialize($_SESSION['check_articles']);
          if(!is_array($check_articles)) $check_articles = array();
          $check_articles[] = $obj->article_srl;
          $_SESSION['check_articles'] = serialize($check_articles);
        }
      }

      $output->article_srl = $obj->article_srl;
      $output->sid = $this->sid;
      $output->mode = $mode;

      if($this->oModule->upload_enable && count($upload_file_list)) {
        $tmp_file_list = "'".implode("','",$upload_file_list)."'";
        $file_query_obj->article_srl = $obj->article_srl;
        $file_query_obj->is_used = 'Y';
        $member_srl = $oDB->addquotes($this->member_srl);
        $oDB->update('file',$file_query_obj,array("member_srl='{$member_srl}'","filename in ({$tmp_file_list})"));
      }

      if($trackback_obj) {
        require_class('zTrackBack');
        $oTrackBack = zTrackBack::instance($this->oModule);
        $oTrackBack->sendTrackBack($trackback_obj, $obj);
      }

      if($mode == 'insert' && $obj->member_srl) {
        $oPoint = new zPoint($this->oModule->module_srl,$obj->member_srl, 'write_article', $obj->article_srl);
        $oPoint->add_point();
      }

      $node_srl = $oDB->addquotes($this->oModule->module_info->node_srl);

      zMenu::updateNode($this->oModule->module_srl);

      if($this->member_srl) {
        $member_srl = $oDB->addquotes($this->member_srl);
        $oDB->delete('serial',array("member_srl='{$member_srl}'","article_cnt<1"));
      }

      if($mode == 'insert' && $obj->tag) {
        $tag = explode(',',$obj->tag);
        $tag_obj->article_srl = $obj->article_srl;
        $tag_obj->module_srl = $obj->module_srl;
        for($i=0;$i<count($tag);$i++) {
          if(!$tag[$i]) continue;
          $tag_obj->tag = $tag[$i];
          $oDB->insert('tag',$tag_obj);
        }
      }

      if($mode == 'modify' && $this->article->tag != $obj->tag) {
        $article_srl = $oDB->addquotes($obj->article_srl);
        $oDB->delete('tag',"article_srl='{$article_srl}'");
        $tag = explode(',',$obj->tag);
        $tag_obj->article_srl = $obj->article_srl;
        $tag_obj->module_srl = $obj->module_srl;
        for($i=0;$i<count($tag);$i++) {
          if(!$tag[$i]) continue;
          $tag_obj->tag = $tag[$i];
          $oDB->insert('tag',$tag_obj);
        }
      }

      if($send_to_center) zDocument::sendToCenter($mode, $obj);

      return $output;
    }

    function deleteArticle($article_srl) {
      $this->getArticle($article_srl, &$article, &$cur_page);
      if(!$article->delete_enable) return Zeroboard::getOutput(-1, $this->lang->common->notice_access_denied_title);

      if(!$this->member_srl) {
        $check_articles = unserialize($_SESSION['check_articles']);
        if(!is_array($check_articles)) $check_articles = array();
        if(!in_array($article_srl, $check_articles)) return Zeroboard::getOutput(-1, $this->lang->common->notice_access_denied_title);
      }

      $oDB = &zDB::instance();
      $article_srl = $oDB->addquotes($article->article_srl);
      $cond_list = array("article_srl='{$article_srl}'");

      $oDB->delete('articles',$cond_list);
      $oDB->delete('comment',$cond_list);
      $oDB->delete('trackback',$cond_list);
      $oDB->delete('survey',$cond_list);
      $oDB->delete('survey_item',$cond_list);
      $oDB->delete('survey_log',$cond_list);
      $oDB->delete('report_log',$cond_list);
      $oDB->delete('tag',$cond_list);

      zMenu::updateNode($this->oModule->module_srl);

      $this->_removeSerial($article);

      if($article->member_srl) {
        $oPoint = new zPoint($this->oModule->module_srl,$article->member_srl, 'write_article', $article->article_srl);
        $oPoint->remove_point();
      }

      return Zeroboard::getOutput();
    }

    function vote($obj) {
      if(!$this->oModule->vote_enable) return;

      $oDB = &zDB::instance();
      $article_srl = $oDB->addquotes($obj->article_srl);
      $this->getArticle($article_srl, &$article, &$cur_page);

      if($article->member_srl == $this->member_srl) return Zeroboard::getOutput(-1,$this->lang->common->notice_disable_yout_vote);

      $output = Zeroboard::getOutput(0,'success');

      $vote_log = unserialize($_SESSION['vote_log']);
      if(!$vote_log) $vote_log = array();

      if(!in_array($article_srl, $vote_log)) {
        $vote_log[] = $article_srl;
        $_SESSION['vote_log'] = serialize($vote_log);
        $t_output = $oDB->updatePlus('articles','voted_cnt',"article_srl='{$article_srl}'");
        if($t_output->error!=0) $output = $t_output;
        else {
          $output->msg = $this->lang->common->notice_success_voted;

          if($this->member_srl && $article->member_srl != $this->member_srl) {

            $oPoint = new zPoint($this->oModule->module_srl,$this->member_srl, 'do_vote', $article->article_srl);
            $oPoint->add_point();

            if($article->member_srl) {
              unset($oPoint);
              $oPoint = new zPoint($this->oModule->module_srl,$article->member_srl, 'voted', $article->article_srl);
              $oPoint->add_point();
            }
          }
        }
      } else {
        $output->msg = $this->lang->common->notice_already_voted;
      }

      return $output;
    }

    function report($obj) {
      if(!$this->is_logged) return Zeroboard::getOutput(-1,$this->lang->common->notice_must_be_login);

      $oDB = &zDB::instance();

      if(!$this->oModule->manager_enable) {
        $article_srl = $oDB->addquotes($obj->article_srl);
        $comment_srl = $oDB->addquotes($obj->comment_srl);
        $member_srl = $oDB->addquotes($this->member_srl);
        $cond_list = array("article_srl='{$article_srl}'");
        if($obj->comment_srl) $cond_list[] = "comment_srl='{$comment_srl}'";
        $cond_list[] = "member_srl='{$member_srl}'";
        $cnt = $oDB->getCount('report_log',$cond_list);
        if($cnt) return Zeroboard::getOutput(-1,$this->lang->common->notice_report_done);

        $query_obj->article_srl = $obj->article_srl;
        $query_obj->comment_srl = $obj->comment_srl;
        $query_obj->member_srl = $this->member_srl;
        $query_obj->target_module_srl = $obj->target_module_srl;
        $query_obj->regdate = date("YmdHis");
        $query_obj->listorder = $oDB->getNextSequence()*-1;
        $oDB->insert('report_log',$query_obj);

        $output = Zeroboard::getOutput(0,$this->lang->common->msg_reported);
        $output->mode = '';
        $output->article_srl = $obj->article_srl;
        $output->target = $obj->target;
        return $output;

      } else {

        switch($obj->type) {
          case 'delete' :
              if($obj->target == 'article') $this->deleteArticle($obj->article_srl);
              elseif($obj->target == 'comment') {
                require_class('zComment');
                $oComment = new zComment($this->oModule);
                $oComment->deleteComment($obj);
              }

              $message = $this->lang->common->msg_deleted;
            break;
          case 'move' :
              if($obj->target == 'article') {
                $this->article_srl = $obj->article_srl;
                $this->comment_srl = $obj->comment_srl;

                $query_obj->module_srl = $obj->target_module_srl;
                $article_srl = $oDB->addquotes($obj->article_srl);
                $oDB->update('articles',$query_obj,"article_srl='{$article_srl}'");
                $oDB->update('comment',$query_obj,"article_srl='{$article_srl}'");
                $oDB->update('tag',$query_obj,"article_srl='{$article_srl}'");
                $oDB->delete('report_log',array("article_srl='{$article_srl}'","comment_srl=0"));

                zMenu::updateNode($this->oModule->module_srl);
                zMenu::updateNode($obj->target_module_srl);
              }

              $message = $this->lang->common->msg_moved;
            break;
        }
        $output = Zeroboard::getOutput(0,$message);
        $output->mode = 'refresh';
        $output->target = $obj->target;
        $output->module_srl = $this->module_srl;
        $output->article_srl = $obj->article_srl;
        return $output;
      }
    }

    function getXmlDocument() {
      if(!$this->oModule->access_enable) return Zeroboard::getOutput(1,'can not access');

      $oSvc = &zSvc::instance();
      $site_info = $oSvc->getSiteInfo();

      $this->cur_page = $_REQUEST['page']?$_REQUEST['page']:1;
      $this->getArticleList(&$total_article, &$article_list, &$oPageNav, false);

      $output->title = $site_info->title;
      $output->link = zUrl::getXmlUrl($this->sid);
      $output->description = $site_info->description;
      $output->language = $lang_type; 
      $output->date = gmdate("D, d M Y H:i:s");

      if(count($article_list)) {
        foreach($article_list as $article_srl => $data) {
          $year = substr($data->regdate,0,4);
          $month = substr($data->regdate,4,2);
          $day = substr($data->regdate,6,2);
          $hour = substr($data->regdate,8,2);
          $min = substr($data->regdate,10,2);
          $sec = substr($data->regdate,12,2);
          $time = mktime($hour,$min,$sec,$month,$day,$year);

          $tmp->title = $data->title;
          $tmp->author = $data->writer;
          $tmp->link = zUrl::getSourceUrl($data->article_srl);
          $tmp->description = $data->article;
          $tmp->date = gmdate("D, d M Y H:i:s", $time);

          $output->list[] = $tmp;
        }
      }

      return $output;
    }

    function uploadFile() {
      $seq = $_POST['_seq'];
      if(!$seq) return;

      if(!$this->oModule->upload_enable || !$this->member_srl) return;

      $max_upload_size = $this->oModule->max_upload_size * 1024*1024;
      $oDB = &zDB::instance();
      $seq = $oDB->addquotes($seq);
      $tmp = $oDB->selectOne('sum(size) as size','file',"article_srl='{$seq}'");
      $total_size = (int)$tmp->size;

      $size = $_FILES['_upload_file']['size'];

      if(!$this->oModule->manager_enable && $total_size + $size >  $max_upload_size) {
        return "<script type='text/javascript'>top.svc_file_message(\"{$this->lang->common->alert_file_size_over}\\n\\n{$this->lang->common->alert_file_max_size} : {$this->max_upload_size}MB\");</script>";
      }

      $obj = zFile::uploadFile($this->member_srl, $_FILES['_upload_file'],$this->oModule->module_info->image_width);
      if($obj ->error!=0) {
        return "<script type='text/javascript'>top.svc_file_message(\"{$this->lang->common->alert_file_upload_error}\");</script>";
      }
      
      unset($obj->error);
      unset($obj->message);
      $obj->file_srl = $oDB->getNextSequence();
      $obj->article_srl = $seq;
      $obj->member_srl = $this->member_srl;
      $obj->listorder = $obj->file_srl * -1;
      $obj->server_srl = $this->oModule->module_info->file_server_srl;
      $obj->is_used = 'N';
      $oDB->insert('file',$obj);

      $str = sprintf("%s (%s)",$obj->s_filename, zFile::filesize($obj->size));
      $val = $obj->filename;

      return "<script type='text/javascript'>top.svc_file_upload_finish(\"{$str}\",\"{$val}\");</script>";
    }

    function _checkReadCnt($article) {

      if($article->member_srl && $this->member_srl==$article->member_srl) return;

      $article_srl = $article->article_srl;

      $hit_log = unserialize($_SESSION['hit_log']);
      if(!$hit_log) $hit_log = array();
      if(in_array($article_srl, $hit_log)) return;

      $hit_log[] = $article_srl;
      $_SESSION['hit_log'] = serialize($hit_log);

      $oDB = &zDB::instance();
      $article_srl = $oDB->addquotes($article_srl);
      $oDB->updatePlus('articles','readed_cnt',"article_srl='{$article_srl}'");

      if($article->serial_srl) {
        $serial_srl = $oDB->addquotes($article->serial_srl);
        $oDB->updatePlus('serial','readed_cnt',"serial_srl='{$serial_srl}'");
      }

      $article->read_cnt ++;
    }

    function _getSurveyInfo($article) {
      if($article->use_survey != 'Y' || !$article->survey) {
        $article->use_survey = 'N';
        $article->survey = null;
        $article->survey_enable = false;
        return;
      }

      $article->survey = unserialize(base64_decode($article->survey));
      foreach($article->survey as $key => $survey) {
        if(!$survey->content) {
          unset($article->survey[$key]);
          continue;
        }
        $cnt = $survey->cnt;
        if(!$cnt) $cnt= 1;
        if(!count($survey->item)) continue;
        foreach($survey->item as $k => $item) {
          $per = (int)(($item->cnt / $cnt)*100);
          $article->survey[$key]->item[$k]->per = $per;
        }
      }

      if(!$this->member_srl || $article->member_srl==$this->member_srl) {
        $article->survey_enable = false;
        return;
      }

      $oDB = &zDB::instance();
      $article_srl = $oDB->addquotes($article->article_srl);
      $member_srl = $oDB->addquotes($this->member_srl);

      $cond_list = array("article_srl='{$article_srl}'","member_srl='{$member_srl}'");
      $cnt = $oDB->getCount('survey_log',$cond_list);
      if($cnt>0) $article->survey_enable = false;
      else $article->survey_enable = true;
      
    }

    function _checkGrant($article) {
      $article->delete_enable = $this->_checkDeleteEnable($article);
      $article->modify_enable = $this->_checkModifyEnable($article);
      $article->report_enable = $this->_checkReportEnable($article);
      $article->vote_enable = $this->_checkVoteEnable($article);
    }

    function _checkUrl($article) {
      if($this->oModule->view_enable) $article->url = zUrl::getViewUrl($article->article_srl, $this->sid, $this->serial_srl, $this->cur_page);
      else $article->url = '#';
      $article->trackback_url = zUrl::getTrackbackUrl($article->article_srl);
      $article->source_url = zUrl::getSourceUrl($article->article_srl);
      $article->list_url = zUrl::getListUrl($this->sid, $this->serial_srl, $this->cur_page);
      $article->send_message_url = $article->member_srl?zUrl::getSendMessageUrl($article->member_srl):null;
      $article->view_info_url = $article->member_srl?zUrl::getMemberInfoUrl($article->member_srl, $this->serial_srl, $article_srl):null;
      $article->modify_url = $article->modify_enable?zUrl::getModifyUrl($article->article_srl, $this->sid, $this->serial_srl, $this->cur_page):null;
      $article->delete_url = $article->delete_enable?zUrl::getDeleteUrl($article->article_srl, $this->sid, $this->serial_srl, $this->cur_page):null;
      $article->vote_url = $this->oMember->vote_enable?zUrl::getVoteUrl($article->module_srl, $article->article_srl):null;
      $article->serial_url = $article->serial_srl?zUrl::getSerialUrl($article->serial_srl, null, $this->sid):null;
    }

    function _checkTag($article) {
      if(!$article->tag) return;
      $tag_list = explode(',',$article->tag);
      if(!count($tag_list)) return;

      for($i=0;$i<count($tag_list);$i++) {
        unset($tmp_obj);

        $tmp_obj->tag = trim($tag_list[$i]);
        if(!$tmp_obj->tag) continue;
        $tmp_obj->url = zUrl::getTagUrl($tmp_obj->tag, $this->oModule->sid);

        $tag_obj[] = $tmp_obj;
      }

      $article->tag_list = $tag_obj;
    }

    function _checkHighlightKeyword($article) {
      if(!$this->oModule->search_keyword) return;
      if($this->oModule->st == 'Y') $article->title = Zeroboard::highlight_keyword($article->title, $this->oModule->search_keyword);
      if($this->oModule->sc == 'Y') $article->article = Zeroboard::highlight_keyword($article->article, $this->oModule->search_keyword);
    }

    function _insertSerial(&$article) {
      $oDB = &zDB::instance();

      $serial_srl = $oDB->addquotes($article->serial_srl);
      $serial = $oDB->selectOne('*','serial',"serial_srl='{$serial_srl}'");

      if($serial->serial_srl == $article->serial_srl && $serial->member_srl == $this->member_srl) {
        if(!$serial->first_article_srl) {
          $query_obj->last_article_srl = $query_obj->first_article_srl = $article->article_srl;
          $article->prev_serial_srl = 0;
        } else {
          $article->prev_serial_srl = $serial->last_article_srl;
          $query_obj->last_article_srl = $article->article_srl;

          $prev_serial_srl = $oDB->addquotes($article->prev_serial_srl);
          $prev_serial_obj->next_serial_srl = $article->article_srl;
          $oDB->update('articles',$prev_serial_obj,"article_srl='{$prev_serial_srl}'");
        }
        
        $query_obj->article_cnt = $serial->article_cnt+1;
        $oDB->update('serial',$query_obj,"serial_srl='{$serial_srl}'");
      } else {
        $article->use_serial = 'N';
        $article->prev_serial_srl = $article->next_serial_srl = $article->serial_srl = 0;
      }
    }

    function getOwnSerialList() {
      if(!$this->member_srl) return;

      $oDB = &zDB::instance();
      $member_srl = $oDB->addquotes($this->member_srl);
      $_list = $oDB->selectList(array('serial_srl','title'),'serial',"member_srl='{$member_srl}'");
      return $_list->list;
    }

    function _removeSerial($article) {
      $oDB = &zDB::instance();
      $serial_srl = $oDB->addquotes($article->serial_srl);
      if(!$serial_srl) return;

      $serial = $oDB->selectOne('*','serial',"serial_srl='{$serial_srl}'");

      $first_article_srl = $oDB->addquotes($serial_srl->first_article_srl);
      $last_article_srl = $oDB->addquotes($serial_srl->last_article_srl);

      $prev_serial_srl = $oDB->addquotes($article->prev_serial_srl);
      $next_serial_srl = $oDB->addquotes($article->next_serial_srl);

      if($prev_serial_srl) {
        $prev_serial_obj->next_serial_srl = $next_serial_srl;
        $oDB->update('articles',$prev_serial_obj,"article_srl = '{$prev_serial_srl}'");
      } else {
        $query_obj->first_article_srl = $next_serial_srl;   
      }

      if($next_serial_srl) {
        $next_serial_obj->prev_serial_srl = $prev_serial_srl;
        $oDB->update('articles',$next_serial_obj,"article_srl = '{$next_serial_srl}'");
      } else {
        $query_obj->last_article_srl = $prev_serial_srl;
      }

      $query_obj->article_cnt = $serial->article_cnt -1;
      $oDB->update('serial',$query_obj,"serial_srl='{$serial_srl}'");
    }

    function _doInsertSurvey($article_srl, $member_srl, $obj) {
      if(!$obj->survey_content_1) return;
      foreach($obj as $key => $val) {
        if(!eregi("^survey_",$key)||!$val) continue;

        $tmp = explode('_',eregi_replace("^survey_","",$key));

        $seq = $tmp[1];
        if($tmp[0]=='content') $survey_obj[$seq]->content = $val;
        elseif($tmp[0]=='checkcnt') $survey_obj[$seq]->checkcnt = $val;
        elseif($tmp[0]=='item') {
          $t_obj->item = $val;
          $t_obj->cnt = 0;
          $survey_obj[$seq]->item[] = $t_obj;
        }
      }
 
      if(!count($survey_obj)) return;

      $oDB = &zDB::instance();

      foreach($survey_obj as $key => $val) {
        unset($query_obj);

        $seq = $oDB->getNextSequence();

        $survey_obj[$key]->survey_srl = $seq;
        $survey_query_obj->survey_srl = $seq;
        $survey_query_obj->article_srl = $article_srl;
        $survey_query_obj->content = $val->content;
        $survey_query_obj->checkcnt = $val->checkcnt;
        $survey_query_obj->member_srl = $member_srl;
        $survey_query_obj->regdate = date("YmdHis");
        $survey_query_obj->cnt = 0;
        $oDB->insert('survey', $survey_query_obj);

        for($i=0;$i<count($val->item);$i++) {
          unset($item_query_obj);
          $survey_obj[$key]->item[$i]->listorder = $i;
          $item_query_obj->article_srl = $article_srl;
          $item_query_obj->survey_srl = $seq;
          $item_query_obj->listorder = $i;
          $item_query_obj->item = $val->item[$i]->item;
          $item_query_obj->cnt = $val->item[$i]->cnt;
          $oDB->insert('survey_item', $item_query_obj);
        }
      }

      return base64_encode(serialize($survey_obj));
    }


  }

?>
