<?php
  
  class zComment extends zDocument {

    function &instance($oModule) {
      if(!$GLOBLAS['_zComment_']) $GLOBLAS['_zComment_'] = new zComment($oModule);
      return $GLOBLAS['_zComment_'];
    }

    function zComment($oModule) {
      parent::zDocument($oModule);
    }

    function getComment($comment_srl) {
      if(!$this->oModule->view_enable || !$comment_srl) return;

      $oDB = &zDB::instance();

      $comment_srl = $oDB->addquotes($comment_srl);
      $comment = $oDB->selectOne('*','comment',"comment_srl='{$comment_srl}'");
      if(!$comment) return;

      $comment->delete_enable = $this->_checkDeleteEnable($comment);
      $comment->report_enable = $this->_checkReportEnable($comment);

      return $comment;
    }

    function insertComment($obj) {
      $article_srl = $obj->article_srl;
      if(!$article_srl || !$this->oModule->comment_enable) return Zeroboard::getOutput(-1, $this->lang->common->notice_access_denied_title);;

      $oDB = &zDB::instance();
      $article_srl = $oDB->addquotes($article_srl);
      $tmp_article = $oDB->selectOne('allow_comment','articles',"article_srl='{$article_srl}'");
      if(!$tmp_article || $tmp_article->allow_comment != 'Y') return Zeroboard::getOutput(-1, $this->lang->common->notice_access_denied_title);
      if(!$this->is_logged) {
        require_class('zImageNumber');
        $number = zImageNumber::getNumber();
        if($obj->image_number!=$number) return Zeroboard::getOutput(-1,$this->lang->common->notice_member_fo_image_number_is_invalid);
      }

      $obj = Zeroboard::delDummy($this->column_comment, $obj);
      $seq = $oDB->getNextSequence();

      $obj->comment_srl = $obj->listorder = $seq;
      $obj->modify_order = $seq * -1;
      $obj->regdate = date("YmdHis");
      if($this->is_logged) {
        $obj->writer = $this->member_info->nick_name;
        $obj->user_id = $this->member_info->user_id;
        $obj->passwd = $this->member_info->passwd;
        $obj->member_srl = $this->member_info->member_srl;
      } else {
        $obj->passwd = md5($obj->passwd);
      }
      $obj->module_srl = $this->oModule->module_srl;
      $obj->ipaddress = $_SERVER['REMOTE_ADDR'];

      $output = $oDB->insert('comment',$obj);
      if($output->error!=0) return $output;

      $output->article_srl = $obj->article_srl;
      $output->module_srl = $obj->module_srl;
      $output->sid = $this->oModule->sid;

      $article_query_obj->comment_cnt = $oDB->getCount('comment',"article_srl='{$article_srl}'");
      $article_query_obj->modify_order = $seq*-1;
      $tmp_output = $oDB->update('articles',$article_query_obj,"article_srl='{$article_srl}'");
      if($tmp_output->error!=0) {
        $oDB->delete('comment',"comment_srl='{$obj->comment_srl}'");
        return $tmp_output;
      }

      if(!$this->member_srl) {
        $check_comments = unserialize($_SESSION['check_comments']);
        if(!is_array($check_comments)) $check_comments = array();
        $check_comments[] = $obj->comment_srl;
        $_SESSION['check_comments'] = serialize($check_comments);
      }

      if($this->member_srl && $article->member_srl != $this->member_srl) {
        $oPoint = new zPoint($this->oModule->module_srl,$this->member_srl, 'write_comment', $obj->comment_srl);
        $oPoint->add_point();
      }

      if($article->member_srl && $this->member_srl != $article->member_srl) {
        unset($oPoint);
        $oPoint = new zPoint($this->oModule->module_srl,$this->article->member_srl, 'get_comment', $obj->comment_srl);
        $oPoint->add_point();
      }

      if($article->use_reply_message == 'Y' && $article->member_srl && $article->member_srl != $this->member_srl) {
        $comment_obj->target_srl = $article->member_srl;
        $comment_obj->member_srl = $this->member_srl;
        $comment_obj->title = '[re] '.$article->title;
        $comment_obj->article = $obj->article;
        $comment_obj->article_srl = $article->article_srl;
        $oMember = &zMember::instance();
        $oMember->_sendMessage($comment_obj);
      }

      return $output;
    }

    function deleteComment($obj) {
      $comment = $this->getComment($obj->comment_srl);

      if(!$comment->delete_enable || !$comment->comment_srl) return Zeroboard::getOutput(-1,$this->lang->common->notice_access_denied_title);

      if(!$this->member_srl) {
        $check_comments = unserialize($_SESSION['check_comments']);
        if(!is_array($check_comments)) $check_comments = array();
        if(!in_array($comment->comment_srl, $check_comments)) return Zeroboard::getOutput(-1, $this->lang->common->notice_access_denied_title);
      }

      $oDB = &zDB::instance();

      $comment_srl = $oDB->addquotes($comment->comment_srl);
      $article_srl = $oDB->addquotes($comment->article_srl);

      $article = $oDB->selectOne('*','articles',"article_srl='{$article_srl}'");

      $cnt = $oDB->getCount('comment',"parent_srl='{$comment_srl}'");

      if($cnt) {
        if(!$this->oModule->manager_enable) {
          return Zeroboard::getOutput(-1, $this->lang->common->notice_child_comment_exists);
        } else {
          $new_parent_srl = $comment->parent_srl;
          $query_obj->parent_srl = $new_parent_srl;
          $oDB->update('comment',$query_obj, array("article_srl='{$article_srl}'","parent_srl='{$comment_srl}'") );
        }
      }

      $oDB->delete('comment',"comment_srl = '{$comment_srl}'");
      $oDB->updateMinus('articles', 'comment_cnt', "article_srl='{$article_srl}'");
      $oDB->delete('report_log',array("article_srl='{$article_srl}'","comment_srl='{$comment_srl}'"));

      if($comment->member_srl && $article->member_srl != $comment->member_srl) {
        $oPoint = new zPoint($this->oModule->module_srl,$comment->member_srl, 'write_comment', $comment->comment_srl);
        $oPoint->remove_point();

        if($article->member_srl) {
          unset($oPoint);
          $oPoint = new zPoint($this->oModule->module_srl,$article->member_srl, 'get_comment', $article->article_srl);
          $oPoint->remove_point();
        }
      }

      return Zeroboard::getOutput();
    }

    function getCommentList($obj, $comment_list) {
      if(!$obj->article_srl) return;

      if(!$this->oModule->access_enable) return Zeroboard::getOutput(-1, $this->lang->common->notice_access_denied_title);

      $oDB = &zDB::instance();

      $article_srl = $oDB->addquotes($obj->article_srl);

      $cond_list = array("article_srl = '{$article_srl}'");
      $oDB->select('*','comment',$cond_list,'listorder');

      $root = null;
      while($tmp = $oDB->fetch()) {
        $tmp->delete_enable = $this->_checkDeleteEnable($tmp);
        $tmp->delete_url = zUrl::getDeleteCommentUrl($this->sid,$tmp->article_srl,$tmp->comment_srl,$this->serial_srl,$this->cur_page);
        if(!$tmp->delete_enable) $tmp->report_enable = $this->_checkReportEnable($tmp);
        if($tmp->member_srl) {
          $tmp->send_message_url = zUrl::getSendMessageUrl($tmp->member_srl);
          $tmp->view_info_url = zUrl::getMemberInfoUrl($tmp->member_srl, $this->oModule->serial_url, $article_srl);
        }
        $list[$tmp->comment_srl] = $tmp;

        if($tmp->parent_srl) $list[$tmp->parent_srl]->child[] = &$list[$tmp->comment_srl];
        else $root->child[] = &$list[$tmp->comment_srl];
      }

      $this->_arrangeComment(&$comment_list, $root->child,0);
    }

    function _arrangeComment($comment_list, $list, $depth) {
      if(!count($list)) return;
      foreach($list as $key => $val) {
        if($val->child) {
          $tmp = $val;
          $tmp->depth = $depth;
          unset($tmp->child);
          $comment_list[$tmp->comment_srl] = $tmp;
          $this->_addUserInfo(&$comment_list[$tmp->comment_srl]);
          $this->_arrangeComment(&$comment_list,$val->child, $depth+1);
        }
        else {
          $val->depth = $depth;
          $comment_list[$val->comment_srl] = $val;
          $this->_addUserInfo(&$comment_list[$val->comment_srl]);
        }
      }
      $this->_getUserInfo();
    }

  }

?>
