<?php

  class zDB {

    var $db_hostname = null;
    var $db_userid = null;
    var $db_password = null;
    var $db_database = null;
    var $zb_prefix = 'zb_';
    var $lang_type = '';

    var $connect = null;

    var $result = null;

    var $_query;

    var $_debug = true;
    var $total_e_time = 0;
    var $query_log = array();

    function &instance($new_connection = false, $hostname = '', $userid = '', $password = '', $database = '',$zb_prefix='') {
      if($new_connection) return new zDB($hostname, $userid, $password, $database, $zb_prefix, $new_connection);

      if(!$GLOBALS['_zDB_']) $GLOBALS['_zDB_'] = new zDB($hostname, $userid, $password, $database, $zb_prefix);

      return $GLOBALS['_zDB_'];
    }

    function zDB($hostname = '', $userid = '', $password = '', $database = '',$zb_prefix='', $new_connection = false) {
      $this->setInfo($hostname,$userid,$password,$database,$zb_prefix);
      $this->connectDatabase($new_connection);
    }

    function setInfo($hostname = '', $userid = '', $password = '', $database = '', $prefix = '') {
      $this->db_hostname = $hostname?$hostname:'';
      $this->db_userid = $userid?$userid:'';
      $this->db_password = $password?$password:'';
      $this->db_database = $database?$database:'';
      $this->zb_prefix = $prefix?$prefix:'zb_';
    }

    function loadDBConfig() {
      if(!file_exists(DB_CONFIG_FILE)) return false;
      $buff = file(DB_CONFIG_FILE);
      $tmp_buff = explode("\n",base64_decode(trim($buff[1])));

      $this->db_hostname = base64_decode($tmp_buff[0]);
      $this->db_userid = base64_decode($tmp_buff[1]);
      $this->db_password = base64_decode($tmp_buff[2]);
      $this->db_database = base64_decode($tmp_buff[3]);
      $this->zb_prefix = base64_decode($tmp_buff[4]);
      $this->lang_type = base64_decode($tmp_buff[5]);
      return true;
    }

    function saveDBConfig($hostname, $userid, $password, $database, $prefix, $lang_type) {
      $config = 
        "<?php/*\n".
        base64_encode(
          base64_encode($hostname)."\n".
          base64_encode($userid)."\n".
          base64_encode($password)."\n".
          base64_encode($database)."\n".
          base64_encode($prefix)."\n".
          base64_encode($lang_type)."\n"
        ).
        "\n*/?>";
      zFile::writeFile(DB_CONFIG_FILE, $config);
    }
    
    function connectDatabase($new_connection = false) {
      if($this->loadDBConfig()) return $this->connect($new_connection);
    }

    function connect($new_connection = false) {
      if(!$this->connect || $new_connection == true) {
        $this->connect = @mysql_connect($this->db_hostname, $this->db_userid, $this->db_password, true);
        if(mysql_error()) return $this->error(); 

        @mysql_select_db($this->db_database, $this->connect);
        if(mysql_error()) return $this->error(); 
      }

      unset($this->db_hostname);
      unset($this->db_userid);
      unset($this->db_password);
      unset($this->db_database);

      return $this->success();
    }

    function disconnect() {
      @mysql_close($this->connect);
    }

    function checkTableExists($table_name) {
      if(!$this->connect) return;

      $table_name = $this->addquotes($this->zb_prefix.$table_name);
      $query = "show tables like '{$table_name}'";
      $this->query($query);
      $tmp = $this->fetch_array();
      if(!$tmp[0]) return false;
      return true;
    }

    function _getFields($fields_list) {
      if(is_array($fields_list)) {
        for($i=0;$i<count($fields_list);$i++) {
          if(strpos($fields_list[$i],"as")) {
            $tmp = explode("as",$fields_list[$i]);
            if(!eregi("\.",$tmp[0])&&!eregi("\(",$tmp[0])) $tmp[0] = "`".trim($tmp[0])."`";
            $fields_list[$i] = $tmp[0]." as `".trim($tmp[1])."`";
          } else $fields_list[$i] = "`".$fields_list[$i]."`";
        }
        $fields = implode(",",$fields_list);
      } else $fields = $fields_list;
      return $fields;
    }

    function _getTables($table_list) {
      if(is_array($table_list)) {
        for($i=0;$i<count($table_list);$i++) {
          if(strpos($table_list[$i]," ")) {
            $tmp = explode(" ",$table_list[$i]);
            $table_list[$i] = "`".trim($this->zb_prefix.$tmp[0])."` ".trim($tmp[1]);
          }
        }
        $tables = implode(",",$table_list);
      } else $tables = $this->zb_prefix.$table_list;

      return $tables;
    }

    function _getConds($cond_list) {
      if($cond_list) {
        if(is_array($cond_list)) $conds = " where (".implode(") and (",$cond_list).")";
        else $conds = " where ({$cond_list})";
      }
      return $conds;
    }

    function _getOrders($order_list) {
      if($order_list) {
        if(is_array($order_list)) $orders = " order by ".implode(",",$order_list);
        else $orders = " order by {$order_list} ";
      }
      return $orders;
    }

    function _getLimits($limit_start, $limit_length) {
      if(isset($limit_start) && $limit_length) $limits = " limit {$limit_start},{$limit_length} ";
      return $limits;
    }

    function query($query) {
      $this->_query = $query;

      if($this->_debug) $start_time = $this->getMicroTime();
        
      $this->result = @mysql_query($query, $this->connect);

      if($this->_debug) {
        $e_time = $this->getMicroTime()-$start_time;
        if(eregi("^select",$query)) @$tmp = mysql_fetch_object(mysql_query("explain ".$query));
        $this->query_log[] = array('query'=>$query, 'e_time' => $e_time, 'explain' => $tmp);
        $this->total_e_time += $e_time;
      }
      if(mysql_error()) return $this->error(); 
      return $this->success();
    }

    function fetch() {
      return @mysql_fetch_object($this->result);
    }
    
    function fetch_array() {
      return @mysql_fetch_array($this->result, MYSQL_ASSOC);
    }

    function insertId() {
      return @mysql_insert_id();
    }

    function getCount($table_list, $cond_list = null) {
      $tables = $this->_getTables($table_list);
      $conds = $this->_getConds($cond_list);

      $query = "select count(*) as cnt from {$tables} {$conds}";
      $output = $this->query($query);
      $tmp = $this->fetch();
      return (int)$tmp->cnt;
    }

    function getMax($table_list, $keyname, $cond_list) {
      $tables = $this->_getTables($table_list);
      $conds = $this->_getConds($cond_list);

      if(strpos($keyname,".")) $s_keyname = substr($keyname, strpos($keyname,".")+1, strlen($keyname));
      else $s_keyname = $keyname;

      $query = "select max({$keyname}) as {$s_keyname} from {$tables} {$conds}";

      $this->query($query);
      $tmp = $this->fetch();
      return $tmp->{$s_keyname};
    }

    function getMin($table_list, $keyname, $cond_list) {
      $tables = $this->_getTables($table_list);
      $conds = $this->_getConds($cond_list);

      if(strpos($keyname,".")) $s_keyname = substr($keyname, strpos($keyname,".")+1, strlen($keyname));
      else $s_keyname = $keyname;

      $query = "select min({$keyname}) as {$s_keyname} from {$tables} {$conds}";

      $this->query($query);
      $tmp = $this->fetch();
      return $tmp->{$s_keyname};
    }
    
    function getNextSequence() {
      $obj->srl = '';
      $obj->regdate = date("YmdHis");
      $this->insert('sequence', $obj);
      return $this->insertId();
    }

    function select($fields_list, $table_list, $cond_list = null, $order_list = null, $limit_start = null, $limit_length = null) {
      $fields = $this->_getFields($fields_list);
      $tables = $this->_getTables($table_list);
      $conds = $this->_getConds($cond_list);
      $orders = $this->_getOrders($order_list);
      $limits = $this->_getLimits($limit_start, $limit_length);
      $query = "select {$fields} from {$tables} {$conds} {$orders} {$limits}";
      return $this->query($query);
    }

    function selectGroup($fields_list, $table_list, $cond_list = null, $order_list = null, $group_by = null, $limit_start = null, $limit_length = null) {
      $fields = $this->_getFields($fields_list);
      $tables = $this->_getTables($table_list);
      $conds = $this->_getConds($cond_list);
      $orders = $this->_getOrders($order_list);
      $limits = $this->_getLimits($limit_start, $limit_length);
      $query = "select {$fields} from {$tables} {$conds} group by {$group_by} {$orders} {$limits}";
      return $this->query($query);
    }

    function selectList($fields_list, $table_list, $cond_list = null, $order_list = null, $limit_start = null, $limit_length = null) {
      $this->select($fields_list, $table_list, $cond_list, $order_list, $limit_start, $limit_length);
      while($tmp = $this->fetch()) $output->list[] = $tmp;
      return $output;
    }

    function selectListArray($fields_list, $table_list, $cond_list = null, $order_list = null, $limit_start = null, $limit_length = null) {
      $this->select($fields_list, $table_list, $cond_list, $order_list, $limit_start, $limit_length);
      while($tmp = $this->fetch_array()) $output->list[] = $tmp;
      return $output;
    }

    function selectOne($fields_list, $table_list, $cond_list = null, $order_list = null, $limit_start = 0, $limit_length = 1) {
      $this->select($fields_list, $table_list, $cond_list, $order_list, $limit_start, $limit_length);
      return $this->fetch();
    }

    function selectOneArray($fields_list, $table_list, $cond_list = null, $order_list = null, $limit_start = 0, $limit_length = 1) {
      $this->select($fields_list, $table_list, $cond_list, $order_list, $limit_start, $limit_length);
      return $this->fetch_array();
    }

    function insert($table_name, $values) {
      foreach($values as $key => $val) {
        $key_list[] = $key;
        $val_list[] = $this->addquotes($val);
      }

      $keys = "`".implode("`,`",$key_list)."`";
      $vals = "'".implode("','",$val_list)."'";

      $query = "insert into `{$this->zb_prefix}{$table_name}` ({$keys}) values ({$vals})";
      return $this->query($query);
    }

    function update($table_name, $values, $cond_list = null) {
      foreach($values as $key => $val) {
        $val = $this->addquotes($val);
        $val_list[] = "`{$key}` = '{$val}'";
      }
      $vals = implode(",",$val_list);

      $conds = $this->_getConds($cond_list);

      $query = "update `{$this->zb_prefix}{$table_name}` set {$vals} {$conds}";
      return $this->query($query);
    }

    function updatePlus($table_name, $column_key, $cond_list, $cnt = 1) {
      if(is_array($column_key)) {
        for($i=0;$i<count($column_key);$i++) {
          $update_query_list[] = " `{$column_key[$i]}` = `{$column_key[$i]}`+{$cnt} ";
        }
        $update_query = implode(',',$update_query_list);
      } else $update_query = " `{$column_key}` = `{$column_key}`+{$cnt} ";

      $conds = $this->_getConds($cond_list);
      $query = "update `{$this->zb_prefix}{$table_name}` set {$update_query} {$conds}";
      return $this->query($query);
    }

    function updateMinus($table_name, $column_key, $cond_list, $cnt = 1) {
      if(is_array($column_key)) {
        for($i=0;$i<count($column_key);$i++) {
          $update_query_list[] = " `{$column_key[$i]}` = `{$column_key[$i]}`-{$cnt} ";
        }
        $update_query = implode(',',$update_query_list);
      } else $update_query = " `{$column_key}` = `{$column_key}`-{$cnt} ";

      $conds = $this->_getConds($cond_list);
      $query = "update `{$this->zb_prefix}{$table_name}` set {$update_query} {$conds}";
      return $this->query($query);
    }

    function delete($table_name, $cond_list=null) {
      $conds = $this->_getConds($cond_list);
      $query = "delete from `{$this->zb_prefix}{$table_name}` {$conds}";
      return $this->query($query);
    }

    function addquotes($data) {
      if(get_magic_quotes_gpc()) $data = stripslashes(str_replace("\\","\\\\",$data));
      if(!is_numeric($data)) $data = @mysql_escape_string($data);
      return $data;
    }

    function error() {
      if($this->_debug) Zeroboard::debugPrint((++$GLOBALS['____QUCNT'])." : ".$this->_query."\n".mysql_error());
      return Zeroboard::getOutput(mysql_errno(), mysql_error());
    }

    function success() {
      return Zeroboard::getOutput();
    }

    function getMicroTime() {
      $microtimestmp = split(" ",microtime());
      return $microtimestmp[0]+$microtimestmp[1];
    }

  }
?>
