<?php

  class zFile {

    function getDirectoryList($path) {
      $oDir = dir($path);
      while($entry = $oDir->read()) {
        if ($entry != '.' && $entry != '..' && is_dir($path.'/'.$entry) && $entry != 'CVS') $output[] = $entry;
      }    
      $oDir ->close();

      return $output;
    }

    function mkDir($path) {
      if(is_dir($path)) return;
      @mkdir($path, 0777);
    }

    function mkDirRecursiv($default_path, $path) {
      if(substr($default_path, -1,1)=='/') $default_path = substr($default_path,0,strlen($default_path)-1);
      $arr_path = explode('/',$path);
      for($i=0;$i<count($arr_path);$i++) {
          if(!$arr_path[$i]) continue;
          $default_path .= '/'.$arr_path[$i];
          zFile::mkDir($default_path);
      }
    }

    function readFile($filename) {
      if(!file_exists($filename)) return '';
      if(filesize($filename)<1) return '';
      $f = fopen($filename, 'r');
      $buff = fread($f, filesize($filename));
      fclose($f);
      return $buff;
    }

    function getDirList($path) {
      if(!is_dir($path)) return;
      $oDir = dir($path);
      while($entry = $oDir->read()) {
        if ($entry != '.' && $entry != '..' && is_dir($path.'/'.$entry)) $output[] = $entry;
      }
      $oDir->close();
      return $output;
    }

    function writeFile($filename, $buff) {
      $f = fopen($filename, "w");
      fwrite($f, $buff);
      fclose($f);
    }

    function resizeImage($file, $width, $height) {
      if(!function_exists("imagecreatefromgif")) return;

      list($_width, $_height) = getimagesize($file);

      if($_width<=$width && $_height<=$height) return;

      $tmp = explode(".",$file);
      $ext = strtolower($tmp[count($tmp)-1]);

      $thumb = imagecreatetruecolor($width, $height);

      switch($ext) {
        case 'gif' :
            $source = imagecreatefromgif($file);
            if(function_exists('imagecopyresampled')) imagecopyresampled($thumb, $source, 0, 0, 0, 0, $width, $height, $_width, $_height);
            else imagecopyresized($thumb, $source, 0, 0, 0, 0, $width, $height, $_width, $_height);
            imagegif($thumb, $file, 100);
          break;
        case 'jpeg' :
        case 'jpg' :
            $source = imagecreatefromjpeg($file);
            if(function_exists('imagecopyresampled')) imagecopyresampled($thumb, $source, 0, 0, 0, 0, $width, $height, $_width, $_height);
            else imagecopyresized($thumb, $source, 0, 0, 0, 0, $width, $height, $_width, $_height);
            imagejpeg($thumb, $file, 100);
          break;
        case 'png' :
            $source = imagecreatefrompng($file);
            if(function_exists('imagecopyresampled')) imagecopyresampled($thumb, $source, 0, 0, 0, 0, $width, $height, $_width, $_height);
            else imagecopyresized($thumb, $source, 0, 0, 0, 0, $width, $height, $_width, $_height);
            imagepng($thumb, $file, 100);
          break;
        default :
            return;
          break;
      }
    }

    function getFilePath($sequence, $len) {
      while($str = substr($sequence,0,$len)) {
        if(strlen($str)<$len) $str = sprintf("%0{$len}d",$str);
        $path .= $str.'/';
        $sequence = substr($sequence,$len,strlen($sequence));
      }
      return $path;
    }

    function uploadImage($member_srl, $file, $width = null, $height = null) {
      if(!$member_srl) return;
      if(!is_uploaded_file($file['tmp_name'])) return;
      if(!eregi("^multipart\/form-data", $_SERVER['CONTENT_TYPE'])) return;
      list($type, $ext) = explode('/',$file['type']);
      if($type!='image') return;

      $tmp = explode(".",$file['name']);
      $ext = strtolower($tmp[count($tmp)-1]);
      if(!in_array($ext,array('gif','jpg','jpeg','png'))) return;

      $tmp_filename = md5(time()).'.'.$ext;
      $tmp_filepath = 'files/images/'.zFile::getFilePath($member_srl, 4).zFile::getFilePath(rand(1000,9999),2);
      zFile::mkDirRecursiv('./',$tmp_filepath);

      $filename = $tmp_filepath.$tmp_filename;
      if(!move_uploaded_file($file['tmp_name'], $filename)) return;

      if($width && $height) zFile::resizeImage($filename, $width, $height);

      $host = str_replace(':80','',$_SERVER['HTTP_HOST']);
      $path = str_replace('file_upload.php','',$_SERVER['PHP_SELF']);

      $url = sprintf("http://%s%s%s",$host,$path,$filename);
      return $url;
    }

    function deleteImageFile($url) {
      $url_info = parse_url($url);
      $path = str_replace('file_upload.php','',$_SERVER['PHP_SELF']);

      $filename = './'.str_replace($path, '', $url_info['path']);
      unlink($filename);
    }

    function uploadFile($member_srl, $file, $width = 540) {
      if(!$member_srl) return;
      if(!is_uploaded_file($file['tmp_name'])) return;
      if(!eregi("^multipart\/form-data", $_SERVER['CONTENT_TYPE'])) return;
      list($type, $ext) = explode('/',$file['type']);
      $output = Zeroboard::getOutput();

      $tmp = explode(".",$file['name']);
      $output->ext = strtolower($tmp[count($tmp)-1]);
      $output->s_filename = $file['name'];
      $output->size = $file['size'];

      $tmp_filename = md5(time()).'.'.$output->ext;
      $tmp_filepath = 'files/binary/'.zFile::getFilePath($member_srl, 4).zFile::getFilePath(rand(1000,9999),2);
      zFile::mkDirRecursiv('./',$tmp_filepath);

      $filename = $tmp_filepath.$tmp_filename;
      if(!move_uploaded_file($file['tmp_name'], $filename)) return;
      if(in_array($output->ext,array('gif','jpg','jpeg','png'))) {

        list($_width, $_height) = getimagesize($filename);
        if($width < $_width) {
          $per = round($width / $_width, 2);
          $height = (int)$_height*$per;
          $output->is_resized = 'Y';

          $source_file = eregi_replace("\.{$output->ext}$","_source.{$output->ext}",$filename);
          @copy($filename, $source_file);

          zFile::resizeImage($filename, $width, $height);

        }
        $output->size = filesize($filename);

        $thumbnail = eregi_replace("\.{$output->ext}$","_thumbnail.{$output->ext}",$filename);
        if(@copy($filename, $thumbnail)) {
          zFile::resizeImage($thumbnail, 80,80);
        }
      }

      $output->path = $filename;
      $output->filename = md5($tmp_filename);
      return $output;
    }

    function filesize($size) {
      if(!$size) return "0Byte";
      if($size<1024) return ($size."Byte");
      if($size >1024 && $size< 1024 *1024) return sprintf("%0.1fKB",$size / 1024);
      return sprintf("%0.2fMB",$size / (1024*1024));
    }

    function deleteFile($obj) {
      $file_srl = $obj->file_srl;
      $file_path = $obj->file_path;
      $hostname = $obj->hostname;
      $port = $obj->port;
      if($port != 80) $hostname .= ":{$port}";
      $path = $obj->path;

      $this_server = $hostname.$path;

      $_hostname = $_SERVER['HTTP_HOST'];
      $_port = $_SERVER['SERVER_PORT'];
      if($_port!=80) $_hostname .= ":{$_port}";
      $_path = str_replace('server.php','',$_SERVER['PHP_SELF']);

      $target_server = $hostname.$path;
      if($this_server == $target_server) {
        @unlink("./".$file_path);
        if(in_array($obj->ext,array('gif','jpeg','jpg','png'))) {
          $thumbnail_path = eregi_replace("\.{$obj->ext}$","_thumbnail.{$obj->ext}",$file_path);
          @unlink($thumbnail_path);
        }
        return true;
      } else {
        $query_string = sprintf("%s%s?file_srl=%s&file_path=%s",$path, "server.php", $file_srl, md5($file_path));
        $fp = fsockopen($hostname, $port, $errno, $errstr);
        if(!$fp) return false;
        fputs($fp, "GET {$query_string} HTTP/1.0\r\n");
        fputs($fp, "Host : {$hostname}\r\n\r\n");
        fclose($fp);

        return true;
      }
    }

    function deleteFromRemoteFile() {
      $file_srl = trim($_REQUEST['file_srl']);
      $file_path = trim($_REQUEST['file_path']);
      if(!$file_srl||!$file_path) return;

      $oDB = &zDB::instance();
      $file_srl = $oDB->addquotes($file_srl);
      $file = $oDB->selectOne('*','file',"file_srl='{$file_srl}'");

      if($file->file_srl != $file_srl || md5($file->path)!=$file_path) return;

      unlink("./".$file->path);

      if(in_array(strtolower($file->ext),array('gif','jpeg','jpg','png'))) {
        $thumbnail_path = eregi_replace("\.{$file->ext}$","_thumbnail.{$file->ext}",$file->path);
        @unlink($thumbnail_path);
      }

      return Zeroboard::getOutput(0,'success');
    }

    function getFileInfo($file_srl) {
      $tmp = explode('_',$file_srl);
      $obj->file_srl = $tmp[0];
      $obj->md5_path = $tmp[1];
      return $obj;
    }

    function getFileName($file_srl, $path) {
      return $file_srl.'_'.md5($path);
    }

    function downloadFile($filename, $type='') {
      $oDB = &zDB::instance();

      $filename = $oDB->addquotes($filename);
      $file_obj = $oDB->selectOne('*','file',"filename='{$filename}'");
      if($file_obj->filename!=$filename) exit();

      $article_srl = $oDB->addquotes($file_obj->article_srl);
      $module_info = $oDB->selectOne(array('b.module_srl as module_srl','b.download_level as download_level'),array("articles a","module_manager b"),array("a.article_srl='{$article_srl}'","a.module_srl = b.module_srl"));
      $download_level = $module_info->download_level;

      $oMember = &zMember::instance();
      if($download_level) if(!$oMember->inLevels($download_level)) exit();

      if($oMember->member_srl) {
        $oPoint = new zPoint($module_info->module_srl,$oMember->member_srl, 'download', $article_srl);
        $oPoint->add_point();
      }

      $filename = $file_obj->s_filename;
      if(strstr($_SERVER['HTTP_USER_AGENT'], "MSIE")) $filename = urlencode(preg_replace('/\./', '%2e', $filename, substr_count($filename, '.') - 1));

      if($type == 'thumbnail') $path = "./".eregi_replace("\.{$file_obj->ext}$","_thumbnail.{$file_obj->ext}",$file_obj->path);
      elseif($type == 'source') $path = "./".eregi_replace("\.{$file_obj->ext}$","_source.{$file_obj->ext}",$file_obj->path);
      else $path = "./".$file_obj->path;

      if(!file_exists($path)) exit();

      $fp = fopen($path, 'rb');
      if(!$fp) exit();

      header("Cache-Control: ");
      header("Pragma: ");

      if(in_array(strtolower($file_obj->ext),array('gif','jpeg','jpg','png'))) {
        if($file_obj->ext=='jpg') $file_obj->ext = 'jpeg';
        header("Content-Type: image/{$file_obj->ext}");
      } else {
        header("Content-Type: application/octet-stream");
      }

      header("Content-Length: " .(string)(filesize($path)) );
      header('Content-Disposition: attachment; filename="'.$filename.'"');
      header("Content-Transfer-Encoding: binary\n");

      fpassthru($fp);

      if(!in_array($file_obj->ext,array('gif','jpg','jpeg','png'))) {
        $oDB->updatePlus('file','download_cnt',"file_srl='{$file_obj->file_srl}'");
      }
    }

  }

?>
