<?php

  class zInstall extends Zeroboard {

    function zInstall() {
      global $lang;
      $this->addLang(INSTALL_LANG_DIR);

      parent::Zeroboard();

      $this->addLang(ADMIN_LANG_DIR);
      $this->addLang(FONTLIST_LANG_DIR);

      $this->addCssFile(ADMIN_CSS_DIR.'common.css');

      switch($this->lang_type) {
        default :
            $this->addCssFile(ADMIN_CSS_DIR.'lang.ko.css');
          break;
      }

    }

    function proc($action = '', $obj = '') {

      switch($action) {
        case 'check_install' :
            return $this->_checkPermision($obj);
          break;
        case 'do_install' :
            return $this->_doInstall($obj);
          break;
        default :
            $this->printHtml();
          break;
      }
    }

    function _checkPermision($obj) {
      $output = $this->getOutput();

      if(!function_exists("imagecreatefromgif")) $output->gd_enable = 'fail';
      else $output->gd_enable = 'success';

      if(!function_exists('iconv')) $output->iconv_enable = 'fail';
      else $output->iconv_enable = 'success';

      if(mysql_get_client_info() < "4.1.00") $output->mysql_enable = "fail";
      else $output->mysql_enable = "success";

      if(ini_get('session.auto_start')==1) $output->session_auto_start_enable = 'fail';
      else $output->session_auto_start_enable = 'success';

      $output->mysql_version = mysql_get_client_info();

      if(is_writable(ROOT_DIR)||is_writable(FILES_DIR)) {
        if(!is_writable(FILES_DIR)) zFile::mkdir(FILES_DIR);
        if(!is_writable(SMARTY_CACHE_DIR)) zFile::mkdir(SMARTY_CACHE_DIR);
        if(!is_writable(SMARTY_COMPILE_DIR)) zFile::mkdir(SMARTY_COMPILE_DIR);
        if(!is_writable(ZB_CACHE_DIR)) zFile::mkdir(ZB_CACHE_DIR);
        $output->permission_enable = 'success';
      }
      else $output->permission_enable = 'fail';

      if($output->gd_enable=='success'&&$output->permission_enable=='success'&&$output->iconv_enable=='success'&&$output->mysql_enable=='success'&&$output->session_auto_start_enable=='success') $output->install_enable = 'success';
      else $output->install_enable = 'fail';

      return $output;
    }

    function _doInstall($obj) {
      $obj->db_prefix .= '_';
      $this->oDB->setInfo($obj->db_hostname, $obj->db_userid, $obj->db_password, $obj->db_database, $obj->db_prefix);
      $output = $this->oDB->connect();
      if($output->error!=0) return $output;

      $cnt = $this->oDB->getCount('site_manager');
      if(!$cnt) {
        $schema = str_replace("{#ZB_PREFIX#}", $obj->db_prefix, zFile::readFile(COMMON_DIR.'schema.sql'));
        $schema_list = explode("\n\n",$schema);
        for($i=0;$i<count($schema_list);$i++) {
          unset($output);
          $output = $this->oDB->query($schema_list[$i]);
          if($output->error!=0) return $output;
        }

        $level->level = 1;
        $level->level_title = $this->lang->install->member_level_title[0];
        $join_level_srl = $level->level_srl = $this->oDB->getNextSequence();
        $this->oDB->insert('member_level_manager',$level);

        $level->level = 2;
        $level->level_title = $this->lang->install->member_level_title[1];
        $level->level_srl = $this->oDB->getNextSequence();
        $this->oDB->insert('member_level_manager',$level);

        $level->level = 3;
        $level->level_title = $this->lang->install->member_level_title[2];
        $admin_level_srl = $level->level_srl = $this->oDB->getNextSequence();
        $this->oDB->insert('member_level_manager',$level);

        $site_info->title = '';
        $site_info->keywords = '';
        $site_info->description = '';
        $site_info->email = $obj->admin_email;
        $site_info->hidden = 'N';
        $site_info->auto_login_time = 7;
        $site_info->access_level = 0;
        $site_info->join_level_srl = $join_level_srl;
        $this->oDB->insert('site_manager',$site_info);

        $server->hostname = $_SERVER['SERVER_NAME'];
        $server->port = $_SERVER['SERVER_PORT'];
        $server->path = str_replace('server.php','',$_SERVER['SCRIPT_NAME']);
        $server->server_type = 'web';
        $server->server_name = $this->lang->install->default_web_server;
        $server->regdate = date('YmdHis');
        $server->is_default = 'Y';
        $server->server_srl = $this->oDB->getNextSequence();
        $this->oDB->insert('server_manager',$server);

        $server->server_type = 'file';
        $server->server_name = $this->lang->install->default_file_server;
        $server->server_srl = $this->oDB->getNextSequence();
        $this->oDB->insert('server_manager',$server);

        $tmp = explode("@",$obj->admin_email);

        $member->user_id = $obj->admin_userid;
        $member->user_name = $obj->admin_name;
        $member->nick_name = $obj->admin_nick_name;
        $member->passwd = md5($obj->admin_password_1);
        $member->email_address = $obj->admin_email;
        $member->email = $tmp[0];
        $member->email_host = $tmp[1];
        $member->allowed = 'Y';
        $member->denied = 'N';
        $member->mailing = 'Y';
        $member->regdate = date('YmdHis');
        $member_srl = $member->member_srl = $this->oDB->getNextSequence();
        $member->listorder = $member_srl * -1;
        $this->oDB->insert('member_list',$member);

        $member_level->member_srl = $member_srl;
        $member_level->level_srl = $admin_level_srl;
        $this->oDB->insert('member_level',$member_level);

        $message_agreement->type = 'agreement';
        $message_agreement->message = $this->lang->install->default_agreement_messgae;
        $this->oDB->insert('site_message', $message_agreement);

        $message_auth_mail->type = 'auth_mail';
        $message_auth_mail->title = $this->lang->install->default_auth_mail_title;
        $message_auth_mail->message = $this->lang->install->default_auth_mail_messgae;
        $this->oDB->insert('site_message', $message_auth_mail);

        $message_find_passwd->type = 'find_passwd';
        $message_find_passwd->title = $this->lang->install->default_find_passwd_title;
        $message_find_passwd->message = $this->lang->install->default_find_passwd_messgae;
        $this->oDB->insert('site_message', $message_find_passwd);

        $analytics->regdate = '00000000';
        $this->oDB->insert('analytics',$analytics);
        for($i=time();$i<time()+60*60*24*365*3;$i+=60*60*24) {
          $analytics->regdate = date("Ymd",$i);
          $this->oDB->insert('analytics',$analytics);
        }
      }

      $this->oDB->saveDBConfig($obj->db_hostname, $obj->db_userid, $obj->db_password, $obj->db_database, $obj->db_prefix, $this->lang_type);

      return $this->getOutput();
    }

    function printHtml() {
      $this->addJsFile(COMMON_JS_DIR.'install.js');

      $this->tpl->header = $this->oSmarty->assign_fetch(COMMON_TPL_DIR.'header.tpl', $this);
      $this->tpl->footer = $this->oSmarty->assign_fetch(COMMON_TPL_DIR.'footer.tpl', $this);

      $this->tpl->content = $this->oSmarty->assign_fetch(COMMON_TPL_DIR.'install.tpl', $this);

      print $this->oSmarty->assign_fetch(COMMON_TPL_DIR.'index.tpl', $this);
    }

  }
?>
