<?php

  class zMember {

    var $member_info = null;

    var $member_srl;
    var $user_id;

    var $extend_val;

    var $check_not_empty_key = array('user_id','passwd','user_name','nick_name','email','email_host');
    var $columns_member_list = array(
          'member_srl',
          'listorder',
          'user_id',
          'passwd',
          'user_name',
          'nick_name',
          'email_address',
          'email',
          'email_host',
          'extend_val',
          'new_message',
          'point',
          'allowed',
          'denied',
          'mailing',
          'manager_message',
          'regdate',
          'last_signin',
          'image_nick',
          'image_mark',
          'profile_image',
          'sign',
        );

    var $lang;

    function &instance() {
      if(!$GLOBALS['_ZMEMBER_']) $GLOBALS['_ZMEMBER_'] = new zMember();
      return $GLOBALS['_ZMEMBER_'];
    }

    function zMember() {
      global $lang;
      $this->lang = &$lang;

      $oSvc = &zSvc::instance();
      $oSvc->addLang(COMMON_LANG_DIR);
      $oSvc->addLang(ADMIN_LANG_DIR);

      $this->_checkAutoLogin();
      if(!$this->isLogged()) return;

      $this->member_srl = $this->getMemberSrl();
    }

    function proc($action = '', $obj = '') {
      switch($action) {
        case 'do_login' :
            return $this->_doLogin($obj);
          break;
        case 'do_logout' :
            return $this->_doLogout($obj);
          break;
        case 'check_exists_user_id' :
            return $this->_checkExistsUserId($obj);
          break;
        case 'check_exists_nick_name' :
            return $this->_checkExistsNickname($obj);
          break;
        case 'check_exists_email_address' :
            return $this->_checkExistsEmailAddress($obj);
          break;
        case 'request_auth_mail' :
            return $this->_requestAuthMail($obj);
          break;
        case 'find_password' :
            return $this->_findPassword($obj);
          break;
        case 'insert_member' :
            return $this->_insertMember($obj);
          break;
        case 'update_member' :
            return $this->_updateMember($obj);
          break;
        case 'leave_out' :
            return $this->_leaveOut($obj);
          break;
        case 'send_message' :
            return $this->_sendMessage($obj);
          break;
        case 'delete_message' :
            return $this->_deleteMessage($obj);
          break;
        case 'do_survey_pass' :
            return $this->_doSurveyPass($obj);
          break;
        case 'do_survey' :
            return $this->_doSurvey($obj);
          break;
        case 'remove_survey' :
            return $this->_removeSurvey($obj);
          break;
        case 'get_module_list' :
            return $this->_getModuleList($obj);
          break;
        case 'add_serial' :
            return $this->_addSerial($obj);
          break;
        case 'get_new_seq' :
            return $this->_getNewSeq($obj);
          break;
        case 'delete_file' :
            return $this->_deleteFile($obj);
          break;
      }
    }
    
    function _checkAutoLogin() {
      if(!$_COOKIE['ZBSESSID']||$_SESSION['is_logged']) return false;

      $oDB = &zDB::instance();

      $zbsessid = $oDB->addquotes($_COOKIE['ZBSESSID']);
      $ipaddress = $oDB->addquotes($_SERVER['REMOTE_ADDR']);
      $cond_list = array(
            "session_key = '{$zbsessid}'",
            "ipaddress = '{$ipaddress}'",
          );
      $tmp_output = $oDB->selectOne('*','session_autologin',$cond_list);
      if($tmp_output->error!=0 || !$tmp_output->session_key) {
        setcookie('ZBSESSID','',-1,'/'); 
        return;
      } 

      $_SESSION['member_srl'] = $tmp_output->member_srl;
      $_SESSION['is_logged'] = true;

      $this->_setSessionInfo();
    }

    function _doLogin($obj) {
      $output = Zeroboard::getOutput();
      $output->logged = 'false';
      $output->as_key = $output->as_expired = '';

      $oDB = &zDB::instance();

      $user_id = $oDB->addquotes($obj->user_id);
      $passwd = $oDB->addquotes(md5($obj->passwd));
      $auto_login = $obj->auto_login;

      $cond_list = array("user_id = '{$user_id}'");
      $member_info = $oDB->selectOne('*','member_list',$cond_list);
      if($user_id!=$member_info->user_id) return Zeroboard::getOutput(-1, $this->lang->common->login_fail_invalid_user_id);
      if($passwd!=$member_info->passwd) return Zeroboard::getOutput(-1, $this->lang->common->login_fail_invalid_password);
      if($member_info->denied == 'Y') return Zeroboard::getOutput(-1, $this->lang->common->login_fail_denied);
      if($member_info->allowed != 'Y') {
        $site_info = $oDB->selectOne('*','site_manager');
        if($site_info->auth_type == 1) {
          $output = Zeroboard::getOutput();
          $output->logged = 'false';
          $output->message = 
            $this->lang->common->login_fail_disallowed."\n".
            $this->lang->common->login_request_auth_mail;
          $output->auth_type = 1;
          $output->member_srl = $member_info->member_srl;
          return $output;
        } else {
          return Zeroboard::getOutput(-1, $this->lang->common->login_fail_disallowed);
        }
      }

      $member_srl = $oDB->addquotes($member_info->member_srl);
      $query_obj->last_signin = date("YmdHis");
      $oDB->update('member_list',$query_obj,"member_srl='{$member_srl}'");

      $output->logged = 'true';
      $output->auth_type = 0;
      $output->member_srl = $member_info->member_srl;

      if($auto_login=='Y') {
        $site_info = $oDB->selectOne('*','site_manager');
        $auto_login_time = $site_info->auto_login_time;
        if(!$auto_login_time) $expire_time = 60*60*24*365;
        else $expire_time = 60*60*24*$auto_login_time;

        $as_obj->session_key = $oDB->addquotes(session_id());
        $as_obj->expired = time()+$expire_time;
        $as_obj->member_srl = $member_info->member_srl;
        $as_obj->ipaddress = $_SERVER['REMOTE_ADDR'];
        $tmp_output = $oDB->insert('session_autologin',$as_obj);

        if($tmp_output->error!=0) {
          $oDB->delete('session_autologin',"session_key='{$as_obj->session_key}'");
          $oDB->insert('session_autologin',$as_obj);
        }
        $output->as_key = $as_obj->session_key;
        $output->as_expired = $expire_time;
      }

      $this->_setSessionInfo($member_info);

      return $output;
    }

    function _doLogout($obj) {
      session_destroy();

      $oDB = &zDB::instance();

      if($_COOKIE['ZBSESSID']) {
        $session_key = $oDB->addquotes($_COOKIE['ZBSESSID']);
        $oDB->delete('session_autologin',"session_key = '{$session_key}'");
        setcookie('ZBSESSID','',-1,'/'); 
      }

      return Zeroboard::getOutput();
    }

    function _setSessionInfo($member_info = null) {
      $oDB = &zDB::instance();

      if(!$member_info) {
        $member_srl = $oDB->addquotes($_SESSION['member_srl']);
        $member_info = $oDB->selectOne('*','member_list',"member_srl='{$member_srl}'");
      } else $member_srl = $oDB->addquotes($member_info->member_srl);

      $table_list = array('member_level a','member_level_manager b');
      $cond_list = array("a.member_srl = '{$member_srl}'",'a.level_srl=b.level_srl');
      $oDB->select('*',$table_list, $cond_list,'b.level');
      $max_level = 0;
      $level_srls = array();
      while($tmp = $oDB->fetch()) {
        $level_srl = $tmp->level_srl;
        $level = $tmp->level;
        if($level>$max_level) $max_level = $level;
        $level_srls[] = $level_srl;
      }

      if($_SESSION) {
        session_unset();
        $_sessid = $oDB->addquotes(session_id());
        $_ipaddress = $oDB->addquotes($_SERVER['REMOTE_ADDR']);
        $cond_list = array(
              "session_key = '{$_sessid}'",
              "ipaddress = '{$_ipaddress}'",
            );
        $oDB->delete('session', $cond_list);
      }

      $_SESSION['is_logged'] = true;
      $_SESSION['member_srl'] = $member_srl;
      $_SESSION['level_srls'] = $level_srls;
      $_SESSION['max_level'] = $max_level;
      $_SESSION['member_info'] = $member_info;

      $this->member_info = $member_info;
    }

    function isLogged() {
      return $_SESSION['is_logged'];
    }

    function getMemberSrl() {
      if(!$this->isLogged()) return 0;

      return $_SESSION['member_srl'];
    }

    function getMaxLevel() {
      if(!$this->isLogged()) return 0;

      return $_SESSION['max_level'];
    }

    function getLevelSrlList() {
      if(!$this->isLogged()) return array();

      return $_SESSION['level_srls'];
    }

    function isLevel($level) {
      if($level == 0) return true;

      if(!$this->isLogged()) return false;
      if($level<=$_SESSION['max_level']) return true;
    }

    function inLevels($level) {
      if(!is_array($level)) $level = explode('|@|', $level);
      for($i=0;$i<count($level);$i++) if($this->isLevelSrl($level[$i])) return true;
      return false;
    }

    function isLevelSrl($level_srl) {
      if($level_srl == 0) return true;
      if(!$this->isLogged()) return false;
      if(in_array($level_srl, $this->getLevelSrlList())) return true;
    }

    function getMemberInfo() {
      if(!$this->isLogged()) return;

      if($_SESSION['member_info']) $this->member_info = $_SESSION['member_info'];

      if(!$this->member_info) {
        $oDB = &zDB::instance();
        $member_srl = $oDB->addquotes($_SESSION['member_srl']);
        $this->member_info = $oDB->selectOne('*','member_list',"member_srl='{$member_srl}'");
      }

      $level = zPoint::getLevel($this->member_info->point);
      $this->member_info->exp_level = $level->exp_level;
      $this->member_info->exp_per = $level->exp_per;
      $this->member_info->exp_icon = $level->exp_icon;

      return $this->member_info;
    }

    function _checkExistsUserId($obj) {
      $oDB = &zDB::instance();
      $user_id = $oDB->addquotes($obj->user_id);
      $check = $oDB->getCount('member_list',"user_id='{$user_id}'");

      $output = Zeroboard::getOutput();
      $output->check = $check;

      if($check>0) $output->msg = $this->lang->common->notice_exists_user_id;
      else $output->msg = $this->lang->common->notice_not_exists_user_id;
      return $output;
    }

    function _checkExistsNickname($obj) {
      $oDB = &zDB::instance();

      $member_srl = $oDB->addquotes($obj->member_srl);
      $nick_name = $oDB->addquotes($obj->nick_name);

      $cond_list[] = "nick_name='{$nick_name}'";
      if($member_srl) $cond_list[] = "member_srl != '{$member_srl}'";

      $check = $oDB->getCount('member_list',$cond_list);
      $output = Zeroboard::getOutput();
      $output->check = $check;

      if($check>0) $output->msg = $this->lang->common->notice_exists_nick_name;
      else $output->msg = $this->lang->common->notice_not_exists_nick_name;
      return $output;
    }

    function _checkExistsEmailAddress($obj) {
      $oDB = &zDB::instance();

      $email_address = $oDB->addquotes($obj->email_address);
      $member_srl = $oDB->addquotes($obj->member_srl);

      $cond_list[] = "email_address='{$email_address}'";
      if($member_srl) $cond_list[] = "member_srl != '{$member_srl}'";
      $check = $oDB->getCount('member_list',$cond_list);

      $output = Zeroboard::getOutput();
      $output->check = $check;

      if($check>0) $output->msg = $this->lang->common->notice_exists_email_address;
      else $output->msg = $this->lang->common->notice_not_exists_email_address;
      return $output;
    }

    function _checkMemberEmptyKey($obj) {
      for($i=0;$i<count($this->check_not_empty_key);$i++) {
        $key = $this->check_not_empty_key[$i];
        $val = $obj->{$key};
        if(!$val) return Zeroboard::getOutput(-1, $this->lang->admin->{"notice_member_fo_".$key});
      }
      $output->error = 0;
      $output->message = 'success';
      return $output;
    }

    function _leaveOut($obj) {
      if(!$this->isLogged()) return Zeroboard::getOutput(-1,$this->lang->common->notice_must_be_login);

      $oDB = &zDB::instance();

      $member_srl = $oDB->addquotes($this->getMemberSrl());
      $user_id = $obj->user_id;
      $passwd = md5($obj->passwd);
      $email_address = $obj->email.'@'.$obj->email_host;

      $member_info = $oDB->selectOne('*','member_list',"member_srl='{$member_srl}'");

      if(strcmp($member_info->user_id, $user_id)!=0) return Zeroboard::getOutput(-1,$this->lang->common->login_fail_invalid_user_id);
      if(strcmp($member_info->passwd, $passwd)!=0) return Zeroboard::getOutput(-1,$this->lang->common->login_fail_invalid_password);
      if(strcmp($member_info->email_address, $email_address)!=0) return Zeroboard::getOutput(-1,$this->lang->common->notice_invalid_email_address);

      $oDB->delete('member_list',"member_srl='{$member_srl}'");
      $oDB->delete('member_level',"member_srl='{$member_srl}'");
      
      $this->_doLogout($obj);

      return Zeroboard::getOutput(0,$this->lang->common->fld_leave_out_success);
    }

    function _requestAuthMail($obj) {
      if($this->isLogged()) return Zeroboard::getOutput(-1,$this->lang->common->notice_already_logged);

      $oDB = &zDB::instance();

      $auth_mail_info = $oDB->selectOne('*','site_message',"type='auth_mail'");
      $mail_title = $auth_mail_info->title;
      $mail_message = $auth_mail_info->message;

      $member_srl = $oDB->addquotes($obj->member_srl);
      if(!$obj->user_name) {
        $obj = $oDB->selectOne('*','member_list',"member_srl='{$member_srl}'");
      }
      
      $site_info = $oDB->selectOne('*','site_manager');

      $mail_obj->to_name = $obj->user_name;
      $mail_obj->to = $obj->email_address;
      $mail_obj->from_name = $site_info->title;
      $mail_obj->from = $site_info->email;
      $mail_obj->content_type = 'html';

      $auth_link = Zeroboard::getSignUpRegisterUrl($obj);
      $mail_obj->title = $mail_title;
      $mail_obj->content = nl2br(str_replace(
          array('{user_id}','{user_name}','{nick_name}','{auth_link}','{ip}'),
          array($obj->user_id,$obj->user_name,$obj->nick_name,$auth_link,$_SERVER['REMOTE_ADDR']),
          $mail_message
      ));

      require_class('zMail');
      zMail::sendMail($mail_obj);

      return Zeroboard::getOutput(0,$this->lang->common->login_send_auth_mail);
    }

    function _findPassword($obj) {
      if($this->isLogged()) return Zeroboard::getOutput(-1,$this->lang->common->notice_already_logged);

      $oDB = &zDB::instance();

      $user_id = $oDB->addquotes($obj->user_id);
      $email = $oDB->addquotes($obj->email);
      if(!$user_id) return Zeroboard::getOutput(-1,$this->lang->common->notice_member_fo_user_id);
      if(!$email) return Zeroboard::getOutput(-1,$this->lang->common->notice_member_fo_email);

      $member_info = $oDB->selectOne('*','member_list',"user_id='{$user_id}'");
      if(!$member_info) return Zeroboard::getOutput(-1,$this->lang->common->notice_member_fo_not_exists_user_id);
      if($member_info->email_address != $email) return Zeroboard::getOutput(-1,$this->lang->common->notice_member_fo_invalid_email);
      if($member_info->denied == 'Y') return Zeroboard::getOutput(-1, $this->lang->common->login_fail_denied);

      $auth_mail_info = $oDB->selectOne('*','site_message',"type='find_passwd'");
      $mail_title = $auth_mail_info->title;
      $mail_message = $auth_mail_info->message;

      $site_info = $oDB->selectOne('*','site_manager');

      $mail_obj->to_name = $member_info->user_name;
      $mail_obj->to = $member_info->email_address;
      $mail_obj->from_name = $site_info->title;
      $mail_obj->from = $site_info->email;
      $mail_obj->content_type = 'html';

      $output = zUrl::getFindPasswdUrl($member_info);
      $auth_link = $output->auth_link;
      $new_password = $output->new_password;

      $mail_obj->title = $mail_title;
      $mail_obj->content = nl2br(str_replace(
          array('{user_id}','{user_name}','{nick_name}','{auth_link}','{ip}','{new_password}'),
          array($member_info->user_id,$member_info->user_name,$member_info->nick_name,$auth_link,$_SERVER['REMOTE_ADDR'],$new_password),
          $mail_message
        ));

      require_class('zMail');
      zMail::sendMail($mail_obj);

      return Zeroboard::getOutput(0,$this->lang->common->login_send_find_password_mail);
    }

    function _insertMember($obj) {
      if($this->getMaxLevel()!=ADMINISTRATOR&&$this->isLogged()) return Zeroboard::getOutput(-1,$this->lang->common->notice_already_logged);
      $oDB = &zDB::instance();

      $obj->email_address = $obj->email.'@'.$obj->email_host;
      $obj->last_signin = '';
      $obj->regdate = date('YmdHis');

      $output = $this->_checkMemberEmptyKey($obj);
      if($output->error!=0) return $output;

      $obj->passwd = md5($obj->passwd);

      $output = $this->_checkExistsUserId($obj);
      if($output->check!=0) return Zeroboard::getOutput(-1,$output->msg);

      $output = $this->_checkExistsNickname($obj);
      if($output->check!=0) return Zeroboard::getOutput(-1,$output->msg);

      $output = $this->_checkExistsEmailAddress($obj);
      if($output->check!=0) return Zeroboard::getOutput(-1,$output->msg);

      require_class('zMail');
      if(!zMail::checkMailMX($obj->email_address)) return Zeroboard::getOutput(-1, $this->lang->common->notice_member_fo_not_exists_email);

      if(!$this->isLogged()) {
        require_class('zImageNumber');
        $number = zImageNumber::getNumber();
        if($obj->image_number!=$number) return Zeroboard::getOutput(-1,$this->lang->common->notice_member_fo_image_number_is_invalid);
      }
        

      $obj->extend_val = $oDB->addquotes(base64_encode(serialize(Zeroboard::unsetKey($this->columns_member_list, $obj))));
      $obj = Zeroboard::delDummy($this->columns_member_list, $obj);

      $site_info = $oDB->selectOne('*','site_manager');
      $join_level_srl = $site_info->join_level_srl;
      switch($site_info->auth_type) {
        case '2' :
            $obj->allowed = 'N';
            $msg = $this->lang->admin->msg_site_auth_list[2];
          break;
        case '1' :
            $obj->allowed = 'N';
            $msg = $this->lang->admin->msg_site_auth_list[1];
          break;
        default :
            $obj->allowed = 'Y';
            $msg = $this->lang->admin->msg_site_auth_list[0];
          break;
      }

      if($this->getMaxLevel()==ADMINISTRATOR) $obj->allowed = 'Y';
      else $obj->point = 0;

      unset($output);
      $member_srl = $obj->member_srl = $oDB->getNextSequence();
      $obj->listorder = $member_srl * -1;
      $output = $oDB->insert('member_list',$obj);
      if($output->error!=0) return $output;

      $level_obj->member_srl = $member_srl;
      $level_obj->level_srl = $join_level_srl;
      $oDB->insert('member_level',$level_obj);

      $output = Zeroboard::getOutput();
      $output->msg = $msg;
      $output->member_srl = $member_srl;

      $obj->member_srl = $member_srl;
      
      if($site_info->auth_type == 1&&$this->getMaxLevel()!=ADMINISTRATOR) $this->_requestAuthMail($obj);

      return $output;
    }

    function _updateMember($obj) {
      if(!$this->isLogged()) return Zeroboard::getOutput(-1,$this->lang->common->notice_must_be_login);
      if($obj->member_srl != $this->member_srl && $this->getMaxLevel()!=ADMINISTRATOR) return Zeroboard::getOutput(-1, $this->lang->admin->notice_member_invalid_access);

      $oDB = &zDB::instance();

      $member_srl = $oDB->addquotes($obj->member_srl);
      $obj->email_address = $obj->email.'@'.$obj->email_host;

      if($obj->member_srl == $this->member_srl) $member_info = $this->getMemberInfo($obj);
      else $member_info = $oDB->selectOne('*','member_list',"member_srl='{$member_srl}'");

      $obj->user_id = $member_info->user_id;
      if($this->getMaxLevel()!=ADMINISTRATOR) {
        $obj->user_name = $member_info->user_name;
        unset($obj->point);
        unset($obj->manager_message);
      }

      if(!$obj->user_name) $obj->user_name = $member_info->user_name;

      if($obj->passwd&&$obj->passwd_1&&$obj->passwd_2) $obj->passwd = md5($obj->passwd);
      else $obj->passwd = $member_info->passwd;

      $output = $this->_checkMemberEmptyKey($obj);
      if($output->error!=0) return $output;

      $output = $this->_checkExistsNickname($obj);
      if($output->check!=0) return Zeroboard::getOutput(-1,$output->msg);

      $output = $this->_checkExistsEmailAddress($obj);
      if($output->check!=0) return Zeroboard::getOutput(-1,$output->msg);
      $obj->extend_val = $oDB->addquotes(base64_encode(serialize(Zeroboard::unsetKey($this->columns_member_list, $obj))));
      $obj = Zeroboard::delDummy($this->columns_member_list, $obj);

      $output = $oDB->update('member_list',$obj,"member_srl='{$member_srl}'");
      if($output->error!=0) return $output;

      $member_info = $oDB->selectOne('*','member_list',"member_srl='{$member_srl}'");

      if($obj->member_srl == $this->member_srl) $this->_setSessionInfo($member_info);

      $output = Zeroboard::getOutput();
      $output->msg = $this->lang->admin->notice_member_update_success;
      $output->member_srl = $obj->member_srl;

      return $output;
    }

    function _sendMessage($obj) {
      $oDB = &zDB::instance();
      $target_srl = $oDB->addquotes($obj->target_srl);
      if(!$target_srl) return;
      $target_info = $oDB->selectOne(array('member_srl','user_id','nick_name'),'member_list',"member_srl='{$target_srl}'");

      if(!$target_info->user_id) return Zeroboard::getOutput(-1,$this->lang->common->notice_message_target_is_null);
      if(!$obj->title) return Zeroboard::getOutput(-1,$this->lang->common->alert_require_title);
      if(!$obj->article) return Zeroboard::getOutput(-1,$this->lang->common->alert_require_article);

      $member_srl = $oDB->addquotes($this->member_srl);
      $member_info = $oDB->selectOne(array('member_srl','user_id','nick_name'),'member_list',"member_srl='{$member_srl}'");

      $seq = $oDB->getNextSequence();
      $query_obj->message_srl = $seq;
      $query_obj->message_type = 'R';
      $query_obj->sender_srl = $this->member_srl;
      $query_obj->sender_user_id = $member_info->user_id;
      $query_obj->sender_nick_name = $member_info->nick_name;
      $query_obj->receiver_srl = $target_info->member_srl;
      $query_obj->receiver_user_id = $target_info->user_id;
      $query_obj->receiver_nick_name = $target_info->nick_name;
      $query_obj->article_srl = $obj->article_srl;
      $query_obj->keeping = 'N';
      $query_obj->title = $obj->title;
      $query_obj->message = $obj->article;
      $query_obj->regdate = date("YmdHis");
      $query_obj->is_readed = 'N';
      $query_obj->listorder = $seq*-1;
      $output = $oDB->insert('message',$query_obj);

      if(!$obj->article_srl) {
        $seq = $oDB->getNextSequence();
        $query_obj->message_srl = $seq;
        $query_obj->message_type = 'S';
        $query_obj->is_readed = 'Y';
        $query_obj->listorder = $seq*-1;
        $output = $oDB->insert('message',$query_obj);
      }

      if($output->error==0) {
        $target_srl = $oDB->addquotes($target_info->member_srl);
        $oDB->updatePlus('member_list','new_message',"member_srl='{$target_srl}'");
        $oDB->updatePlus('session','new_message',"member_srl='{$target_srl}'");
      }

      return Zeroboard::getOutput(0,$this->lang->common->alert_sended);
    }

    function _deleteMessage($obj) {
      $oDB = &zDB::instance();
      $message_srl = $oDB->addquotes($obj->message_srl);
      if(!$message_srl) return Zeroboard::getOutput(0,'pass');

      $message = $oDB->selectOne(array('message_type','sender_srl','receiver_srl'),'message',"message_srl='{$message_srl}'");

      if(
        ($message->message_type=='S' && $message->sender_srl == $this->member_srl) or
        ($message->message_type=='R' && $message->receiver_srl == $this->member_srl) 
      ) $oDB->delete('message',"message_srl='{$message_srl}'");

      return Zeroboard::getOutput(0,'success');
    }

    function _doSurveyPass($obj) {
      if(!$this->isLogged()) return;

      $article_srl = $obj->article_srl;
      if(!$article_srl) return;

      $member_srl = $this->member_srl;

      $log_obj->article_srl = $article_srl;
      $log_obj->member_srl = $member_srl;

      $oDB = &zDB::instance();
      $oDB->insert('survey_log',$log_obj);

      return Zeroboard::getOutput();
    }

    function _doSurvey($obj) {
      if(!$this->isLogged()) return;
      $tmp = explode('|@|', $obj->survey_list);
      for($i=0;$i<count($tmp);$i++) {
        $tmp2 = explode('-',$tmp[$i]);

        $survey_srl = (int)$tmp2[0];
        if(!$survey_srl) continue;

        $survey_selected[$survey_srl] = explode(',',$tmp2[1]);
      }

      $oDB = &zDB::instance();

      $survey_srl = $oDB->addquotes($survey_srl);
      $tmp = $oDB->selectOne('article_srl','survey',"survey_srl='{$survey_srl}'");
      $article_srl = $tmp->article_srl;
      if(!$article_srl) return;

      $member_srl = $oDB->addquotes($this->member_srl);
      $cond_list = array(
            "article_srl='{$article_srl}'",
            "member_srl='{$member_srl}'",
          );
      $cnt = $oDB->getCount('survey_log',$cond_list);
      if($cnt) return Zeroboard::getOutput(-1,$this->lang->common->notice_survey_done);

      $tmp = $oDB->selectOne(array('module_srl','article_srl','survey','use_survey'),'articles',"article_srl='{$article_srl}'");
      if(!$tmp->article_srl||$tmp->use_survey=='N'||!$tmp->survey) return;
      $survey_info = unserialize(base64_decode($tmp->survey));
      $module_srl = $tmp->module_srl;

      $update_cond_list = array();

      for($i=1;$i<=count($survey_info);$i++) {
        $survey_srl = $survey_info[$i]->survey_srl;
        $checkcnt = $survey_info[$i]->checkcnt;
        $items = $survey_info[$i]->item;
        $cnt = $survey_info[$i]->cnt;

        if(count($survey_selected[$survey_srl])>$checkcnt) return;

        $survey_info[$i]->cnt++;
        $survey_cond_list[] = $survey_srl;
        for($j=0;$j<count($survey_selected[$survey_srl]);$j++) $update_cond_list[] = "survey_srl='{$survey_srl}' and listorder = '{$survey_selected[$survey_srl][$j]}'";
      }

      $survey_cond_list = '('.implode(") or (",$survey_cond_list).')';
      $oDB->updatePlus('survey','cnt',$cond_list);

      $cond_list = '('.implode(") or (",$update_cond_list).')';
      $oDB->updatePlus('survey_item','cnt',$cond_list);

      $log_obj->article_srl = $article_srl;
      $log_obj->member_srl = $member_srl;
      $oDB->insert('survey_log',$log_obj);

      $oDB->select('*','survey_item',"article_srl='{$article_srl}'");
      while($tmp = $oDB->fetch()) {
        $survey_srl = $tmp->survey_srl;
        $listorder = $tmp->listorder;
        $cnt = $tmp->cnt;

        for($i=1;$i<=count($survey_info);$i++) {
          if($survey_info[$i]->survey_srl == $survey_srl) $survey_info[$i]->item[$listorder]->cnt = $cnt;
        }
      }

      $query_obj->survey = base64_encode(serialize($survey_info));
      $output = $oDB->update('articles',$query_obj,"article_srl='{$article_srl}'");

      $oPoint = new zPoint($module_srl,$this->member_srl, 'do_poll', $article_srl);
      $oPoint->add_point();

      return Zeroboard::getOutput(0,'success');
    }

    function _removeSurvey($obj) {
      if(!$this->isLogged()) return;

      $oDB = &zDB::instance();

      $article_srl = $oDB->addquotes($obj->article_srl);
      $article = $oDB->selectOne('*','articles',"article_srl='{$article_srl}'");

      if($article->use_survey != 'Y') return;

      $module_srl = $oDB->addquotes($article->module_srl);
      $module_info = $oDB->selectOne('*','module_manager',"module_srl='{$module_srl}'");

      $manager_level = explode('|@|', $module_info->manager_level);

      if($this->inLevels($manager_level)) $manager_enable= true;
      else $manager_enable = false;

      if($article->member_srl != $this->member_srl && !$manager_enable) return;

      $query_obj->use_survey = 'N';
      $query_obj->survey = '';
      $oDB->update('articles',$query_obj,"article_srl='{$article_srl}'");

      $oDB->delete('survey',"article_srl='{$article_srl}'");
      $oDB->delete('survey_item',"article_srl='{$article_srl}'");
      $oDB->delete('survey_log',"article_srl='{$article_srl}'");

      return Zeroboard::getOutput();
    }

    function uploadFile() {
      $file_list = array(
          array('image_nick',100,20),
          array('image_mark',20,20),
          array('profile_image',120,120),
      );

      $oDB = &zDB::instance();

      $member_srl = $oDB->addquotes($_REQUEST['member_srl']);
      if($member_srl != $this->member_srl) return;
      $member_info = $oDB->selectOne(array('member_srl','image_nick','image_mark','profile_image'),'member_list',"member_srl='{$member_srl}'");
      if($member_info->member_srl!=$member_srl) return;

      for($i=0;$i<count($file_list);$i++) {
        $filename = $file_list[$i][0];
        $width = $file_list[$i][1];
        $height = $file_list[$i][2];

        if($_REQUEST['_delete_'.$filename] == 'Y' && $member_info->{$filename}) {
          $query_obj->{$filename}= '';
          zFile::deleteImageFile($member_info->{$filename});
        }
        if($_FILES[$filename]['name'] && $_FILES[$filename]['size']) {
          if($member_info->{$filename}) zFile::deleteImageFile($member_info->{$filename});
          $query_obj->{$filename} = zFile::uploadImage($this->member_srl, $_FILES[$filename], $width, $height);
        }
      }
      $oDB->update('member_list',$query_obj,"member_srl='{$member_srl}'");

      $this->_setSessionInfo();

      $msg = $_REQUEST['_msg'];
      $back_url = $_REQUEST['back_url'];

      return "
          <script type='text/javascript'>
            alert(\"{$msg}\");
            top.location.replace(\"{$back_url}\");
          </script>";
    }

    function _getModuleList($obj) {
      $oDB = &zDB::instance();
      $mid = $oDB->addquotes($obj->mid);

      $oDB->select(array('module_srl','title','access_level','view_level'),'module_manager',array("module_srl!='{$mid}'","node_srl>0"),'module_category_srl');
      while($tmp = $oDB->fetch()) {
        $module_srl = $tmp->module_srl;
        $module_name = $this->lang->common->fld_move_module." - ".$tmp->title;
        $view_level = $tmp->view_level;
        $access_level = $tmp->access_level;

        if(!$view_level && !$access_level) {
          $module_srl_list[] = $module_srl;
          $module_name_list[$module_srl] = $tmp->title;

          $module_list[] = $module_srl.",".$module_name;
        } elseif($this->inLevels($view_level)&&$this->inLevels($access_level)) {
          $module_srl_list[] = $module_srl;
          $module_name_list[$module_srl] = $tmp->title;

          $module_list[] = $module_srl.",".$module_name;
        }
      }

      if($obj->return_type=='object') {
        $output->module_srl_list = $module_srl_list;
        $output->module_name_list = $module_name_list;
        return $output;
      }

      $output = Zeroboard::getOutput();
      $output->srl = $obj->srl;
      $output->module_list = implode('|@|',$module_list);

      return $output;
    }

    function _addSerial($obj) {
      if(!$obj->title) return Zeroboard::getOutput(-1,$this->lang->common->alert_serial_title);

      $oDB = &zDB::instance();
      $title = $oDB->addquotes($obj->title);

      $query_obj->serial_srl = $oDB->getNextSequence();
      $query_obj->member_srl = $this->member_srl;
      $query_obj->title = $title;
      $query_obj->first_article_srl = 0;
      $query_obj->regdate = date("YmdHis");
      $query_obj->listorder = $query_obj->serial_srl*-1;

      $oDB->insert('serial',$query_obj);

      $output = Zeroboard::getOutput();
      $output->serial_srl = $query_obj->serial_srl;
      $output->title = $query_obj->title;

      return $output;
    }

    function _getNewSeq($obj) {
      $oDB = &zDB::instance();
      $output = Zeroboard::getOutput();
      $output->seq = $oDB->getNextSequence();
      return $output; 
    }

    function _deleteFile($obj) {
      $filename = $obj->filename;
      if(!$filename) return Zeroboard::getOutput(0,'fail');

      $oDB = &zDB::instance();
      $filename = $oDB->addquotes($filename);

      $file = $oDB->selectOne(
          array(
            "a.file_srl as file_srl",
            "a.path as file_path",
            "a.filename as filename",
            "a.member_srl as member_srl",
            "a.article_srl as article_srl",
            "a.is_used as is_used",
            "a.ext as ext",
            "b.hostname as hostname",
            "b.port as port",
            "b.path as path",
          ),
          array('file a','server_manager b'),
          array("a.filename = '{$filename}'","a.server_srl = b.server_srl")
      );

      if($this->getMaxLevel()!=ADMINISTRATOR&&$this->member_srl!=$file->member_srl&&$file->filename!=$filename) return Zeroboard::getOutput(0,'fail');

      if(!zFile::deleteFile($file)) return Zeroboard::getOutput(0,'fail');
      $oDB->delete('file',"filename='{$filename}'");
      if($file->is_used == 'Y') {
        $article_srl = $oDB->addquotes($file->article_srl);
        $oDB->updateMinus('article','file_cnt',"article_srl='{$article_srl}'");
      }

      $output = Zeroboard::getOutput(0,'success');
      $output->filename = $filename;
      return $output;
    }

  }
?>
