<?php

  class zModuleManager {

    var $lang = null;

    var $action = 'list';
    var $args = null;

    var $article_srl = 0;
    var $comment_srl = 0;
    var $serial_srl = 0;

    var $module_srl = 0;  
    var $module_info = null;
    var $module = null;  
    var $skin = null;
    var $theme = null;
    var $layout_srl = null;
    var $config = null;

    var $cur_page = null;

    var $st = null;
    var $sc = null;
    var $sw = null;
    var $sg = null;
    var $sa = 'and';
    var $tag = null;
    var $archive = null;
    var $search_keyword = null;
    var $search_kind = null;

    var $sid = null;  
    var $mid = null;  

    var $image_path = '';
    var $tpl_path = '';

    var $is_logged = false;
    var $is_admin = false;
    var $member_srl = null;
    var $member_info = null;

    var $access_level = null;
    var $write_level = null;
    var $view_level = null;
    var $comment_level = null;
    var $survey_level = null;
    var $upload_level = null;
    var $manager_level = null;

    var $access_enable = false;
    var $write_enable = false;
    var $view_enable = false;
    var $comment_enable = false;
    var $survey_enable = false;
    var $upload_enable = false;
    var $serial_enable = false;
    var $manager_enable = false;

    var $max_upload_size = 0;

    var $delete_enable = false;
    var $modify_enable = false;
    var $vote_enable = false;

    var $charset_list = array('UTF-8','EUC-KR','EUC-JP','SHIFT_JIS', 'EUC-CN', 'HZ', 'BIG5');

    function &getInstanceByASrl($article_srl, $module_srl = 0) {
      if(!$article_srl) return;

      $oDB = &zDB::instance();

      $article_srl = $oDB->addquotes($article_srl);
      $article = $oDB->selectOne('module_srl','articles',"article_srl='{$article_srl}'");
      if(!$article->module_srl) return;

      if(!$module_srl) $oModule = &zModuleManager::getInstanceByMid($article->module_srl);
      else $oModule = &zModuleManager::getInstanceByMid($module_srl);

      $oModule->setArticleSrl($article_srl);

      return $oModule;
    }

    function &getInstanceByMid($module_srl) {
      if(!$module_srl) return;

      $oDB = &zDB::instance();
      $module_srl = $oDB->addquotes($module_srl);

      $module_info = $oDB->selectOne('*','module_manager',"module_srl='{$module_srl}'");
      if(!$module_info) return;

      $module = $module_info->module;
      zModuleManager::checkWebServer($module_info->web_server_host);

      $class_file = sprintf("%s%s/module.class.php",MODULE_DIR,$module);
      if(!file_exists($class_file)) return;

      require_once($class_file);

      eval('$oModule = new '.$module.'();');
      $oModule->setModuleInfo($module_info);

      return $oModule;
    }

    function zModuleManager() {
      global $lang;
      $this->lang = &$lang;

      $oDB = &zDB::instance();
      if($this->db_table) $this->db_table = $oDB->zb_prefix.'module_in_'.$this->db_table;
    }

    function setArticleSrl($article_srl) {
      $this->article_srl = $article_srl;
    }

    function setModuleInfo($module_info) {
      $val = unserialize(base64_decode($module_info->val));
      if(count($val)) {

        $module_require_var_file = MODULE_DIR.$module_info->module.'/require.var.php';
        if(file_exists($module_require_var_file)) include $module_require_var_file;
        $skin_require_var_file = MODULE_DIR.$module_info->module.'/skins/'.$module_info->skin.'/require.var.php';
        if(file_exists($skin_require_var_file)) include $skin_require_var_file;

        require_class('zPageManager');
        $oPage = &zPageManager::instance();

        foreach($val as $k => $v) {
          if($module->{$k}['type'] == 'plugin' || $skin->{$k}['type'] == 'plugin') $v = $oPage->getPluginHtml($v);
          $this->config->{$k} = $v;
        }
      }
      unset($module_info->val);
      foreach($module_info as $k => $v) $this->config->{$k} = $v;

      $this->module_info = $module_info;
      $this->module_name = $module_info->title;;
      $this->module_srl = $this->mid = $module_info->module_srl;
      $this->sid = $module_info->node_srl;
      $this->module = $module_info->module;
      $this->skin = $module_info->skin;
      $this->theme = $module_info->theme;
      $this->layout_srl = $module_info->layout_srl;
    }

    function setXmlArgs($obj) {
      $this->action = $obj->action;
      $this->args = $obj;
    }

    function getMid() {
      return $this->mid;
    }

    function getSid() {
      return $this->sid;
    }

    function getLayoutSrl() {
      return $this->layout_srl;
    }

    function proc() {
      $oSvc = &zSvc::instance();
      $this->site_info = $oSvc->getSiteInfo();
      $this->location_history = $oSvc->location_history;
      $this->node_history = $oSvc->node_history;
      $this->selected_menu = $oSvc->selected_menu;

      $this->_setDefaultValue();
      $this->_loadLang();
      $this->_addJsCss();
      $this->_checkLevel();
    }

    function getNodeHistory($module_srl) {
      return $this->node_history[$module_srl];
    }

    function _setDefaultValue() {
      $oMember = &zMember::instance();

      if($oMember->isLogged()) {
        $this->is_logged = true;
        $this->member_srl = $oMember->getMemberSrl();
        $this->member_info = $oMember->getMemberInfo();

        if($oMember->getMaxLevel() == ADMINISTRATOR) $this->is_admin = true;
      }

      $this->access_level = explode('|@|', $this->module_info->access_level);
      $this->write_level = explode('|@|', $this->module_info->write_level);
      $this->view_level = explode('|@|', $this->module_info->view_level);
      $this->comment_level = explode('|@|', $this->module_info->comment_level);
      $this->manager_level = explode('|@|', $this->module_info->manager_level);
      if($this->module_info->survey_level) $this->survey_level = explode('|@|', $this->module_info->survey_level);
      if($this->module_info->upload_level) $this->upload_level = explode('|@|', $this->module_info->upload_level);

      $this->action = $_REQUEST['action']?$_REQUEST['action']:$this->action;
      $this->st = $_REQUEST['st']==='Y'?'Y':null;
      $this->sc = $_REQUEST['sc']==='Y'?'Y':null;
      $this->sw = $_REQUEST['sw']==='Y'?'Y':null;
      $this->sg = $_REQUEST['sg']==='Y'?'Y':null;
      if($this->st!='Y'&&$this->sc!='Y'&&$this->sw!='Y'&&$this->sg!='Y') $this->st = 'Y';
      $this->sa = in_array($_REQUEST['sa'],array('and','or'))?$_REQUEST['sa']:'and';
      $this->search_keyword = $_REQUEST['search_keyword']?trim(stripslashes($_REQUEST['search_keyword'])):null;
      $this->tag = $_REQUEST['tag']?trim(stripslashes($_REQUEST['tag'])):null;
      $this->archive = $_REQUEST['archive']?trim(stripslashes($_REQUEST['archive'])):null;

      $this->article_srl = $_REQUEST['article_srl']?(int)$_REQUEST['article_srl']:$this->article_srl;
      $this->comment_srl = $_REQUEST['comment_srl']?(int)$_REQUEST['comment_srl']:$this->args->comment_srl;
      $this->serial_srl = $_REQUEST['serial_srl']?(int)$_REQUEST['serial_srl']:$this->serial_srl;

      $this->image_path = MODULE_DIR.$this->module.'/skins/'.$this->skin.'/theme/'.$this->theme.'/images/';
      $this->tpl_path = MODULE_DIR.$this->module.'/skins/'.$this->skin.'/tpl/';
      $this->common_tpl_path = COMMON_TPL_DIR;
      $this->xml_url = zUrl::getXmlUrl($this->sid);

      $this->write_url = zUrl::getWriteUrl($this->sid);

      $oDB = &zDB::instance();
      $file_server_srl = $oDB->addquotes($this->module_info->file_server_srl);
      $server = $oDB->selectOne('*','server_manager',"server_srl='{$file_server_srl}'");
      if($server->port!=80) $server->hostname .= ':'.$server->port;
      $this->file_server = sprintf("http://%s%s%s",$server->hostname,$server->path,'file_upload.php');
    }

    function _loadLang() {
      $oSvc = &zSvc::instance();
      $oSvc->addLang(MODULE_DIR.$this->module.'/lang/');
    }

    function _addJsCss() {
      $oSvc = &zSvc::instance();

      $css_file = MODULE_DIR.$this->module.'/skins/'.$this->skin.'/module.css';
      $oSvc->addCssFile($css_file);

      $css_file = MODULE_DIR.$this->module.'/skins/'.$this->skin.'/theme/'.$this->theme.'/module.css';
      $oSvc->addCssFile($css_file);

      $js_file = MODULE_DIR.$this->module.'/skins/'.$this->skin.'/module.js';
      $oSvc->addJsFile($js_file);
    }

    function _checkLevel() {
      $oMember = &zMember::instance();

      if($oMember->getMaxLevel() == ADMINISTRATOR) {
        $this->access_enable = $this->write_enable = $this->view_enable = $this->comment_enable = $this->manager_enable = $this->vote_enable = $this->survey_enable = $this->upload_enable = $this->serial_enable = true;
      } else {
        if($oMember->inLevels($this->access_level)) $this->access_enable = true;
        if($oMember->inLevels($this->write_level)) $this->write_enable = $this->serial_enable = true;
        if($oMember->inLevels($this->view_level)) $this->vote_enable = $this->view_enable= true;
        if($oMember->inLevels($this->comment_level)) $this->comment_enable= true;
        if(count($this->survey_level) && $oMember->inLevels($this->survey_level)) $this->survey_enable = true;
        if(count($this->upload_level) && $oMember->inLevels($this->upload_level)) $this->upload_enable = true;
        if($oMember->inLevels($this->manager_level)) $this->manager_enable= true;
      }
      if($this->manager_enable) $this->lang->common->btn_report = $this->lang->common->btn_manage;
      if(!$this->is_logged) $this->manager_enable = $this->vote_enable = $this->survey_enable = $this->serial_enable = $this->upload_enable = false;
      if($this->upload_enable) $this->max_upload_size = $this->module_info->upload_max_size?$this->module_info->upload_max_size:2;
    }

    function setChildList($child_module_list) {
      $this->child_module_list = $child_module_list;
    }

    function doCheckPassword() {
      if(!$this->args->passwd) return Zeroboard::getOutput(-1,$this->lang->common->alert_require_passwd);

      if($this->args->mode == 'delete_comment') {
        require_class('zComment');
        $oComment = &zComment::instance($this);
        $comment = $oComment->getCommentInfo($this->args->comment_srl);
        $result = strcmp($comment->passwd, md5(trim($this->args->passwd)));
        $session_name = 'check_comments';
        $check_srl = $comment->comment_srl;
      } else {
        require_class('zArticle');
        $oArticle = &zArticle::instance($this);
        $oArticle->getArticle($this->args->article_srl, &$article, &$cur_page);
        
        $result = strcmp($article->passwd, md5(trim($this->args->passwd)));
        $session_name = 'check_articles';
        $check_srl = $article->article_srl;
      }
      if($result!=0) return Zeroboard::getOutput(-1,$this->lang->common->alert_invalid_passwd);

      $check_session = unserialize($_SESSION[$session_name]);
      if(!is_array($check_session)) $check_session = array();
      $check_session[] = $check_srl;
      $_SESSION[$session_name] = serialize($check_session);

      return Zeroboard::getOutput();
    }

    function readTpl($filename) {
      $oSmarty = &zSmarty::instance();
      return $oSmarty->assign_fetch($this->tpl_path.$filename, $this);
    }

    function printDeniedHtml() {
      $this->message_title = $this->lang->common->notice_access_denied_title;
      $this->message_content = $this->lang->common->notice_access_denied_content; 
    }

    function checkWebServer($s_host) {
      if(!eregi("index.php",$_SERVER['SCRIPT_NAME'])&&!eregi("file_upload.php",$_SERVER['SCRIPT_NAME'])) return;
      $hostname = $_SERVER['HTTP_HOST'];
      $port = $_SERVER['SERVER_PORT'];
      if($port!=80) $hostname .= ":{$port}";
      $query_string = $_SERVER['QUERY_STRING'];
      $path = str_replace(array('index.php','file_upload.php'),'',$_SERVER['PHP_SELF']);

      $t_host = sprintf("http://%s%s",$hostname, $path);
      if($t_host!=$s_host) {
        if($query_string) $s_host .= "?{$query_string}";
        header("location:{$s_host}");
        exit();
      }
    }

    function installed() {
      if(!$this->db_table) return true;

      $oDB = &zDB::instance();
      return $oDB->checkTableExists($this->db_table);
    }

    function install() {
      if(!$this->db_table) return Zeroboard::getOutput(-1, $this->lang->admin->notice_index_module_not_to_install);
      if($this->installed()) return Zeroboard::getOutput(-1, $this->lang->admin->notice_index_module_is_installed);

      $oDB = &zDB::instance();

      $schema = zFile::readFile(MODULE_DIR.$this->module."/schema.sql");
      if(!$schema) return Zeroboard::getOutput(-1, $this->lang->admin->notice_index_module_not_find_schema);

      $schema = str_replace('{#TABLE_NAME#}', $oDB->zb_prefix.$this->db_table, $schema);
      $output = $oDB->query($schema);
      if($output->error!=0) return $output;

      if(!$this->installed()) return Zeroboard::getOutput(-1, $this->lang->admin->notice_index_module_cat_not_install);

      return Zeroboard::getOutput(0, 'success');
    }

  }
?>
