<?php

  class zPageManager {

    var $lang = null;

    var $loaded_plugins = array();

    function &instance() {
      if(!$GLOBALS['_PageManager_']) $GLOBALS['_PageManager_'] = new zPageManager();
      return $GLOBALS['_PageManager_'];
    }

    function zPageManager() {
      global $lang;
      $this->lang = &$lang;
    }

    function getPageHtml($page_srl, $no_cache = false) {
      if(!$page_srl) return;

      $oDB = &zDB::instance();
      $oSvc = &zSvc::instance();

      $page_srl = $oDB->addquotes($page_srl);

      $page_info = $oDB->selectOne('*','page_manager',"page_srl='{$page_srl}'");
      if( $no_cache || (($page_info->cache_interval>0 && $page_info->update_date+$page_info->cache_interval*60 < time()) || !$page_info->cache_interval || !$page_info->cache_data) ) {
        $table_list = array('page_plugin a left out join plugin_manager b on a.plugin_srl = b.plugin_srl');
        $cond_list = array("a.page_srl = '{$page_srl}'");
        $plugin_list = $oDB->selectList('*',$table_list, $cond_list,'a.page_plugin_srl','a.page_plugin_srl desc');

        $tpl = '';

        for($i=0;$i<count($plugin_list->list);$i++) {
          $tmp_obj = $plugin_list->list[$i];
          if($tmp_obj->height&&!$tmp_obj->plugin_srl) $height = 'height:'.$tmp_obj->height.'px;';
          else $height = '';
          $tpl .= "<div style=\"width:{$tmp_obj->width};{$height}padding:{$tmp_obj->padding};\" class=\"{$tmp_obj->float}\">".$this->getPluginHtml($tmp_obj->plugin_srl, $no_cache)."</div>";
        }

        $query_obj->cache_data = $tpl;
        $query_obj->update_date = time();
        $oDB->update('page_manager',$query_obj,"page_srl='{$page_srl}'");
      } else {

        $table_list = array(
            'page_plugin a',
            'plugin_manager b'
        );
        $cond_list = array(
            "a.page_srl = '{$page_srl}'",
            "a.plugin_srl = b.plugin_srl"
          );
        $oDB->select(array('b.plugin as plugin','b.theme as theme'),$table_list,$cond_list);
        while($tmp = $oDB->fetch()) {
          $plugin = $tmp->plugin;
          $theme = $tmp->theme;
          if(!$plugin||!$theme) continue;
          $plugin_css_file = sprintf("%s%s/theme/%s/plugin.css",PLUGIN_DIR,$plugin,$theme);
          $oSvc->addCssFile($plugin_css_file);
        }

        $tpl = $page_info->cache_data;
      }

      preg_match_all("!<\!--StyleSheet:.*?-->!is", $tpl, $match);
      if(count($match[0])) {
        $tpl = preg_replace("!<\!--StyleSheet:.*?-->!is", "", $tpl);
        for($i=0;$i<count($match[0]);$i++) {
          $tstr = trim($match[0][$i]);
          $css_file = str_replace(array("<!--StyleSheet:","-->"),"",$tstr);
          $oSvc->addCssFile($css_file);
        }
      }

      return $tpl;
    }

    function getPluginHtml($plugin_srl, $no_cache = false) {
      global $lang;

      if(!$plugin_srl) return;
      $oDB = &zDB::instance();

      $plugin_srl = $oDB->addquotes($plugin_srl);
      $plugin_info = $oDB->selectOne('*','plugin_manager',"plugin_srl = '{$plugin_srl}'");
      $plugin = $plugin_info->plugin;
      $theme = $plugin_info->theme;
      if(!$plugin) return;

      $css_file = sprintf("%s%s/theme/%s/plugin.css",PLUGIN_DIR,$plugin,$theme);
      $oSvc = &zSvc::instance();
      $oSvc->addCssFile($css_file);

      $plugin_js_file = sprintf("%s%s/plugin.js",PLUGIN_DIR,$plugin,$plugin);
      $oSvc->addJsFile($plugin_js_file);

      if( $plugin_info->cache_interval>0 && !$no_cache) {
        if($plugin_info->update_date+$plugin_info->cache_interval*60 < time() || !$plugin_info->cache_data ) {
          $output = $this->_loadPluginHtml($plugin_info);
          $query_obj->cache_data = $oDB->addquotes(base64_encode($output));
          $query_obj->update_date = time();
          $oDB->update("plugin_manager",$query_obj,"plugin_srl = '{$plugin_srl}'");
        } else {
          $output = base64_decode($plugin_info->cache_data);
        }
      } else {
        $output = $this->_loadPluginHtml($plugin_info);
      }

      return $output;

    }

    function _loadPluginHtml($plugin_info) {
      $oSvc = &zSvc::instance();
      $plugin = $plugin_info->plugin;

      if(!array_key_exists($plugin, $this->loaded_plugins)) {

        $oSvc->addLang(PLUGIN_DIR.$plugin.'/lang/');

        $classFile = sprintf("%s%s/%s.class.php",PLUGIN_DIR,$plugin,$plugin);
        if(!file_exists($classFile)) return;

        require_once($classFile);

        $this->loaded_plugins[$plugin] = $pluginObj;

      } else $pluginObj = $this->loaded_plugins[$plugin];

      $plugin_info->info = unserialize(base64_decode($plugin_info->val));

      return $pluginObj->getTpl($plugin_info);
    }

  }

?>
