<?php

  class zSvc extends Zeroboard {

    var $_sid = null;
    var $_mid = null;
    var $_layout_srl = null;
    var $_article_srl = null;

    var $site_keyword = null;
    var $tag = null;
    var $site_sa = 'and';

    var $action = null;
    var $action_list = array(
        'show_info',
        'signup',
        'login',
        'denied',
        'hidden',
        'modify_info',
        'register',
        'find_password',
        'change_passwd',
        'leave_out',
        'message_box',
        'view_info',
        'view_serial',
        'view_articles',
        'search'
      );
    var $action_tpl_file = null;

    var $site_info = null;
    var $menu_list = null;
    var $linear_menu_list = array();
    var $menu_type = null;

    var $selected_menu = null;
    var $selected_layout = null;
    var $layout_menu_list = null;

    var $location_history = array();

    var $oModule = null;
    var $oPage = null;

    var $content = null;

    var $is_logged = false;
    var $member_srl = null;
    var $member_info = null;
    var $member_max_level = 0;
    var $member_point = 0;
    var $new_message = 0;

    var $home_url = null;
    var $signup_url = null;
    var $show_info_url = null;
    var $modify_info_url = null;
    var $find_password_url = null;
    var $message_box_url = null;
    var $back_url = null;

    var $signup_form_list = null;
    
    function &instance() {
      if(!$GLOBALS['_zSvc_']) $GLOBALS['_zSvc_'] = new zSvc();
      return $GLOBALS['_zSvc_'];
    }

    function zSvc () {
      $this->addLang(COMMON_LANG_DIR);
      $this->addLang(FONTLIST_LANG_DIR);

      parent::Zeroboard();

      if(!$this->isInstalled()) {
        require_class("zInstall");
        $zInstall = new zInstall();
        $zInstall->printHtml();
        exit();
      }

      $this->_article_srl = (int)$_REQUEST['article_srl']?(int)$_REQUEST['article_srl']:null;
      $this->_mid = (int)$_REQUEST['mid']?(int)$_REQUEST['mid']:null;
      $this->sid = $this->_sid = (int)$_REQUEST['sid']?(int)$_REQUEST['sid']:null;
      $this->action = in_array($_REQUEST['action'],$this->action_list)?$_REQUEST['action']:null;
      $this->target_srl = (int)$_REQUEST['target_srl']?(int)$_REQUEST['target_srl']:null;

      $this->site_keyword = $_REQUEST['site_keyword']?trim(stripslashes($_REQUEST['site_keyword'])):null;
      $this->site_sa = in_array($_REQUEST['site_sa'],array('and','or'))?$_REQUEST['site_sa']:'and';
      $this->tag = $_REQUEST['tag']?trim(stripslashes($_REQUEST['tag'])):null;

      $this->common_tpl_path = COMMON_TPL_DIR;

    }

    function setSid($sid) {
      $this->_sid = $sid;
    }

    function preProc() {
      $oMember = &zMember::instance();
      if($oMember->isLogged()) {
        $this->is_logged = true;
        $this->member_srl = $oMember->getMemberSrl();
        $this->member_info = $oMember->getMemberInfo();
        $this->member_max_level = $oMember->getMaxLevel();
        $this->member_point = $this->member_info->point;
        $this->new_message = $this->member_info->new_message;
      }

      if($this->action=='message_box'&&!$this->member_srl) unset($this->action);
      if(in_array($this->action, array('view_info','view_serial','view_articles'))&&!$this->target_srl) unset($this->action);
      if($this->_article_srl) $this->oModule = zModuleManager::getInstanceByASrl($this->_article_srl);
      elseif($this->_mid) $this->oModule = zModuleManager::getInstanceByMid($this->_mid);

      if($this->oModule) {
        $this->_mid = $this->oModule->getMid();
        $this->sid = $this->_sid = $this->oModule->getSid();
        $this->_layout_srl = $this->oModule->getLayoutSrl();
      } 

      $this->back_url = zUrl::getBackUrl($this->_sid, $this->articel_srl);
      $this->show_info_url = zUrl::getShowInfoUrl($this->_sid, $this->articel_srl);
      $this->signup_url = $this->modify_info_url = zUrl::getSignupUrl($this->_sid, $this->articel_srl);
      $this->find_password_url = zUrl::getFindPasswordUrl($this->_sid, $this->articel_srl);

      $this->message_box_url = zUrl::getMessageBoxUrl($this->_sid, $this->articel_srl,'');
      $this->message_box_sended_url = zUrl::getMessageBoxUrl($this->_sid, $this->articel_srl, 'sended');
      $this->message_box_keeping_url = zUrl::getMessageBoxUrl($this->_sid, $this->articel_srl, 'keeping');

      $this->view_info_url = zUrl::getViewInfoUrl($this->member_srl);
      $this->view_serial_url = zUrl::getViewSerialUrl($this->target_srl);
      $this->view_articles_url = zUrl::getViewArticlesUrl($this->target_srl);

      require_class('zPageManager');
      $this->oPage = &zPageManager::instance();

      $this->getSiteInfo();

      $this->_getLayoutSrl();

      $this->_getLayoutInfo();

      if($oMember->getMaxLevel() == ADMINISTRATOR) {
        $this->enable_image_nick = $this->enable_image_mark = $this->enable_profile_image = $this->enable_sign = true;
      } else {
        if($oMember->isLevel($this->site_info->use_image_nick)) $this->enable_image_nick = true;
        if($oMember->isLevel($this->site_info->use_image_mark)) $this->enable_image_mark = true;
        if($oMember->isLevel($this->site_info->use_profile_image)) $this->enable_profile_image= true;
        if($oMember->isLevel($this->site_info->use_sign)) $this->enable_sign = true;
      }

      $this->_checkSiteAccess();

      $this->_getMenuList();
      $this->_getSelectedMenuList();
      $this->_checkMenuAccess();
      $this->_makeLocationHistory();
    }

    function proc() {
      $this->preProc();

      $this->_doAction();

      $this->_getModulePageHtml();

      $this->_getLayoutHtml();

      require_class('zAnalytics');
      zAnalytics::record();

      $this->_printHtml();
    }

    function getSiteInfo() {
      if(!$GLOBALS['__SvcSiteInfo']) {
        $oDB = &zDB::instance();
        $GLOBALS['__SvcSiteInfo'] = $oDB->selectOne('*','site_manager');
      }

      return $this->site_info = $GLOBALS['__SvcSiteInfo'];
    }

    function _getLayoutSrl() {
      if($this->_layout_srl) return;

      $oDB = &zDB::instance();
      if($this->_sid) {
        $node_srl = $oDB->addquotes($this->_sid);
        $tmp = $oDB->selectOne('layout_srl','menu_tree',"node_srl='{$node_srl}'");
        if($tmp->layout_srl) $this->_layout_srl = $tmp->layout_srl;
      }

      if(!$this->_layout_srl) $this->_layout_srl = $this->site_info->layout_srl;
    }

    function _getLayoutInfo() {
      if(!$this->_layout_srl) return;

      $oDB = &zDB::instance();
      $layout_srl = $oDB->addquotes($this->_layout_srl);

      $tmp = $oDB->selectOne('*','layout_manager',"layout_srl='{$layout_srl}'");
      $val = unserialize(base64_decode($tmp->val));
      if(count($val)&&$val) foreach($val as $k => $v) $tmp->{$k} = $v;

      $this->selected_layout = $tmp;

      $layout_name = $this->selected_layout->layout;
      @include(LAYOUT_DIR.$layout_name.'/require.var.php');

      foreach($layout as $_key => $_val) {
        if($_val['type']!='menu_list') continue;

        if($val->{$_key}) $this->layout_menu_list->{$_key} = $val->{$_key};
      }
    }

    function _checkSiteAccess() {
      $oMember = &zMember::instance();
      if($oMember->isLevel(ADMINISTRATOR)) return;

      if($this->action) return;

      if($this->site_info->hidden == 'Y') $this->action = 'hidden';
      if(!$oMember->isLevel($this->site_info->access_level)) {
        if(!$oMember->isLogged()) $this->action = 'denied';
        else $this->action = 'login';
      }
    }

    function _getMenuList() {
      if(!$this->layout_menu_list) return;

      $menu_list_obj = zMenu::getMenuList($this->layout_menu_list);

      foreach($menu_list_obj as $menu_name => $val) {
        $menu_srl = $val->menu_srl;
        $tree_list = $val->tree_list;
        $simple_tree_list = $val->simple_tree_list;

        $this->menu_type->{$menu_srl} = $menu_name;
        if(is_array($simple_tree_list)) {
          $this->linear_menu_list += $simple_tree_list;
          $this->{$menu_name} = $simple_tree_list;
        }

        $this->_checkMenuList(&$tree_list, array(), $menu_name);
        $this->menu_list[$menu_name] = $tree_list['list'];
      }
    }

    function _checkMenuList(&$menu, $node_name, $key) {
      if(!count($menu['list'])) return;

      $child_list = array();

      $s_node_name = $node_name;

      foreach($menu['list'] as $srl => $node) {

        $child = array();

        $info = $node['info'];
        $list = $node['list'];

        $oMember = &zMember::instance();
        if($oMember->getMaxLevel() != ADMINISTRATOR && !$oMember->inLevels($info['access_level'])) continue;

        $node_name[$info['module_srl']] = $info['node_name'];

        if($info['show_level'] > $this->member_max_level) {
          unset($menu['list'][$srl]);
          continue;
        }

        if($info['module_srl']) {
          $child[] = $info['module_srl'];
          $this->node_history[$info['module_srl']] = $node_name;
        }

        if(count($list)) {
          $tmp_list = $this->_checkMenuList(&$menu['list'][$srl], $node_name, $key);
          if(count($tmp_list)) $child = array_merge($child,$tmp_list);
        }

        $this->linear_menu_list[$srl]['child_module_list'] = $child;
        $this->{$key}[$srl]['child_module_list'] = $child;
        $menu['list'][$srl]['info']['child_module_list'] = $child;

        $child_list = array_merge($child_list,$child);

        $node_name = $s_node_name;

        $menu['info']['article_cnt'] += $menu['list'][$srl]['info']['article_cnt'];
        $p_node_srl = $menu['info']['node_srl'];
        if($p_node_srl) {
          $this->linear_menu_list[$p_node_srl]['article_cnt'] = 
            $this->{$key}[$p_node_srl]['article_cnt'] = 
            $menu['info']['article_cnt'];
        }
      }

      return $child_list;
    }

    function _getSelectedMenuList() {
      if(!$this->_sid && count($this->menu_list)) {
        foreach($this->menu_list as $_key => $_val) {
          if(count($_val)) foreach($_val as $_k => $_v) {
            $this->_sid = $_k;
            $this->selected_menu = $_v['info'];
            return;
          }
        }
      }
      $this->selected_menu = $this->linear_menu_list[$this->_sid];
    }

    function _checkMenuAccess() {
      $oMember = &zMember::instance();
      if($oMember->isLevel(ADMINISTRATOR)) return true;

      if($this->action) return;

      $hidden = $this->selected_menu['hidden'];
      $show_level = $this->selected_menu['show_level'];
      $access_level = $this->selected_menu['access_level'];
      if($hidden == 'Y'||!$oMember->inLevels($show_level)) $this->action = 'hidden';
      if(!$oMember->inLevels($access_level)) $this->action = 'denied';
      if(!$oMember->isLogged()&&$this->action) $this->action = 'login';
    }

    function _makeLocationHistory() {
      $child = $this->selected_menu;
      while($child['p_node_srl']) {
        array_unshift($this->location_history, $child);
        $child = $this->linear_menu_list[$child['p_node_srl']];
      }
      array_unshift($this->location_history, $child);

      $menu_srl = $this->location_history[0]['menu_srl'];
      $node_srl = $this->location_history[0]['node_srl'];
      $menu_type = $this->menu_type->{$menu_srl};

      $p_obj = &$this->menu_list[$menu_type][$node_srl];
      $p_obj['info']['selected'] = true;
      $this->{$menu_type}[$node_srl]['selected'] = true;

      for($i=1;$i<count($this->location_history);$i++) {
        $node_srl = $this->location_history[$i]['node_srl'];

        $p_obj = &$p_obj['list'][$node_srl];
        $p_obj['info']['selected'] = true;
        $this->{$menu_type}[$node_srl]['selected'] = true;
      }

      $home['node_name'] = $this->lang->common->fld_home;
      $home['node_srl'] = '';
      array_unshift($this->location_history, $home);

      foreach($this->linear_menu_list as $key => $val) {
        $this->home_url = "./?sid=".$key;
        $this->root_sid = $key;
        return;
      }
    }

    function _getModulePageHtml() {
      $oDB = &zDB::instance();

      if($this->action) {
        $this->content = $this->oSmarty->assign_fetch($this->action_tpl_file, $this);
      } else {
        switch($this->selected_menu['menu_type']) {
            case '2' :
                $path = $this->selected_menu['page_path'];
                if(!$path || !file_exists($path) ) break;

                ob_start();
                @include $path;
                $this->content = ob_get_contents();
                ob_end_clean();
              break;
            default :
                if($this->selected_menu['page_srl']) {
                  $this->content = $this->oPage->getPageHtml($this->selected_menu['page_srl']);
                } elseif($this->selected_menu['module_srl']) {
                  if(!$this->oModule) $this->oModule = zModuleManager::getInstanceByMid($this->selected_menu['module_srl']);
                  if(!$this->oModule) return;

                  if($this->selected_menu['use_succession'] == 'Y' && count($this->selected_menu['child_module_list'])>1) 
                    $this->oModule->setChildList($this->selected_menu['child_module_list']);

                  $this->content = $this->oModule->proc();

                  $this->manager_enable = $this->oModule->manager_enable;
                  $this->module_srl = $this->oModule->module_srl;
                  $this->write_enable = $this->oModule->write_enable;
                  $this->write_url = $this->oModule->write_url;
                }
              break;
        }
      }
    }

    function _getLayoutHtml() {
      if(!$this->selected_layout) return;

      $layout_name = $this->selected_layout->layout;
      $theme = $this->selected_layout->theme;
      
      $this->addLang(LAYOUT_DIR.$layout_name.'/lang/');

      @include LAYOUT_DIR.$layout_name.'/require.var.php';

      foreach($layout as $key => $value) {
        if($value['type']=='plugin') {
          $plugin_srl = $this->selected_layout->{$key};
          $this->plugin_list[$key] = $this->oPage->getPluginHtml($plugin_srl);
        }
      }

      $this->image_path = sprintf("%s%s/theme/%s/images/", LAYOUT_DIR, $layout_name, $theme);      

      $layout_tpl = sprintf("%s%s/tpl/layout.tpl",LAYOUT_DIR,$layout_name);
      $this->tpl->content = $this->oSmarty->assign_fetch($layout_tpl, $this);

      $layout_theme_css_file = sprintf("%s%s/theme/%s/layout.css",LAYOUT_DIR,$layout_name,$theme);
      if(file_exists($layout_theme_css_file)) $this->addCssFile($layout_theme_css_file);

      $layout_js_file = sprintf("%s%s/layout.js",LAYOUT_DIR,$layout_name,$layout_name);
      if(file_exists($layout_js_file)) $this->addJsFile($layout_js_file);
    }

    function _doAction() {
      $oDB = &zDB::instance();
      $layout_name = $this->selected_layout->layout;
      switch($this->action) {
        case 'change_passwd' :
            $output = Zeroboard::changePassword();
            $this->message_title = $this->lang->common->fld_change_password_title;
            $this->message_content = $output->message;
            $filename = 'message.tpl';
          break;
        case 'register' :
            $output = Zeroboard::registerUser();
            $this->message_title = $this->lang->common->fld_register_mail_title;
            $this->message_content = $output->message;
            $filename = 'message.tpl';
          break;
        case 'leave_out' :
            if(!$this->member_srl) {
              $this->message_title = $this->lang->common->fld_leave_out_title;
              $this->message_content = $this->lang->common->notice_must_be_login;
              $filename = 'message.tpl';
              break;
            }
            $this->back_url = zUrl::getShowInfoUrl($this->_sid, $this->articel_srl);
            $filename = 'leave_out.tpl';

          break;
        case 'show_info' :
        case 'signup' :
        case 'modify_info' :
            if(!$this->member_srl) {
              $output = $oDB->selectOne('message','site_message',"type='agreement'");
              if($output->message) $this->agreement = $output->message;
            }

            $this->_getSignupFormList();

            $this->member_info = $this->_setExtendsVal($this->member_info);

            if($this->action == 'show_info' && $this->is_logged) {
              $this->leave_out_url = zUrl::getLeaveOutUrl($this->_sid, $this->articel_srl);
              $filename = 'show_info.tpl';
            }
            else {
              if($this->is_logged) $this->back_url = zUrl::getShowInfoUrl($this->_sid, $this->articel_srl);
              else {
                $this->back_url = zUrl::getBackUrl($this->_sid, $this->articel_srl);
                require_class('zImageNumber');
                zImageNumber::setNumber();
                $this->show_image_number = true;
              }
              $filename = 'signup_form.tpl';
            }
          break;
        case 'find_password' :
            $filename = 'find_password.tpl';
          break;
        case 'denied' :
            $filename = 'denied.tpl';
          break;
        case 'hidden' :
            $filename = 'hidden.tpl';
          break;
        case 'login' :
            $filename = 'login.tpl';
          break;
        case 'message_box' :
            require_class('zMessage');
            $oMessage = &zMessage::instance($this);
            $oMessage->getMessageBox(&$this->message_cnt, &$this->message_list, &$this->target_member, &$this->selected_message, &$this->subaction, &$this->source_title, &$this->oPageNav, &$this->mode);
            $this->back_url = zUrl::getBackUrl($this->_sid, $this->articel_srl);
            $filename = 'message_box.tpl';
          break;
        case 'view_info' :
            $target_srl = $oDB->addquotes($_REQUEST['target_srl']);

            $oMember = &zMember::instance();

            $this->_getSignupFormList();

            $tmp = $oDB->selectOne('*','member_list',"member_srl='{$target_srl}'");
            if($this->member_srl != $target_srl && !$oMember->isLevel(ADMINISTRATOR)) unset($tmp->extend_val);
            else $tmp = $this->_setExtendsVal($tmp);
            $tmp->send_message_url = zUrl::getSendMessageUrl($tmp->member_srl, $this->serial_srl);
            $tmp->view_serial_url = zUrl::getViewSerialUrl($tmp->member_srl);
            $tmp->view_articles_url = zUrl::getViewArticlesUrl($tmp->member_srl);

            $tmp_level = zPoint::getLevel($tmp->point);
            $tmp->exp_level = $tmp_level->exp_level;
            $tmp->exp_per = $tmp_level->exp_per;
            $tmp->exp_icon = $tmp_level->exp_icon;
            $this->target_info = $tmp;
            $filename = "view_info.tpl";
          break;
        case 'view_serial' :
            $this->_getSerialList();
            $filename = "view_serial.tpl";
          break;
        case 'view_articles' :
            $this->_viewArticles();
            $filename = "view_articles.tpl";
          break;
        case 'search' :
            $this->_siteSearch();
            $filename = "site_search.tpl";
          break;

      }
      $this->action_tpl_file = sprintf("%s%s/tpl/%s",LAYOUT_DIR,$layout_name,$filename);
    }

    function _getSignupFormList() {
      $oDB = &zDB::instance();
      $output = $oDB->select('*','member_signup_manager',null,'listorder');
      while($tmp = $oDB->fetch()) {
        if(strpos($tmp->value_list,'|@|')) $tmp->value_list = explode('|@|', $tmp->value_list);
        $this->signup_form_list[] = $tmp;
      }
    }
    
    function _setExtendsVal($obj) {
      $extend_val = unserialize(base64_decode($obj->extend_val));
      for($i=0;$i<count($this->signup_form_list);$i++) {
        $signup_obj = $this->signup_form_list[$i];
        $name = $signup_obj->name;
        $type = $signup_obj->type;
        $value = $extend_val->{$name};
        switch($type) {
          case 'phone_number' :
          case 'checkbox' :
              $_exists = false;
              $_val = explode('|@|',$value);
              for($j=0;$j<count($_val);$j++) {
                if($_val[$j]) $_exists = true;
                break;
              }
              if(!$_exists) $_val = null;
              $obj->{$name} = $_val;
            break;
          case 'address' :
              $_val = explode('|@|',$value);
              $obj->{$name} = $_val;
            break;
          default :
              if(!$value) unset($obj->{$name});
              else $obj->{$name} = $value;
            break;
        }
      }
      return $obj;
    }

    function _getTargetInfo($target_srl) {
      if(!$target_srl) return;

      $oDB = &zDB::instance();
      $target_info = $oDB->selectOne('*','member_list',"member_srl='{$target_srl}'");
      if(!$target_info) return;

      $tmp_level = zPoint::getLevel($target_info->point);
      $target_info->exp_level = $tmp_level->exp_level;
      $target_info->exp_per = $tmp_level->exp_per;
      $target_info->exp_icon = $tmp_level->exp_icon;

      $target_info->send_message_url = zUrl::getSendMessageUrl($target_info->member_srl);

      $this->target_info = $target_info;
    }

    function _getGrantedModuleList() {
      $oMember = &zMember::instance();
      $oDB = &zDB::instance();

      foreach($this->linear_menu_list as $k => $v) {
        if($v['module_srl']) $module_srl_list[] = $v['module_srl'];
      }
      if(!count($module_srl_list)) return;
      $module_srls = implode(',',$module_srl_list);
      unset($module_srl_list);
      $oDB->select(array('module_srl','title','access_level','view_level'),'module_manager',"module_srl in ({$module_srls})");
      while($tmp = $oDB->fetch()) {
        if(!$oMember->inLevels($tmp->access_level) || !$oMember->inLevels($tmp->view_level)) continue;

        $module_list[$tmp->module_srl] = $tmp->title;
        $module_srl_list[] = $tmp->module_srl;
      }

      return $module_srl_list;
    }

    function _getSerialList() {
      $target_srl = $this->target_srl;
      $this->_getTargetInfo($target_srl);

      $this->view_info_url = zUrl::getViewInfoUrl($this->target_srl);

      require_class('zSearch');
      $oSearch = new zSearch();
      $oSearch->setMemberSrl($target_srl);
      $output = $oSearch->searchSerial(20,10);

      $this->total_articles = $output->total_articles;
      $this->oPageNav = $output->oPageNav;
      $serial_list = $output->article_list;

      if(count($serial_list)) foreach($serial_list as $_k => $tmp) {
        if($tmp->article_cnt>0) {
          $tmp->url = zUrl::getSerialUrl($tmp->serial_srl, $tmp->first_article_srl);
          $t_obj['serial_srl'] = $tmp->serial_srl;
          $t_obj['article_srl'] = $tmp->first_article_srl;
          $t_obj['action'] = null;
          $tmp->url = zUrl::getUrl($t_obj);
        } else $tmp->url = '';
        $this->serial_list[] = $tmp;
      }
    }

    function _viewArticles() {
      $target_srl = $this->target_srl;
      $this->_getTargetInfo($target_srl);

      $oMember = &zMember::instance();
      $member_obj->return_type = 'object';
      $output = $oMember->proc('get_module_list',$member_obj);
      if(!count($output->module_srl_list)) return;

      $module_srl_list = $output->module_srl_list;
      $module_name_list = $output->module_name_list;

      require_class('zSearch');
      $oSearch = new zSearch();
      $oSearch->setMemberSrl($target_srl);
      $oSearch->setModuleSrlList($module_srl_list);
      $output = $oSearch->searchArticle(20,10);

      $this->total_articles = $output->total_articles;
      $this->oPageNav = $output->oPageNav;
      $article_list = $output->article_list;

      if(count($article_list)) foreach($article_list as $_k => $tmp) {
        $tmp->url = zUrl::getSourceUrl($tmp->article_srl);
        $tmp->module_url = "./?mid={$tmp->module_srl}";
        $tmp->module_name = $module_name_list[$tmp->module_srl];
        $this->article_list[] = $tmp;
      }
    }

    function _siteSearch() {
      if(!$this->site_keyword) return; 

      $module_srl_list = $this->_getGrantedModuleList();

      require_class('zSearch');
      $oSearch = new zSearch();
      $oSearch->setModuleSrlList($module_srl_list);
      $oSearch->setSearchType($this->site_keyword, 'Y', 'Y', 'Y', 'Y', $this->site_sa);
      $output = $oSearch->searchArticle(20, 10);

      $this->total_articles = $output->total_articles;
      $this->oPageNav = $output->oPageNav;
      $article_list = $output->article_list;

      if(count($article_list)) foreach($article_list as $_k => $tmp) {
        $tmp->title = Zeroboard::highlight_keyword($tmp->title, $this->site_keyword);
        $short_str = strip_tags($tmp->article);
        $short_str = str_replace(array('&amp;'), array('&'), $short_str);
        $short_str = Zeroboard::highlight_keyword(Zeroboard::hCutStr($short_str, 400), $this->site_keyword);
        $tmp->article = $short_str;

        $tmp->url = "./?article_srl={$tmp->article_srl}";
        $tmp->module_url = "./?mid={$tmp->module_url}";
        $this->result_list[] = $tmp;
      }
    }

    function _getHtmlLayout() {
      $this->tpl->header = $this->oSmarty->assign_fetch(COMMON_TPL_DIR.'header.tpl', $this);
      $this->tpl->footer = $this->oSmarty->assign_fetch(COMMON_TPL_DIR.'footer.tpl', $this);
    }

    function _printHtml() {
      $this->_getHtmlLayout();
      //print $this->_fixHtml($this->oSmarty->assign_fetch(COMMON_TPL_DIR.'index.tpl', $this));
      print $this->oSmarty->assign_fetch(COMMON_TPL_DIR.'index.tpl', $this);
    }

    function _fixHtml($source) {
      $block_code1 = '@@@ZB:ZEMBED@@@';
      $block_code2 = '@@@ZB:ZEMBED@@@';

      preg_match_all("!<embed[^>]+>.*?</embed>!is", $source, $match);
      $embed_blocks = $match[0];
      $source = preg_replace("!<embed[^>]+>.*?</embed>!is", $block_code1, $source);

      preg_match_all("!<embed[^>]+>!is", $source, $match);
      $embed_blocks_2 = $match[0];
      $source = preg_replace("!<embed[^>]+>!is", $block_code2, $source);

      $this->_replaceHtml($source, $embed_blocks, $block_code1);
      $this->_replaceHtml($source, $embed_blocks_2, $block_code2);

      return $source;
    }

    function _replaceHtml(&$source, $embed_blocks, $block_code) {
      $_len = strlen($block_code);
      $_pos = 0;
      for ($_i=0, $_count=count($embed_blocks); $_i<$_count; $_i++)
          if (($_pos=strpos($source, $block_code, $_pos))!==false)
              $source = substr_replace($source, "<script type='text/javascript'>document.write(\"".str_replace('"','\"',$embed_blocks[$_i])."\");</script>", $_pos, $_len);
          else
              break;
    }

  }
?>
