<?php

  class zTrackBack extends zDocument {

    function &instance($oModule) {
      if(!$GLOBLAS['_zTrackback_']) $GLOBLAS['_zTrackback_'] = new zTrackBack($oModule);
      return $GLOBLAS['_zTrackback_'];
    }

    function zTrackBack($oModule) {
      parent::zDocument($oModule);
    }

    function getTrackbackList($obj, $trackback_list) {
      $oDB = &zDB::instance();
      $article_srl = $oDB->addquotes($obj->article_srl);
      $article = $oDB->selectOne(array('article_srl','member_srl'),'articles',"article_srl='{$article_srl}'");
      if(!$article||!$article->article_srl) return;

      if($this->is_logged && ($article->member_srl == $this->member_srl || $this->oModule->manager_enable)) $delete_enable = true;
      else $delete_enable = false;

      $cond_list = array(
            "article_srl = '{$article_srl}'",
            'listorder < 0',
          );
      $oDB->select('*','trackback',$cond_list,'listorder');

      while($tmp = $oDB->fetch()) {
        $tmp->delete_enable = $delete_enable;
        if(!$tmp->blog_name) $tmp->blog_name = $tmp->url;
        $trackback_list[] = $tmp;
      }
    }

    function deleteTrackback($obj) {
      if(!$obj->trackback_srl || !$obj->article_srl) exit();

      $oDB = &zDB::instance();
      $article_srl = $oDB->addquotes($obj->article_srl);
      $trackback_srl = $oDB->addquotes($obj->trackback_srl);
      $article = $oDB->selectOne('*','articles',"article_srl='{$article_srl}'");

      if(!$this->is_logged && $article->member_srl != $this->member_srl && !$this->oModule->manager_enable) 
        return Zeroboard::getOutput(-1,$this->lang->common->notice_delete_trackback_fail);

      $oDB->delete('trackback',"trackback_srl='{$trackback_srl}'");
      $oDB->updateMinus('articles','trackback_cnt',"article_srl='{$article_srl}'");

      $output = Zeroboard::getOutput();
      $output->module_srl = $this->oModule->module_srl;
      $output->article_srl = $article_srl;
      return $output;
    }

    function addTrackBack() {
      $obj->article_srl = $_REQUEST['article_srl'];
      $obj->url = $_REQUEST['url'];
      $obj->title = $_REQUEST['title'];
      $obj->blog_name = $_REQUEST['blog_name'];
      $obj->excerpt = $_REQUEST['excerpt'];

      if(function_exists('iconv')) $obj = zTrackBack::convertEncoding($obj);
      if(!$obj->article_srl||!$obj->url||!$obj->title||!$obj->excerpt) return Zeroboard::getOutput(1,"Wrong Parameter");

      $oDB = &zDB::instance();

      $article_srl = $oDB->addquotes($obj->article_srl);
      $article = $oDB->selectOne('*','articles',"article_srl='{$article_srl}'");

      if(!$article->article_srl) return Zeroboard::getOutput(1,"Wrong Parameter");
      if($article->allow_trackback!='Y') return Zeroboard::getOutput(1,"error");

      $seq = $oDB->getNextSequence();

      $obj->trackback_srl = $seq;
      $obj->listorder = $seq*-1;
      $obj->regdate = date("YmdHis");

      $output = $oDB->insert('trackback', $obj);
      if($output->error!=0) return Zeroboard::getOutput(1,"System Fault");

      $query_obj->trackback_cnt = $oDB->getCount('trackback', "article_srl = '{$article_srl}'");

      $output = $oDB->update('articles',$query_obj,"article_srl = '{$article_srl}'");
      if($output->error!=0) return Zeroboard::getOutput(1,"System Fault");

      unset($output);
      $output->error = 0;
      return $output;
    }

    function sendTrackBack($trackback_obj, $article) {
      $trackback_address = $trackback_obj->address;
      $short_text = $trackback_obj->short_text;
      $charset = $trackback_obj->charset;

      $oSvc = &zSvc::instance();
      $oSvc->getSiteInfo();

      $http = parse_url($trackback_address);

      $obj->blog_name = $oSvc->site_info->title;
      $obj->title = $article->title;
      $obj->excerpt = $article->summary?$article->summary:($short_text?$short_text:Zeroboard::hCutStr(strip_tags($article->article),256,"..."));
      $obj->url = zUrl::getSourceUrl($article->article_srl);

      if($charset && function_exists('iconv')) {
        foreach($obj as $key=>$val) {
          $obj->{$key} = iconv('UTF-8',$charset,$val);
        }
      }

      if($http['query']) $http['query'].="&";
      if(!$http['port']) $http['port'] = 80;
      $content = 
        sprintf(
          "title=%s&".
          "url=%s&".
          "blog_name=%s&".
          "excerpt=%s",
          urlencode($obj->title),
          urlencode($obj->url),
          urlencode($obj->blog_name),
          urlencode($obj->excerpt)
        );
      if($http['query']) $content .= '&'.$http['query'];

      $content_length = strlen($content);

      $header = 
        sprintf(
          "POST %s HTTP/1.1\r\n".
          "Host: %s\r\n".
          "Content-Type: %s\r\n".
          "Content-Length: %s\r\n\r\n".
          "%s\r\n",
          $http['path'],
          $http['host'],
          "application/x-www-form-urlencoded",
          $content_length,
          $content
        );

      $fp = fsockopen($http['host'], $http['port'], $errno, $errstr, 5);
      if(!$fp) return;

      fputs($fp, $header);

      while(!feof($fp)) {
        $line = trim(fgets($fp, 4096));
        if(eregi("^<error>",$line)) break;
      }

      fclose($fp);

    }

    function convertEncoding($obj) {
      $charset_list = array(
        'UTF-8', 'EUC-KR', 'CP949', 'ISO-8859-1', 'EUC-JP', 'SHIFT_JIS', 'CP932',
        'EUC-CN', 'HZ', 'GBK', 'GB18030', 'EUC-TW', 'BIG5', 'CP950', 'BIG5-HKSCS',
        'ISO-2022-CN', 'ISO-2022-CN-EXT', 'ISO-2022-JP', 'ISO-2022-JP-2', 'ISO-2022-JP-1',
        'ISO-8859-6', 'ISO-8859-8', 'JOHAB', 'ISO-2022-KR', 'CP1255', 'CP1256', 'CP862',
        'ASCII', 'ISO-8859-1', 'ISO-8850-2', 'ISO-8850-3', 'ISO-8850-4', 'ISO-8850-5',
        'ISO-8850-7', 'ISO-8850-9', 'ISO-8850-10', 'ISO-8850-13', 'ISO-8850-14',
        'ISO-8850-15', 'ISO-8850-16', 'CP1250', 'CP1251', 'CP1252', 'CP1253', 'CP1254',
        'CP1257', 'CP850', 'CP866',
      );

      for($i=0;$i<count($charset_list);$i++) {
        $charset = $charset_list[$i];

        $flag = true;
        foreach($obj as $key=>$val) {
          if($val && !iconv($charset,'UTF-8',$val)) $flag = false;
        }

        if($flag == true) {
          foreach($obj as $key => $val) $obj->{$key} = iconv($charset,'UTF-8',$val);
          return $obj;
        }
      }
    }

  }

?>
