<?php

  class zUrl {

    var $uri = null;
    var $args = array();

    function &instance() {
      if(!$GLOBALS['_zUrl_']) $GLOBALS['_zUrl_'] = new zUrl();
      return $GLOBALS['_zUrl_'];
    }

    function zUrl() {
      $query = $_SERVER['QUERY_STRING'];
      if(!$query) return;

      $args = explode('&', $query);
      foreach($args as $q) {
        list($key, $val) = explode('=',$q);
        if(!$val) continue;
        $this->args[$key] = $val;
      }

      $this->uri = str_replace('index.php','',$_SERVER['SCRIPT_NAME']);
    }

    function getNewUrl($obj = null) {
      $args = array_merge($this->args, $obj);
      if(count($args)) {
        foreach($args as $key => $val) if($val) $output[] = sprintf("%s=%s",$key,$val);
        if(count($output)) $args_list = '?'.implode('&amp;',$output);
      }
      return sprintf("%s%s", $this->uri, $args_list);
    }

    function getUrl($obj = null) {
      $oUrl = &zUrl::instance();
      return $oUrl->getNewUrl($obj);
    }

    function getSignUpRegisterUrl($obj) {
      $oDB = &zDB::instance();

      $member_srl = $oDB->addquotes($obj->member_srl);

      $auth = $oDB->selectOne('*','member_mail',array("member_srl='{$member_srl}'","type='register'"));

      if(!$auth->key) {
        $key = $query_obj->key = md5(uniqid(rand(),true));
        $query_obj->member_srl = $obj->member_srl;
        $query_obj->type = 'register';
        $query_obj->regdate = date("YmdHis");
        $oDB->insert('member_mail',$query_obj);
      } else $key = $auth->key;

      $hostname = $_SERVER['SERVER_NAME'];
      $port = $_SERVER['SERVER_PORT'];
      if($port!=80) $hostname .= ":{$port}";
      $path = str_replace('server.php','',$_SERVER['PHP_SELF']);

      return sprintf("http://%s%s?action=%s&amp;key=%s", $hostname, $path, 'register', $key);
    }

    function getFindPasswdUrl($obj) {
      $oDB = &zDB::instance();

      $member_srl = $oDB->addquotes($obj->member_srl);

      $auth = $oDB->selectOne('*','member_mail',array("member_srl='{$member_srl}'","type='change_passwd'"));
      if(!$auth->key) {
        $key = $query_obj->key = md5(uniqid(rand(),true));
        $new_password = $query_obj->new_password = rand(100000,999999);
        $query_obj->member_srl = $obj->member_srl;
        $query_obj->type = 'change_passwd';
        $query_obj->regdate = date("YmdHis");
        $oDB->insert('member_mail',$query_obj);
      } else {
        $key = $auth->key;
        $new_password = $auth->new_password;
      }

      $hostname = $_SERVER['SERVER_NAME'];
      $port = $_SERVER['SERVER_PORT'];
      if($port!=80) $hostname .= ":{$port}";
      $path = str_replace('server.php','',$_SERVER['PHP_SELF']);

      $output->auth_link = sprintf("http://%s%s?action=%s&amp;key=%s", $hostname, $path, 'change_passwd', $key);
      $output->new_password = $new_password;

      return $output;
    }

    function getListUrl($sid = null, $serial_srl = null, $cur_page = null) {
      $t_obj['sid'] = $sid;
      $t_obj['comment_srl'] = null;
      $t_obj['article_srl'] = null;
      $t_obj['action'] = null;
      $t_obj['serial_srl'] = $serial_srl;
      if($cur_page) $t_obj['page'] = $cur_page;

      return zUrl::getUrl($t_obj);
    }

    function getWriteUrl($sid, $cur_page = null) {
      if($cur_page) $t_obj['page'] = $cur_page;
      $t_obj['article_srl'] = null;
      $t_obj['comment_srl'] = null;
      $t_obj['sid'] = $sid;
      $t_obj['action'] = 'write';
      return zUrl::getUrl($t_obj);
    }

    function getViewUrl($article_srl, $sid = null, $serial_srl = null, $cur_page = null) {
      $t_obj['action'] = null;
      $t_obj['sid'] = $sid;
      $t_obj['comment_srl'] = null;
      $t_obj['article_srl'] = $article_srl;
      $t_obj['serial_srl'] = $serial_srl;
      if($cur_page) $t_obj['page'] = $cur_page;
      $url = zUrl::getUrl($t_obj);
      return $url;
    }

    function getModifyUrl($article_srl, $sid = null, $serial_srl = null, $cur_page = null) {
      $t_obj['sid'] = $sid;
      $t_obj['action'] = 'modify';
      $t_obj['comment_srl'] = null;
      $t_obj['article_srl'] = $article_srl;
      $t_obj['serial_srl'] = $serial_srl;
      if($cur_page) $t_obj['page'] = $cur_page;
      return zUrl::getUrl($t_obj);
    }

    function getDeleteCommentUrl($sid, $article_srl, $comment_srl, $serial_srl = null, $cur_page = null) {
      $t_obj['sid'] = $sid;
      $t_obj['action'] = 'delete_comment';
      $t_obj['article_srl'] = $article_srl;
      $t_obj['comment_srl'] = $comment_srl;
      $t_obj['serial_srl'] = $serial_srl;
      if($cur_page) $t_obj['page'] = $cur_page;
      return zUrl::getUrl($t_obj);
    }

    function getDeleteUrl($article_srl, $sid = null, $serial_srl = null, $cur_page = null) {
      $t_obj['sid'] = $sid;
      $t_obj['action'] = 'delete';
      $t_obj['article_srl'] = $article_srl;
      $t_obj['comment_srl'] = null;
      $t_obj['serial_srl'] = $serial_srl;
      if($cur_page) $t_obj['page'] = $cur_page;
      return zUrl::getUrl($t_obj);
    }

    function getSerialUrl($serial_srl, $article_srl = null, $sid = null) {
      $t_obj['sid'] = $sid;
      $t_obj['action'] = null;
      $t_obj['article_srl'] = $article_srl;
      $t_obj['comment_srl'] = null;
      $t_obj['article_srl'] = null;
      $t_obj['page'] = null;
      $t_obj['search_keyword'] = null;
      $t_obj['serial_srl'] = $serial_srl;
      return zUrl::getUrl($t_obj);
    }

    function getOtherSerialUrl($article_srl) {
      $t_obj['article_srl'] = $article_srl;
      $t_obj['search_keyword'] = null;
      $t_obj['page'] = null;
      $url = zUrl::getUrl($t_obj);
      return $url;
    }

    function getVoteUrl($module_srl, $article_srl) {
      return "javascript:svc_vote('{$module_srl}','{$article_srl}')";
    }

    function getSendMessageUrl($member_srl, $serial_srl = null) {
      $oMember = &zMember::instance();
      if($oMember->member_srl) {
        $t_obj['target_srl'] = $member_srl;
        $t_obj['action'] = 'message_box';
        $t_obj['sub_action'] = 'none';
        $t_obj['serial_srl'] = $serial_srl;
      } else {
        $t_obj['target_srl'] = $member_srl;
        $t_obj['action'] = 'view_info';
        $t_obj['sub_action'] = 'none';
        $t_obj['serial_srl'] = $serial_srl;
      }
      return zUrl::getUrl($t_obj);
    }

    function getMemberInfoUrl($member_srl,$serial_srl = null, $article_srl = null) {
      $t_obj['article_srl'] = $article_srl;
      $t_obj['target_srl'] = $member_srl;
      $t_obj['action'] = 'view_info';
      $t_obj['sub_action'] = 'none';
      $t_obj['serial_srl'] = $serial_srl;
      return zUrl::getUrl($t_obj);
    }

    function getTrackbackUrl($article_srl) {
      $hostname = $_SERVER['SERVER_NAME'];
      $port = $_SERVER['SERVER_PORT'];
      if($port!=80) $hostname .= ":{$port}";
      $path = $_SERVER['REDIRECT_URL']?$_SERVER['REDIRECT_URL']:preg_replace('/([a-zA-Z0-9\_]+).php/i','',$_SERVER['PHP_SELF']);
      
      return sprintf("http://%s%strackback.php?article_srl=%d",$hostname,$path,$article_srl);
    }

    function getXmlUrl($sid) {
      $hostname = $_SERVER['SERVER_NAME'];
      $port = $_SERVER['SERVER_PORT'];
      if($port!=80) $hostname .= ":{$port}";
      $path = $_SERVER['REDIRECT_URL'];
      $path = $_SERVER['REDIRECT_URL']?$_SERVER['REDIRECT_URL']:preg_replace('/([a-zA-Z0-9\_]+).php/i','',$_SERVER['PHP_SELF']);
      
      return sprintf("http://%s%sxml.php?sid=%d",$hostname,$path,$sid);
    }

    function getModuleUrl($module_srl) {
      $hostname = $_SERVER['SERVER_NAME'];
      $port = $_SERVER['SERVER_PORT'];
      if($port!=80) $hostname .= ":{$port}";
      $path = $_SERVER['REDIRECT_URL']?$_SERVER['REDIRECT_URL']:preg_replace('/([a-zA-Z0-9\_]+).php/i','',$_SERVER['PHP_SELF']);
      
      return sprintf("http://%s%s?mid=%d",$hostname,$path,$module_srl);
    }

    function getSourceUrl($article_srl) {
      $hostname = $_SERVER['SERVER_NAME'];
      $port = $_SERVER['SERVER_PORT'];
      if($port!=80) $hostname .= ":{$port}";
      $path = $_SERVER['REDIRECT_URL']?$_SERVER['REDIRECT_URL']:preg_replace('/([a-zA-Z0-9\_]+).php/i','',$_SERVER['PHP_SELF']);
      
      return sprintf("http://%s%s?article_srl=%d",$hostname,$path,$article_srl);
    }

    function getViewInfoUrl($target_srl) {
      $t_obj['target_srl'] = $target_srl;
      $t_obj['action'] = 'view_info';
      $t_obj['sub_action'] = 'none';
      return zUrl::getUrl($t_obj);
    }

    function getLeaveOutUrl($sid, $article_srl) {
      $t_obj['sid'] = $sid;
      $t_obj['article_srl'] = $article_srl;
      $t_obj['action'] = 'leave_out';
      return zUrl::getUrl($t_obj);
    }

    function getBackUrl($sid, $article_srl) {
      $t_obj['sid'] = $sid;
      $t_obj['article_srl'] = $article_srl;
      $t_obj['action'] = null;
      $t_obj['target_srl'] = null;
      $t_obj['sub_action'] = null;
      return zUrl::getUrl($t_obj);
    }

    function getShowInfoUrl($sid, $article_srl) {
      $t_obj['sid'] = $sid;
      $t_obj['article_srl'] = $article_srl;
      $t_obj['action'] = 'show_info';
      $t_obj['target_srl'] = null;
      return zUrl::getUrl($t_obj);
    }

    function getSignupUrl($sid, $article_srl) {
      $t_obj['sid'] = $sid;
      $t_obj['article_srl'] = $article_srl;
      $t_obj['action'] = 'signup';
      return zUrl::getUrl($t_obj);
    }

    function getFindPasswordUrl($sid, $article_srl) {
      $t_obj['sid'] = $sid;
      $t_obj['article_srl'] = $article_srl;
      $t_obj['action'] = 'find_password';
      return zUrl::getUrl($t_obj);
    }

    function getMessageBoxUrl($sid = null, $article_srl = null, $mode = null) {
      $t_obj['sid'] = $sid;
      $t_obj['article_srl'] = $article_srl;
      $t_obj['action'] = 'message_box';
      $t_obj['mode'] = $mode;
      $t_obj['sub_action'] = null;
      $t_obj['target_srl'] = null;
      $t_obj['message_srl'] = null;
      $t_obj['s_message_srl'] = null;
      $t_obj['page'] = null;
      return zUrl::getUrl($t_obj);
    }

    function getReadMessageUrl($message) {
      $t_obj['message_srl'] = $message->message_srl;
      $t_obj['s_message_srl'] = null;
      $t_obj['target_srl'] = null;
      return zUrl::getUrl($t_obj);
    }

    function getReplyMessageUrl($message) {
      if($message->message_type == 'S') $t_obj['target_srl'] = $message->receiver_srl;
      else $t_obj['target_srl'] = $message->sender_srl;
      $t_obj['s_message_srl'] = $message->message_srl;
      $t_obj['message_srl'] = null;
      return zUrl::getUrl($t_obj);
    }

    function getViewSerialUrl($member_srl = null) {
      $oMember = &zMember::instance();

      if(!$member_srl && !$oMember->member_srl) return;
      if(!$member_srl) $member_srl = $oMember->member_srl;
      $t_obj['target_srl'] = $member_srl;
      $t_obj['action'] = 'view_serial';
      return zUrl::getUrl($t_obj);
    }

    function getViewArticlesUrl($member_srl = null) {
      $oMember = &zMember::instance();

      if(!$member_srl && !$oMember->member_srl) return;
      if(!$member_srl) $member_srl = $oMember->member_srl;
      $t_obj['target_srl'] = $member_srl;
      $t_obj['action'] = 'view_articles';
      return zUrl::getUrl($t_obj);
    }

    function getTagUrl($tag, $sid) {
      $t_obj['tag'] = urlencode($tag);
      $t_obj['sid'] = $sid;
      $t_obj['search_keyword'] = null;
      $t_obj['sg'] = null;
      $t_obj['sa'] = null;
      $t_obj['st'] = null;
      $t_obj['sc'] = null;
      $t_obj['sw'] = null;
      $t_obj['article_srl'] = null;
      $t_obj['action'] = null;
      $t_obj['serial_srl'] = null;
      $t_obj['target_srl'] = null;
      $t_obj['message_srl'] = null;
      $t_obj['s_message_srl'] = null;

      return zUrl::getUrl($t_obj);
    }

  }
?>
