var _zLayerMainID = 'zone_page_main_default';
var _zLayerTmpObject = Array();
var _zLayerMovObject = Array();
var _zLayerDragManager = {obj:null, isDrag:false}
var _zLayerDsa = 0;
var _zNullSrl = 0;

function zLayerGetID(srl) {
    if(srl==0) {
        _zNullSrl ++;
        return "zNullLayer_"+_zNullSrl;
    }
    return "zLayer_"+srl;
}


function zLayerAddObject(srl, params) {
    var main_obj = xGetElementById(_zLayerMainID);
    var obj = null;

    var id = zLayerGetID(srl);

    if(xGetElementById(id)) obj = xGetElementById(id);
    else obj = xCreateElement("DIV");
    obj.id = id;
    obj.style.width = params['div_width'];
    if(params['div_height']) obj.style.height = params['div_height'];
    obj.style.position = 'relative';
    obj.style.display = 'block';
    obj.style.borderStyle = 'dotted';
    obj.style.borderWidth = '1px';

    if(srl<1) obj.style.borderColor = '#888888';
    else obj.style.borderColor = '#A9DA12';

    switch(params['div_float']) {
        case 'right' :
                obj.className = 'zFloatRight';
            break;
        case 'left' :
                obj.className = 'zFloatLeft';
            break;
    }

    xInnerHtml(obj, params['tpl']);

    _zLayerMovObject[id] = obj;
    zLayerCreateTmpObject(obj);

    if(!xGetElementById(id)) main_obj.parentNode.insertBefore(obj, main_obj);

    var padding = params['div_padding'].split(' ');
    var paddingTop = typeof(padding[0])!='undefined'?padding[0]:'0px';
    var paddingRight = typeof(padding[1])!='undefined'?padding[1]:'0px';
    var paddingBottom = typeof(padding[2])!='undefined'?padding[2]:'0px';
    var paddingLeft = typeof(padding[3])!='undefined'?padding[3]:'0px';

    obj.style.paddingTop = paddingTop;
    obj.style.paddingRight = paddingRight;
    obj.style.paddingBottom = paddingBottom;
    obj.style.paddingLeft = paddingLeft;

    if(params['div_width_type']!='%') xWidth(obj, xWidth(obj.lastChild));
    //if(params['div_height']) xHeight(obj, params['div_height']);
    if(xHeight(obj.lastChild)>xHeight(obj)) xHeight(obj,xHeight(obj.lastChild));
}

function zLayerRemoveObject(obj) {
    var id = obj.id;
    xInnerHtml(obj,'');
    if(xIE4Up) {
        obj.removeNode(true);
    } else {
        obj.style.display = 'none';
    }
    _zLayerMovObject[id] = _zLayerTmpObject[id] = null;
}

function zLayerCreateTmpObject(obj) {
    var tmp_obj = _zLayerTmpObject[obj.id];
    if(tmp_obj) return;

    tmp_obj = xCreateElement('DIV');
    tmp_obj.id = obj.id + '_tmp';
    tmp_obj.style.display = 'none';
    tmp_obj.style.position = 'absolute';
    tmp_obj.style.backgroundColor = '#FFFFFF';
    tmp_obj.style.opacity = 0.9;
    tmp_obj.style.filter = 'alpha(opacity=90)';
    document.body.appendChild(tmp_obj);
    _zLayerTmpObject[obj.id] = tmp_obj;
}

function zLayerGetTmpObject(obj) {
    var tmp_obj = _zLayerTmpObject[obj.id];
    if(!tmp_obj) tmp_obj = zLayerCreateTmpObject(obj);
    return tmp_obj;
}

function zLayerDragEnable(child_obj, funcDragStart, funcDrag, funcDragEnd) {
    var obj = child_obj.parentNode.parentNode;
    obj.xDraggable = true;
    obj.xDragStart = funcDragStart;
    obj.xDrag = funcDrag;
    obj.xDragEnd = funcDragEnd;

    xAddEventListener(obj, 'mousedown', zLayerDragMouseDown, false);

    if (!_zLayerDragManager.isDrag) {
      _zLayerDragManager.isDrag = true;
      xAddEventListener(document, 'mousemove', zLayerDragMouseMove, false);
    }
}

function zLayerDragDisable(id, last) {
    if (!_zLayerDragManager) return;
    var obj = xGetElementById(id);
    obj.xDraggable = false;
    obj.xDragStart = null;
    obj.xDrag = null;
    obj.xDragEnd = null;

    xRemoveEventListener(obj, 'mousedown', zLayerDragMouseDown, false);

    if (_zLayerDragManager.isDrag && last) {
      _zLayerDragManager.isDrag = false;
      xRemoveEventListener(document, 'mousemove', zLayerDragMouseMove, false);
    }
}

function zLayerDragMouseDown(e) {
    var evt = new xEvent(e);
    var obj = evt.target;

    while(obj && !obj.xDraggable) {
        obj = xParent(obj, true);
    }

    if(obj) {
      xPreventDefault(e);
      obj.xDPX = evt.pageX;
      obj.xDPY = evt.pageY;
      _zLayerDragManager.obj = obj;
      xAddEventListener(document, 'mouseup', zLayerDragMouseUp, false);
      if (obj.xDragStart) obj.xDragStart(obj, evt.pageX, evt.pageY);
    }
}

function zLayerDragStart(tobj, px, py) {
    var obj = zLayerGetTmpObject(tobj);

    xInnerHtml(obj, xInnerHtml(tobj));
    xInnerHtml(tobj,'');

    xLeft(obj, xPageX(tobj));
    xTop(obj, xPageY(tobj));
    xWidth(obj, xWidth(tobj));
    xHeight(obj, xHeight(tobj));

    xDisplay(obj, 'block');
    xHeight(tobj, xHeight(obj));
    tobj.style.borderStyle = 'dotted';
    tobj.style.borderWidth = '1px';
    tobj.style.borderColor = '#CF1111';
}

function zLayerDragMouseMove(e) {
    var evt = new xEvent(e);

    if (_zLayerDragManager.obj) {
      xPreventDefault(e);

      var obj = _zLayerDragManager.obj;
      var dx = evt.pageX - obj.xDPX;
      var dy = evt.pageY - obj.xDPY;

      obj.xDPX = evt.pageX;
      obj.xDPY = evt.pageY;

      if (obj.xDrag) {
        obj.xDrag(obj, dx, dy);
      } else {
        xMoveTo(obj, xLeft(obj) + dx, xTop(obj) + dy);
      }
    }
}

function zLayerDragMouseUp(e) {
    if (_zLayerDragManager.obj) {
      xPreventDefault(e);
      xRemoveEventListener(document, 'mouseup', zLayerDragMouseUp, false);

      if (_zLayerDragManager.obj.xDragEnd) {
        var evt = new xEvent(e);
        _zLayerDragManager.obj.xDragEnd(_zLayerDragManager.obj, evt.pageX, evt.pageY);
      } 
      _zLayerDragManager.obj = null;
    }
}

function zLayerDrag(tobj, dx, dy) {
  var obj = zLayerGetTmpObject(tobj);
  xLeft(obj, parseInt(xPageX(obj)) + parseInt(dx));
  xTop(obj, parseInt(xPageY(obj)) + parseInt(dy));
  for(var i in _zLayerMovObject) {
      var obj = xGetElementById(_zLayerMovObject[i]);
      var l =  xPageX(obj);
      var t =  xPageY(obj);
      var ll =  parseInt(l) + parseInt(xWidth(obj));
      var tt =  parseInt(t) + parseInt((parseInt(xHeight(obj)) <= parseInt(xHeight(tobj))) ? parseInt(xHeight(obj)) : parseInt(xHeight(tobj)));

      if((tobj != obj ) && (tobj.xDPX >= l && tobj.xDPX <= ll) && (tobj.xDPY >= t && tobj.xDPY <= tt)) {
        if(obj.nextSibling == tobj || obj.id.slice(0,4) == 'col_') {
            obj.parentNode.insertBefore(tobj, obj);
        } else {
            obj.parentNode.insertBefore(tobj, obj.nextSibling);
        }
      }
  }
}

function zLayerDragEnd(tobj, px, py) {
    var obj = zLayerGetTmpObject(tobj);
    tobj.style.borderStyle = 'dotted';
    tobj.style.borderWidth = '1px';
    if(/zNullLayer_/i.test(tobj.id)) tobj.style.borderColor = '#888888';
    else tobj.style.borderColor = '#A9DA12';
    _zLayerDsa = zLayerDisapearTmpObject(obj,tobj);
    zLayerDragDisable(tobj.id);
}

function zLayerDisapearTmpObject(obj, tobj) {
  var it = 150;
  var ib = 15;

  var x = parseInt(xPageX(obj));
  var y = parseInt(xPageY(obj));
  var ldt = (x - parseInt(xPageX(tobj))) / ib;
  var tdt = (y - parseInt(xPageY(tobj))) / ib;

  return setInterval(function() {
          if(ib < 1) {
              clearInterval(_zLayerDsa);
              xInnerHtml(tobj,xInnerHtml(obj));
              xInnerHtml(obj,'');
              xDisplay(obj, 'none');
              return;
          }
          ib -= 5;
          x-=ldt;
          y-=tdt;
          xLeft(obj, x);
          xTop(obj, y);
      }, it/ib);
}
