function zXml() {
    this.obj_xmlHttp = null;
    this.method_name = null;
    this.base64_keystr = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";

    this.xml_path = "./server.php";

    this.params = new Array();

    this.reset = zXmlReset;
    this.getXmlHttp = zGetXmlHttp;
    this.request = zXmlRequest;
    this.setPath = zXmlSetPath;
    this.setMethod = zXmlSetMethod;
    this.addParam = zXmlAddParam;
    this.base64Encode = zXmlBase64Encode;
    this.base64Decode = zXmlBase64Decode;
    this.getResponseXml = zXmlGetResponseXML;
    this.toZMsgObject = zXmlToZMsgObject;

    this.obj_xmlHttp = this.getXmlHttp();
}

function zGetXmlHttp() {
    if (window.XMLHttpRequest) return new XMLHttpRequest();
    else if (window.ActiveXObject) {
        try {
            return new ActiveXObject("Msxml2.XMLHTTP");
        } catch (e) {
            return new ActiveXObject("Microsoft.XMLHTTP");
        }
    }       
    return null;
}

function zXmlRequest(callBackFunc, xmlObj, callBackFunc2, response_tags, callback_func_arg) {

    var rd = "";
    rd += "<?xml version=\"1.0\" encoding=\"utf-8\" ?>\n"
       +  "<methodCall>\n"
       +  "<methodName>"+this.method_name+"</methodName>\n";
       +  "<params>\n"

    for (var key in this.params) {
        var val = this.params[key];
        rd += "<"+key+"><![CDATA["+val+"]]></"+key+">\n";
    }

    
    rd += "</params>\n"
       +  "</methodCall>\n";
    if(this.obj_xmlHttp.readyState!=0) {
        this.obj_xmlHttp.abort();
        this.obj_xmlHttp = this.getXmlHttp();
    }
    this.obj_xmlHttp.onreadystatechange = function () {callBackFunc(xmlObj, callBackFunc2, response_tags, callback_func_arg)};
    this.obj_xmlHttp.open('POST', this.xml_path, true);
    this.obj_xmlHttp.send(rd);
}

function zXmlSetPath(path) {
    this.xml_path = "./"+path;
}

function zXmlSetMethod(method_name) {
    this.method_name = method_name;
}

function zXmlReset() {
    this.obj_xmlHttp = this.getXmlHttp();
    this.params = new Array();
}

function zXmlAddParam(key, val) {
    this.params[key] = val;
}

function zXmlGetResponseXML() {
    if(this.obj_xmlHttp && this.obj_xmlHttp.readyState == 4 && xDef(this.obj_xmlHttp.responseXML)) {
        var xmlDoc = this.obj_xmlHttp.responseXML;
        this.reset();
        return xmlDoc;
    }
    return null;
}

function zXmlToZMsgObject(xmlDoc, tags) {
    if(!xmlDoc) return null;
    if(!tags) {
        tags = new Array('error','message');
    }
    var obj_ret = new Array();
    for(var i=0; i<tags.length; i++) {
        try {
            obj_ret[tags[i]] = xmlDoc.getElementsByTagName(tags[i])[0].firstChild.nodeValue;
        } catch(e) {
            obj_ret[tags[i]] = 0;
        }
    }
    return obj_ret;
}

function zXmlBase64Encode(input) {
    var output = "";
    var chr1, chr2, chr3;
    var enc1, enc2, enc3, enc4;
    var i = 0;

    do {
        chr1 = input.charCodeAt(i++);
        chr2 = input.charCodeAt(i++);
        chr3 = input.charCodeAt(i++);

        enc1 = chr1 >> 2;
        enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
        enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
        enc4 = chr3 & 63;

        if (isNaN(chr2)) {
            enc3 = enc4 = 64;
        } else if (isNaN(chr3)) {
            enc4 = 64;
        }

        output = output + this.base64_keystr.charAt(enc1) + this.base64_keystr.charAt(enc2) +
            this.base64_keystr.charAt(enc3) + this.base64_keystr.charAt(enc4);

   } while (i < input.length);

   return output;
}

function zXmlBase64Decode(input) {
    var output = "";
    var chr1, chr2, chr3;
    var enc1, enc2, enc3, enc4;
    var i = 0;

    input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");

    do {
        enc1 = this.base64_keystr.indexOf(input.charAt(i++)); 
        enc2 = this.base64_keystr.indexOf(input.charAt(i++));
        enc3 = this.base64_keystr.indexOf(input.charAt(i++));
        enc4 = this.base64_keystr.indexOf(input.charAt(i++));

        chr1 = (enc1 << 2) | (enc2 >> 4);
        chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
        chr3 = ((enc3 & 3) << 6) | enc4;

        output = output + String.fromCharCode(chr1);

        if (enc3 != 64)
            output = output + String.fromCharCode(chr2);
        if (enc4 != 64)
            output = output + String.fromCharCode(chr3);

    } while (i < input.length);

   return output;
}

