CREATE TABLE `{#ZB_PREFIX#}layout_manager` (
  `layout_srl` int(11) NOT NULL,
  `title` varchar(255) collate utf8_general_ci NOT NULL default '',
  `comment` text collate utf8_general_ci NOT NULL,
  `layout` varchar(255) collate utf8_general_ci NOT NULL default '',
  `theme` varchar( 255 ) collate utf8_general_ci NOT NULL default '',
  `val` text collate utf8_general_ci NOT NULL,
  `regdate` varchar(14) collate utf8_general_ci NOT NULL default '',
  PRIMARY KEY  (`layout_srl`),
  UNIQUE KEY `title` (`title`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci AUTO_INCREMENT=1;

CREATE TABLE `{#ZB_PREFIX#}member_level` (
  `member_srl` int(11) NOT NULL default '0',
  `level_srl` int(11) NOT NULL default '0',
  UNIQUE KEY `member_srl` (`member_srl`,`level_srl`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;

CREATE TABLE `{#ZB_PREFIX#}member_level_manager` (
  `level_srl` int(11) NOT NULL,
  `level` int(11) NOT NULL default '1',
  `level_title` varchar(255) collate utf8_general_ci NOT NULL default '',
  PRIMARY KEY  (`level_srl`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci AUTO_INCREMENT=1;

CREATE TABLE `{#ZB_PREFIX#}member_list` (
  `member_srl` int(11) NOT NULL,
  `listorder` int(11) NOT NULL default '0',
  `user_id` varchar(20) collate utf8_general_ci NOT NULL default '',
  `passwd` varchar(60) collate utf8_general_ci NOT NULL default '',
  `user_name` varchar(20) collate utf8_general_ci NOT NULL default '',
  `nick_name` varchar(20) collate utf8_general_ci NOT NULL default '',
  `email_address` varchar(255) collate utf8_general_ci NOT NULL default '',
  `email` varchar(255) collate utf8_general_ci NOT NULL default '',
  `email_host` varchar(255) collate utf8_general_ci NOT NULL default '',
  `extend_val` text collate utf8_general_ci,
  `new_message` int(11) NOT NULL default '0',
  `point` int(11) NOT NULL default '0',
  `allowed` varchar(2) collate utf8_general_ci NOT NULL default 'N',
  `denied` varchar(2) collate utf8_general_ci NOT NULL default 'N',
  `mailing` varchar(2) collate utf8_general_ci NOT NULL default 'N',
  `manager_message` text collate utf8_general_ci NOT NULL,
  `regdate` varchar(14) collate utf8_general_ci NOT NULL default '',
  `last_signin` varchar(14) collate utf8_general_ci NOT NULL default '',
  `image_nick` varchar(255) collate utf8_general_ci NOT NULL default '',
  `image_mark` varchar(255) collate utf8_general_ci NOT NULL default '',
  `profile_image` varchar(255) collate utf8_general_ci NOT NULL default '',
  `sign` text collate utf8_general_ci NOT NULL,
  PRIMARY KEY  (`member_srl`),
  UNIQUE KEY `user_id` (`user_id`),
  UNIQUE KEY `nick_name` (`nick_name`),
  UNIQUE KEY `email_address` (`email_address`),
  INDEX `email_host` (`email_host`),
  INDEX `mailing` (`mailing`),
  INDEX `listorder` (`listorder`),
  INDEX `regdate` (`regdate`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci AUTO_INCREMENT=1;

CREATE TABLE `{#ZB_PREFIX#}member_signup_manager` (
  `form_srl` int(11) NOT NULL,
  `name` varchar(255) collate utf8_general_ci NOT NULL default '',
  `title` varchar(255) collate utf8_general_ci NOT NULL default '',
  `type` varchar(255) collate utf8_general_ci NOT NULL default '',
  `default_value` varchar(255) collate utf8_general_ci NOT NULL default '',
  `value_list` text collate utf8_general_ci,
  `value` text collate utf8_general_ci NOT NULL,
  `check` varchar(2) collate utf8_general_ci NOT NULL default 'N',
  `description` varchar(255) collate utf8_general_ci NOT NULL default '',
  `listorder` int(11) NOT NULL default '0',
  PRIMARY KEY  (`form_srl`),
  UNIQUE KEY `name` (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci AUTO_INCREMENT=1;

CREATE TABLE `{#ZB_PREFIX#}menu_manager` (
  `menu_srl` int(11) NOT NULL,
  `menu_name` varchar(255) collate utf8_general_ci NOT NULL default '',
  `depth` int(4) NOT NULL default '0',
  `layout_srl` int(11) NOT NULL default '0',
  `comment` text collate utf8_general_ci NOT NULL,
  `tree_list` text collate utf8_general_ci NOT NULL,
  `simple_tree_list` text collate utf8_general_ci NOT NULL,
  `regdate` varchar(14) collate utf8_general_ci NOT NULL default '',
  `cache_interval` int(11) NOT NULL default '0',
  `update_date` int(11) NOT NULL default '0',
  PRIMARY KEY  (`menu_srl`),
  UNIQUE KEY `menu_name` (`menu_name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci AUTO_INCREMENT=1;

CREATE TABLE `{#ZB_PREFIX#}menu_tree` (
  `node_srl` int(11) NOT NULL,
  `menu_srl` int(11) NOT NULL default '0',
  `p_node_srl` int(11) NOT NULL default '0',
  `node_name` varchar(255) collate utf8_general_ci NOT NULL default '',
  `layout_srl` int(11) NOT NULL default '0',
  `module_srl` int(11) NOT NULL default '0',
  `page_srl` int(11) NOT NULL default '0',
  `menu_type` int(11) NOT NULL default '0',
  `link_url` varchar(255) collate utf8_general_ci NOT NULL default '',
  `page_path` varchar(255) collate utf8_general_ci NOT NULL default '',
  `use_succession` char(2) collate utf8_general_ci NOT NULL default 'N',
  `use_image` char(2) collate utf8_general_ci NOT NULL default 'N',
  `img_normal` varchar(255) collate utf8_general_ci NOT NULL default '',
  `img_hover` varchar(255) collate utf8_general_ci NOT NULL default '',
  `img_select` varchar(255) collate utf8_general_ci NOT NULL default '',
  `access_level` text collate utf8_general_ci NOT NULL,
  `show_level` text collate utf8_general_ci NOT NULL,
  `hidden` varchar(2) collate utf8_general_ci NOT NULL default '',
  `depth` int(11) NOT NULL default '1',
  `comment` text collate utf8_general_ci NOT NULL,
  `listorder` int(11) NOT NULL default '1',
  `article_cnt` int(11) NOT NULL default '0',
  `view_cnt` int(11) NOT NULL default '0',
  `regdate` varchar(14) collate utf8_general_ci NOT NULL default '',
  `lastupdate` varchar(14) collate utf8_general_ci NOT NULL default '',
  PRIMARY KEY  (`node_srl`),
  INDEX `idx_menu_srl` (`menu_srl`,`p_node_srl`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci AUTO_INCREMENT=86 ;

CREATE TABLE `{#ZB_PREFIX#}module_category` (
  `module_category_srl` int(11) NOT NULL,
  `category_title` varchar(255) collate utf8_general_ci NOT NULL default '',
  PRIMARY KEY  (`module_category_srl`),
  UNIQUE KEY `category_title` (`category_title`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci AUTO_INCREMENT=1;

CREATE TABLE `{#ZB_PREFIX#}module_manager` (
  `module_srl` int(11) NOT NULL,
  `module_category_srl` int(11) NOT NULL default '0',
  `web_server_srl` int(11) NOT NULL default '0',
  `web_server_host` varchar(255) collate utf8_general_ci NOT NULL default '',
  `file_server_srl` int(11) NOT NULL default '0',
  `title` varchar(255) collate utf8_general_ci NOT NULL default '',
  `comment` text collate utf8_general_ci NOT NULL,
  `module` varchar(255) collate utf8_general_ci NOT NULL default '',
  `menu_srl` int(11) NOT NULL default '0',
  `node_srl` int(11) NOT NULL default '0',
  `val` text collate utf8_general_ci NOT NULL,
  `skin` varchar(255) collate utf8_general_ci NOT NULL default '',
  `theme` varchar(255) collate utf8_general_ci NOT NULL default '',
  `access_level` text collate utf8_general_ci,
  `write_level` text collate utf8_general_ci,
  `view_level` text collate utf8_general_ci,
  `comment_level` text collate utf8_general_ci,
  `manager_level` text collate utf8_general_ci,
  `survey_level` text collate utf8_general_ci,
  `upload_level` text collate utf8_general_ci,
  `download_level` text collate utf8_general_ci,
  `upload_max_size` int(11) NOT NULL default '0',
  `image_width` int(11) NOT NULL default '540',
  `point` varchar(255) collate utf8_general_ci NOT NULL default '',
  `regdate` varchar(14) collate utf8_general_ci NOT NULL default '',
  PRIMARY KEY  (`module_srl`),
  UNIQUE KEY `title` (`title`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci AUTO_INCREMENT=1;

CREATE TABLE `{#ZB_PREFIX#}page_category` (
  `page_category_srl` int(11) NOT NULL,
  `category_title` varchar(255) collate utf8_general_ci NOT NULL default '',
  PRIMARY KEY  (`page_category_srl`),
  UNIQUE KEY `category_title` (`category_title`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci AUTO_INCREMENT=1;

CREATE TABLE `{#ZB_PREFIX#}page_manager` (
  `page_srl` int(11) NOT NULL,
  `page_category_srl` int(11) NOT NULL default '0',
  `title` varchar(255) collate utf8_general_ci NOT NULL default '',
  `cache_interval` int(11) NOT NULL default '0',
  `update_date` int(11) NOT NULL default '0',
  `cache_data` text collate utf8_general_ci,
  `regdate` varchar(14) collate utf8_general_ci NOT NULL default '',
  PRIMARY KEY  (`page_srl`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci AUTO_INCREMENT=1;

CREATE TABLE `{#ZB_PREFIX#}page_plugin` (
  `page_plugin_srl` int(11) NOT NULL,
  `page_srl` int(11) NOT NULL default '0',
  `plugin_srl` int(11) NOT NULL default '0',
  `width` varchar(50) collate utf8_general_ci NOT NULL default '',
  `height` int(11) NOT NULL default '0',
  `padding` varchar(255) collate utf8_general_ci NOT NULL default '',
  `float` varchar(50) collate utf8_general_ci NOT NULL default '',
  PRIMARY KEY  (`page_plugin_srl`),
  INDEX `page_srl` (`page_srl`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci AUTO_INCREMENT=1;

CREATE TABLE `{#ZB_PREFIX#}plugin_category` (
  `plugin_category_srl` int(11) NOT NULL,
  `category_title` varchar(255) collate utf8_general_ci NOT NULL default '',
  PRIMARY KEY  (`plugin_category_srl`),
  UNIQUE KEY `category_title` (`category_title`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci AUTO_INCREMENT=1;

CREATE TABLE `{#ZB_PREFIX#}plugin_manager` (
  `plugin_srl` int(11) NOT NULL,
  `plugin_category_srl` int(11) NOT NULL default '0',
  `title` varchar(255) collate utf8_general_ci NOT NULL default '',
  `comment` text collate utf8_general_ci NOT NULL,
  `plugin` varchar(255) collate utf8_general_ci NOT NULL default '',
  `theme` varchar(255) collate utf8_general_ci NOT NULL default '',
  `val` text collate utf8_general_ci NOT NULL,
  `cache_interval` int(11) NOT NULL default '1',
  `update_date` int(11) NOT NULL default '0',
  `cache_data` text collate utf8_general_ci,
  `regdate` varchar(14) collate utf8_general_ci NOT NULL default '',
  PRIMARY KEY  (`plugin_srl`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci AUTO_INCREMENT=1;

CREATE TABLE `{#ZB_PREFIX#}server_manager` (
  `server_srl` int(11) NOT NULL,
  `server_type` varchar(12) collate utf8_general_ci NOT NULL default 'web',
  `server_name` varchar(255) collate utf8_general_ci NOT NULL default '',
  `hostname` varchar(255) collate utf8_general_ci NOT NULL default '',
  `port` int(6) NOT NULL default '0',
  `path` varchar(255) collate utf8_general_ci NOT NULL default '',
  `comment` text collate utf8_general_ci,
  `is_default` char(2) DEFAULt 'N' NOT NULL,
  `regdate` varchar(14) collate utf8_general_ci NOT NULL default '',
  PRIMARY KEY  (`server_srl`),
  UNIQUE KEY `{#ZB_PREFIX#}server_manager_server_name` (`server_name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci COMMENT='zeroboard5 server list' AUTO_INCREMENT=1;

CREATE TABLE `{#ZB_PREFIX#}site_manager` (
  `title` varchar(255) collate utf8_general_ci NOT NULL default '',
  `keywords` varchar(255) collate utf8_general_ci NOT NULL default '',
  `description` varchar(255) collate utf8_general_ci NOT NULL default '',
  `email` varchar(255) collate utf8_general_ci NOT NULL default '',
  `hidden` varchar(2) collate utf8_general_ci NOT NULL default 'N',
  `layout_srl` int(11) NOT NULL default '0',
  `main_menu_srl` int(11) NOT NULL default '0',
  `sub_menu_1_srl` int(11) NOT NULL default '0',
  `sub_menu_2_srl` int(11) NOT NULL default '0',
  `sub_menu_3_srl` int(11) NOT NULL default '0',
  `sub_menu_4_srl` int(11) NOT NULL default '0',
  `access_level` int(11) NOT NULL default '0',
  `join_level_srl` int(11) NOT NULL default '0',
  `auto_login_time` int(11) NOT NULL default '0',
  `auth_type` int(11) NOT NULL default '0',
  `use_image_nick` int(11) NOT NULL default '2',
  `use_image_mark` int(11) NOT NULL default '2',
  `use_profile_image` int(11) NOT NULL default '2',
  `use_sign` int(11) NOT NULL default '2',
  `use_exp` char(2) NOT NULL default 'N'
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;

CREATE TABLE `{#ZB_PREFIX#}member_mail` (
  `key` varchar(60) collate utf8_general_ci NOT NULL default '',
  `member_srl` int(11) NOT NULL default '0',
  `type` varchar(40) collate utf8_general_ci NOT NULL default 'register',
  `new_password` varchar(40) collate utf8_general_ci NOT NULL default 'register',
  `regdate` VARCHAR(14) collate utf8_general_ci NOT NULL default '',
  PRIMARY KEY  (`key`),
  INDEX ( `member_srl` , `type` )
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;

CREATE TABLE `{#ZB_PREFIX#}site_message` (
  `type` varchar(20) collate utf8_general_ci NOT NULL default '',
  `title` varchar(255) collate utf8_general_ci NULL default '',
  `message` text collate utf8_general_ci NOT NULL default ''
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;

CREATE TABLE `{#ZB_PREFIX#}session_autologin` (
  `session_key` varchar(255) collate utf8_general_ci NOT NULL default '',
  `expired` int(11) unsigned NOT NULL default '0',
  `member_srl` int(11) unsigned NOT NULL default '0',
  `ipaddress` varchar(128) collate utf8_general_ci NOT NULL default '',
  PRIMARY KEY  (`session_key`),
  INDEX ( `member_srl` )
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;

CREATE TABLE `{#ZB_PREFIX#}session` (
  `session_key` varchar(255) collate utf8_general_ci NOT NULL default '',
  `expired` int(11) unsigned NOT NULL default '0',
  `member_srl` int(11) unsigned NOT NULL default '0',
  `val` text collate utf8_general_ci NOT NULL,
  `new_message` int(11) NOT NULL default '0',
  `point` int(11) NOT NULL default '0',
  `ipaddress` varchar(128) collate utf8_general_ci NOT NULL default '',
  PRIMARY KEY  (`session_key`),
  INDEX ( `member_srl` )
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;

CREATE TABLE `{#ZB_PREFIX#}articles` (
  `article_srl` INT( 11 ) NOT NULL,
  `module_srl` INT( 11 ) NOT NULL,
  `is_notice` CHAR( 2 ) DEFAULT 'N' NOT NULL,
  `writer` VARCHAR( 40 ) collate utf8_general_ci NOT NULL default '',
  `user_id` VARCHAR( 20 ) collate utf8_general_ci NOT NULL default '',
  `passwd` VARCHAR( 60 ) collate utf8_general_ci NOT NULL default '',
  `title` VARCHAR( 255 ) collate utf8_general_ci NOT NULL default '',
  `article` TEXT collate utf8_general_ci NOT NULL default '',
  `tag` varchar( 255 ) collate utf8_general_ci NOT NULL default '',
  `regdate` VARCHAR( 14 ) collate utf8_general_ci NOT NULL default '',
  `ipaddress` VARCHAR( 128 ) collate utf8_general_ci NOT NULL default '',
  `member_srl` INT( 11 ) DEFAULT '0' NOT NULL ,
  `comment_cnt` INT( 11 ) DEFAULT '0' NOT NULL ,
  `trackback_cnt` INT( 11 ) DEFAULT '0' NOT NULL ,
  `readed_cnt` INT( 11 ) DEFAULT '0' NOT NULL ,
  `file_cnt` INT( 11 ) DEFAULT '0' NOT NULL ,
  `voted_cnt` INT DEFAULT '0' NOT NULL ,
  `allow_comment` CHAR( 2 ) DEFAULT 'Y' NOT NULL ,
  `allow_trackback` CHAR( 2 ) DEFAULT 'Y' NOT NULL ,
  `summary` TEXT collate utf8_general_ci,
  `summary_div` varchar(255) collate utf8_general_ci,
  `use_serial` CHAR( 3 ) DEFAULT 'N' NOT NULL,
  `serial_srl` INT( 11 ) DEFAULT '0' NOT NULL,
  `prev_serial_srl` INT( 11 ) DEFAULT '0' NOT NULL,
  `next_serial_srl` INT( 11 ) DEFAULT '0' NOT NULL,
  `use_survey` CHAR( 2 ) DEFAULT 'N' NOT NULL,
  `survey` TEXT collate utf8_general_ci,
  `use_reply_message` CHAR( 2 ) DEFAULT 'N' NOT NULL,
  `use_gallery` CHAR( 2 ) DEFAULT 'N' NOT NULL,
  `listorder` INT( 11 ) NOT NULL ,
  `modify_order` INT( 11 ) NOT NULL ,
  PRIMARY KEY ( `article_srl` ),
  INDEX ( `module_srl` ),
  INDEX ( `listorder` ),
  INDEX ( `readed_cnt` ),
  INDEX ( `modify_order` ),
  INDEX ( `regdate` ),
  INDEX ( `member_srl` ),
  INDEX `article_listorder` (`module_srl`,`listorder`),
  INDEX `article_modify_order` (`module_srl`,`modify_order`)
) CHARACTER SET utf8 COLLATE utf8_general_ci;

CREATE TABLE `{#ZB_PREFIX#}tag` (
  `tag` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
  `article_srl` INT( 11 ) DEFAULT '0' NOT NULL ,
  `module_srl` INT( 11 ) DEFAULT '0' NOT NULL ,
  INDEX ( `tag` ),
  INDEX ( `article_srl` ),
  INDEX ( `module_srl` )
) CHARACTER SET utf8 COLLATE utf8_general_ci;

CREATE TABLE `{#ZB_PREFIX#}file` (
  `file_srl` INT( 11 ) DEFAULT '0' NOT NULL ,
  `article_srl` INT( 11 ) DEFAULT '0' NOT NULL ,
  `member_srl` INT( 11 ) DEFAULT '0' NOT NULL ,
  `listorder` INT( 11 ) DEFAULT '0' NOT NULL ,
  `s_filename` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
  `ext` VARCHAR( 60 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
  `size` INT( 11 ) DEFAULT '0' NOT NULL ,
  `server_srl` INT( 11 ) DEFAULT '0' NOT NULL ,
  `path` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
  `filename` CHAR( 32 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
  `is_used` CHAR( 2 ) CHARACTER SET utf8 COLLATE utf8_general_ci DEFAULT 'N' NOT NULL ,
  `download_cnt` INT( 11 ) DEFAULT '0' NOT NULL ,
  `is_resized` CHAR( 2 ) CHARACTER SET utf8 COLLATE utf8_general_ci DEFAULT 'N' NOT NULL ,
  PRIMARY KEY ( `file_srl` ),
  INDEX ( `article_srl` ),
  INDEX ( `member_srl` ),
  INDEX ( `filename` )
) CHARACTER SET utf8 COLLATE utf8_general_ci;

CREATE TABLE `{#ZB_PREFIX#}survey` (
  `survey_srl` int(11) NOT NULL default '0',
  `article_srl` int(11) NOT NULL default '0',
  `content` varchar(255) collate utf8_general_ci NOT NULL default '',
  `cnt` int(11) NOT NULL default '0',
  `checkcnt` int(11) NOT NULL default '1',
  `member_srl` int(11) NOT NULL default '0',
  `regdate` varchar(14) collate utf8_general_ci NOT NULL default '',
  INDEX `survey_srl` (`survey_srl`),
  INDEX `article_srl` (`article_srl`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;

CREATE TABLE `{#ZB_PREFIX#}survey_item` (
  `survey_srl` int(11) NOT NULL default '0',
  `article_srl` int(11) NOT NULL default '0',
  `listorder` int(11) NOT NULL default '0',
  `item` varchar(255) collate utf8_general_ci NOT NULL default '',
  `cnt` int(11) NOT NULL default '0',
  INDEX `survey_srl` (`survey_srl`),
  INDEX `article_srl` (`article_srl`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;

CREATE TABLE `{#ZB_PREFIX#}survey_log` (
  `article_srl` int(11) NOT NULL default '0',
  `member_srl` int(11) NOT NULL default '0',
  INDEX `article_srl` (`article_srl`,`member_srl`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;

CREATE TABLE `{#ZB_PREFIX#}comment` (
  `comment_srl` INT( 11 ) NOT NULL,
  `module_srl` INT( 11 ) NOT NULL,
  `article_srl` INT( 11 ) DEFAULT '0' NOT NULL ,
  `parent_srl` INt( 11 ) DEFAULT '0' NOT NULL ,
  `writer` VARCHAR( 40 ) collate utf8_general_ci NOT NULL default '',
  `user_id` VARCHAR( 20 ) collate utf8_general_ci NOT NULL default '',
  `passwd` VARCHAR( 60 ) collate utf8_general_ci NOT NULL default '',
  `article` TEXT COLLATE utf8_general_ci NOT NULL ,
  `member_srl` INT( 11 ) DEFAULT '0' NOT NULL ,
  `regdate` VARCHAR( 14 ) COLLATE utf8_general_ci NOT NULL ,
  `ipaddress` VARCHAR( 128 ) COLLATE utf8_general_ci NOT NULL ,
  `listorder` INT( 11 ) DEFAULT '0' NOT NULL ,
  `modify_order` INT( 11 ) DEFAULT '0' NOT NULL ,
  PRIMARY KEY ( `comment_srl` ) ,
  INDEX ( `module_srl` ),
  INDEX ( `article_srl` ),
  INDEX ( `listorder` ),
  INDEX ( `modify_order` ),
  INDEX ( `member_srl` ),
  INDEX ( `parent_srl` )
) CHARACTER SET utf8 COLLATE utf8_general_ci;

CREATE TABLE `{#ZB_PREFIX#}trackback` (
  `trackback_srl` INT( 11 ) DEFAULT '0' NOT NULL,
  `article_srl` INT( 11 ) DEFAULT '0' NOT NULL ,
  `url` VARCHAR( 255 ) collate utf8_general_ci NOT NULL default '',
  `title` VARCHAR( 255 ) collate utf8_general_ci NOT NULL default '',
  `blog_name` VARCHAR( 255 ) collate utf8_general_ci NOT NULL default '',
  `excerpt` VARCHAR( 255 ) collate utf8_general_ci NOT NULL default '',
  `regdate` VARCHAR( 14 ) COLLATE utf8_general_ci NOT NULL ,
  `listorder` INT( 11 ) DEFAULT '0' NOT NULL ,
  PRIMARY KEY ( `trackback_srl` ) ,
  INDEX ( `article_srl` ),
  INDEX ( `listorder` )
) CHARACTER SET utf8 COLLATE utf8_general_ci;

CREATE TABLE `{#ZB_PREFIX#}sequence` (
  `srl` INT( 11 ) NOT NULL AUTO_INCREMENT ,
  `regdate` VARCHAR( 14 ) NOT NULL ,
  PRIMARY KEY ( `srl` )
) CHARACTER SET utf8 COLLATE utf8_general_ci;

CREATE TABLE `{#ZB_PREFIX#}analytics` (
  `regdate` char(8) collate utf8_general_ci NOT NULL default '0',
  `unique` int(11) NOT NULL default '0',
  `view` int(11) NOT NULL default '0',
  `u0` int(11) NOT NULL default '0',
  `u1` int(11) NOT NULL default '0',
  `u2` int(11) NOT NULL default '0',
  `u3` int(11) NOT NULL default '0',
  `u4` int(11) NOT NULL default '0',
  `u5` int(11) NOT NULL default '0',
  `u6` int(11) NOT NULL default '0',
  `u7` int(11) NOT NULL default '0',
  `u8` int(11) NOT NULL default '0',
  `u9` int(11) NOT NULL default '0',
  `u10` int(11) NOT NULL default '0',
  `u11` int(11) NOT NULL default '0',
  `u12` int(11) NOT NULL default '0',
  `u13` int(11) NOT NULL default '0',
  `u14` int(11) NOT NULL default '0',
  `u15` int(11) NOT NULL default '0',
  `u16` int(11) NOT NULL default '0',
  `u17` int(11) NOT NULL default '0',
  `u18` int(11) NOT NULL default '0',
  `u19` int(11) NOT NULL default '0',
  `u20` int(11) NOT NULL default '0',
  `u21` int(11) NOT NULL default '0',
  `u22` int(11) NOT NULL default '0',
  `u23` int(11) NOT NULL default '0',
  `u24` int(11) NOT NULL default '0',
  `v0` int(11) NOT NULL default '0',
  `v1` int(11) NOT NULL default '0',
  `v2` int(11) NOT NULL default '0',
  `v3` int(11) NOT NULL default '0',
  `v4` int(11) NOT NULL default '0',
  `v5` int(11) NOT NULL default '0',
  `v6` int(11) NOT NULL default '0',
  `v7` int(11) NOT NULL default '0',
  `v8` int(11) NOT NULL default '0',
  `v9` int(11) NOT NULL default '0',
  `v10` int(11) NOT NULL default '0',
  `v11` int(11) NOT NULL default '0',
  `v12` int(11) NOT NULL default '0',
  `v13` int(11) NOT NULL default '0',
  `v14` int(11) NOT NULL default '0',
  `v15` int(11) NOT NULL default '0',
  `v16` int(11) NOT NULL default '0',
  `v17` int(11) NOT NULL default '0',
  `v18` int(11) NOT NULL default '0',
  `v19` int(11) NOT NULL default '0',
  `v20` int(11) NOT NULL default '0',
  `v21` int(11) NOT NULL default '0',
  `v22` int(11) NOT NULL default '0',
  `v23` int(11) NOT NULL default '0',
  `v24` int(11) NOT NULL default '0',
  PRIMARY KEY ( `regdate` ) 
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;

CREATE TABLE `{#ZB_PREFIX#}referer_query` (
  `query` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
  `cnt` INT( 10 ) DEFAULT '0' NOT NULL ,
  PRIMARY KEY ( `query` )
) CHARACTER SET utf8 COLLATE utf8_general_ci;

CREATE TABLE `{#ZB_PREFIX#}message` (
  `message_srl` int(11) NOT NULL default '0',
  `message_type` varchar(2) collate utf8_general_ci NOT NULL default 'S',
  `sender_srl` int(11) NOT NULL default '0',
  `sender_user_id` varchar(40) NOT NULL default '0',
  `sender_nick_name` varchar(40) NOT NULL default '0',
  `receiver_srl` int(11) NOT NULL default '0',
  `receiver_user_id` varchar(40) NOT NULL default '0',
  `receiver_nick_name` varchar(40) NOT NULL default '0',
  `keeping` varchar(2) collate utf8_general_ci NOT NULL default 'N',
  `article_srl` int(11) NOT NULL default '0',
  `title` varchar(255) collate utf8_general_ci NOT NULL default '',
  `message` text collate utf8_general_ci NOT NULL,
  `regdate` varchar(14) collate utf8_general_ci NOT NULL default '',
  `is_readed` varchar(2) collate utf8_general_ci NOT NULL default 'N',
  `listorder` int(11) NOT NULL default '0',
  PRIMARY KEY  (`message_srl`),
  INDEX `sender_srl` (`sender_srl`),
  INDEX `receiver_srl` (`receiver_srl`),
  INDEX `listorder` (`listorder`),
  INDEX `keeping` (`keeping`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci;

CREATE TABLE `{#ZB_PREFIX#}report_log` (
  `article_srl` INT( 11 ) DEFAULT '0' NOT NULL ,
  `comment_srl` INT( 11 ) DEFAULT '0' NOT NULL ,
  `member_srl` INT( 11 ) DEFAULT '0' NOT NULL ,
  `target_module_srl` INT( 11 ) DEFAULT '0' NOT NULL ,
  `regdate` CHAR( 14 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
  `listorder` int(11) NOT NULL default '0',
  INDEX ( `article_srl` , `comment_srl` ),
  INDEX ( `listorder` )
) CHARACTER SET utf8 COLLATE utf8_general_ci;

CREATE TABLE `{#ZB_PREFIX#}serial` (
  `serial_srl` INT( 11 ) DEFAULT '0' NOT NULL ,
  `member_srl` INT( 11 ) DEFAULT '0' NOT NULL ,
  `title` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
  `first_article_srl` INT( 11 ) DEFAULT '0' NOT NULL ,
  `last_article_srl` INT( 11 ) DEFAULT '0' NOT NULL ,
  `article_cnt` INT( 11 ) DEFAULT '0' NOT NULL ,
  `readed_cnt` INT( 11 ) DEFAULT '0' NOT NULL ,
  `regdate` VARCHAR( 14 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
  `listorder` int(11) NOT NULL default '0',
  PRIMARY KEY ( `serial_srl` ),
  INDEX `listorder` (`listorder`),
  INDEX `member_srl` (`member_srl`)
) CHARACTER SET utf8 COLLATE utf8_general_ci;

CREATE TABLE `{#ZB_PREFIX#}search_keyword` (
  `keyword` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL ,
  `regdate` VARCHAR( 14 ) CHARACTER SET armscii8 COLLATE armscii8_general_ci NOT NULL
) CHARACTER SET utf8 COLLATE utf8_general_ci;
