<?php

  class blog extends zModuleManager {

    var $db_table = null;

    var $list_cnt = 10;

    var $page_cnt = 10;

    var $oPageNav = null;

    var $config = null;

    var $cur_page = null;

    var $total_articles = 0;
    var $article = null;
    var $article_list = null;
    var $serial_list = null;

    var $comment_list = null;
    var $trackback_list = null;

    function blog() {
      parent::zModuleManager();
    }

    function proc() {
      if($this->config->list_cnt) $this->list_cnt = $this->config->list_cnt;

      parent::proc();

      if(!$this->access_enable) return $this->printDeniedHtml();

      switch($this->action) {
        case 'write' :
            return $this->printWriteForm();
          break;
        case 'modify' :
            return $this->printModifyForm();
          break;
        case 'delete' :
            return $this->printDeleteForm();
          break;
        case 'delete_comment' :
            return $this->printDeleteCommentForm();
          break;

        case 'do_insert_article' :
            return $this->doInsertArticle();
          break;
        case 'do_delete_article' :
            return $this->doDeleteArticle();
          break;
        case 'do_vote' :
            return $this->doVote();
          break;
        case 'do_report' :
            return $this->doReport();
          break;

        case 'get_comment_list' :
            return $this->getCommentList();
          break;
        case 'do_insert_comment' :
            return $this->doInsertComment();
          break;
        case 'do_delete_comment' :
            return $this->doDeleteComment();
          break;

        case 'get_trackback_list' :
            return $this->getTrackbackList();
          break;
        case 'do_delete_trackback' :
            return $this->doDeleteTrackback();
          break;

        case 'do_check_password' :
            return $this->doCheckPassword();
          break;

        case 'show_simple_list' :
            return $this->showSimpleList();
          break;

        default :
            $this->getArticle();
            return $this->getArticleList();
          break;
      }
    }

    function getArticle() {
      if(!$this->article_srl) return;

      require_class('zArticle');
      $oArticle = &zArticle::instance($this);
      $oArticle->getArticle($this->article_srl, &$this->article, &$this->cur_page);
    }

    function getArticleList() {
      require_class('zArticle');
      $oArticle = &zArticle::instance($this);
      $oArticle->getArticleList(&$this->total_articles, &$this->article_list, &$this->oPageNav, true);

      return $this->readTpl("list.tpl");
    }

    function doInsertArticle() {
      require_class('zArticle');
      $oArticle = &zArticle::instance($this);
      return $oArticle->insertArticle($this->args);
    }

    function doDeleteArticle() {
      require_class('zArticle');
      $oArticle = &zArticle::instance($this);
      return $oArticle->deleteArticle($this->args->article_srl);
    }

    function doVote() {
      require_class('zArticle');
      $oArticle = &zArticle::instance($this);
      return $oArticle->vote($this->args);
    }

    function doReport() {
      require_class('zArticle');
      $oArticle = &zArticle::instance($this);
      return $oArticle->report($this->args);
    }

    function getCommentList() {
      require_class('zComment');
      $oComment = &zComment::instance($this);
      $oComment->getCommentList($this->args, &$this->comment_list);

      if(!$this->is_logged) {
        require_class('zImageNumber');
        zImageNumber::setNumber();
        $this->show_image_number = true;
      }

      $output->article_srl = $this->args->article_srl;
      $output->tpl = $this->readTpl("comment.tpl");
      return $output;
    }

    function doInsertComment() {
      require_class('zComment');
      $oComment = &zComment::instance($this);
      return $oComment->insertComment($this->args);
    }

    function doDeleteComment() {
      require_class('zComment');
      $oComment = &zComment::instance($this);
      return $oComment->deleteComment($this->args);
    }

    function getTrackbackList() {
      require_class('zTrackBack');
      $oTrackBack = &zTrackBack::instance($this);
      $oTrackBack->getTrackbackList($this->args, &$this->trackback_list);
      $this->trackback_url = zUrl::getTrackbackUrl($this->args->article_srl);

      $output->article_srl = $this->args->article_srl;
      $output->tpl = $this->readTpl("trackback.tpl");
      return $output;
    }

    function doDeleteTrackback() {
      require_class('zTrackBack');
      $oTrackBack = &zTrackBack::instance($this);
      return $oTrackBack->deleteTrackback($this->args);
    }

    function printWriteForm() {
      if(!$this->write_enable) {
        $this->action = null;
        return;
      }

      require_class('zArticle');
      $oArticle = &zArticle::instance($this);

      $this->serial_list = $oArticle->getOwnSerialList();
      $this->list_url = zUrl::getListUrl($this->sid, $this->serial_srl, $this->cur_page);

      if(!$this->member_srl) {
        $this->file_server = './';
        require_class('zImageNumber');
        zImageNumber::setNumber();
        $this->show_image_number = true;
      }

      return $this->readTpl("write_form.tpl");
    }

    function printModifyForm() {
      if(!$this->write_enable || !$this->view_enable || !$this->article_srl) {
        $this->action = null;
        return;
      }

      require_class('zArticle');
      $oArticle = &zArticle::instance($this);

      $oArticle->getArticle($this->article_srl, &$this->article, &$this->cur_page);
      if(!$this->article->modify_enable) {
        $this->action = null;
        return;
      }

      $check_articles = unserialize($_SESSION['check_articles']);
      if(!is_array($check_articles)) $check_articles = array();

      if($this->member_srl || in_array($this->article_srl, $check_articles)) $this->modify_mode = 'confirm';
      else $this->modify_mode = 'ask_password';

      $this->serial_list = $oArticle->getOwnSerialList();
      $this->list_url = zUrl::getViewUrl($this->article->article_srl, $this->sid, $this->serial_srl, $this->cur_page);
      $this->survey_enable = false;

      $oDB = &zDB::instance();

      if($this->member_srl) {
        $article_srl = $oDB->addquotes($this->article_srl);
        if($this->upload_enable && $this->article->file_cnt) {
          $oDB->select(array('filename','s_filename','size'),'file',array("article_srl='{$article_srl}'"));
          while($tmp = $oDB->fetch()) {
            $tmp->s_filename = sprintf("%s (%s)",$tmp->s_filename, zFile::filesize($tmp->size));
            $this->file_list[] = $tmp;
          }
        }
      } else $this->file_server = './';

      if($this->modify_mode == 'confirm') return $this->readTpl('write_form.tpl');
      else return $this->readTpl('ask_password.tpl');
    }

    function printDeleteForm() {
      if(!$this->write_enable || !$this->view_enable || !$this->article_srl) {
        $this->action = null;
        return;
      }

      require_class('zArticle');
      $oArticle = &zArticle::instance($this);

      $oArticle->getArticle($this->article_srl, $this->article, $cur_page);
      if(!$this->article->delete_enable) {
        $this->action = null;
        return;
      }

      $check_articles = unserialize($_SESSION['check_articles']);
      if(!is_array($check_articles)) $check_articles = array();

      if($this->member_srl || in_array($this->article_srl, $check_articles)) $this->delete_mode = 'confirm';
      else $this->delete_mode = 'ask_password';

      $this->list_url = zUrl::getViewUrl($this->article->article_srl, $this->sid, $this->serial_srl, $this->cur_page);

      if($this->delete_mode == 'confirm') return $this->readTpl('confirm.tpl');
      else return $this->readTpl('ask_password.tpl');
    }

    function printDeleteCommentForm() {
      if(!$this->comment_enable || !$this->view_enable || !$this->article_srl || !$this->comment_srl) {
        $this->action = null;
        return;
      }

      require_class('zComment');
      $oComment = &zComment::instance($this);
      $this->comment = $oComment->getComment($this->comment_srl);

      if(!$this->comment->delete_enable) {
        $this->action = null;
        return false;
      }

      $check_comments = unserialize($_SESSION['check_comments']);
      if(!is_array($check_comments)) $check_comments = array();

      if($this->member_srl || in_array($this->comment_srl, $check_comments)) $this->delete_mode = 'confirm';
      else $this->delete_mode = 'ask_password';

      $this->list_url = zUrl::getViewUrl($this->article_srl, $this->sid, $this->serial_srl, $this->cur_page);

      if($this->delete_mode == 'confirm') return $this->readTpl('confirm.tpl');
      else return $this->readTpl('ask_password.tpl');
    }

    function showSimpleList() {
      $node_srl = $this->args->node_srl;
      $zone_id = $this->args->zone_id;
      $tag = urldecode($this->args->tag);
      $archive = urldecode($this->args->archive);

      if(!$node_srl) return;

      $cur_page = $this->args->page;

      $oSvc = &zSvc::instance();
      $oSvc->setSid($node_srl);
      $oSvc->preProc();

      if(!$oSvc->selected_layout->list_cnt) $list_cnt = 10;
      else $list_cnt = $oSvc->selected_layout->list_cnt;

      require_class('zSearch');
      $oSearch = new zSearch();
      if($oSvc->selected_menu['child_module_list']) $oSearch->setModuleSrlList($oSvc->selected_menu['child_module_list']);
      else $oSearch->setModuleSrl($this->module_srl);

      $oSearch->setSid($node_srl);
      if($tag) $oSearch->setTag($tag);
      elseif($archive) $oSearch->setArchive($archive);
      else $oSearch->setSearchType(urldecode($this->args->search_keyword), $this->args->st, $this->args->sc, $this->args->sw, $this->args->sg, $this->args->sa);                                                                                                                        
      $output = $oSearch->searchArticle($list_cnt, $this->page_cnt, $cur_page);

      $this->total_articles = $output->total_articles;
      $this->article_list = $output->article_list;
      $this->oPageNav = $output->oPageNav;
      unset($output);

      $this->node_srl = $node_srl;
      $this->zone_id = $zone_id;

      $output = Zeroboard::getOutput();
      $output->tpl = $this->readTpl('simple_list.tpl');

      return $output;
    }

    function printDeniedHtml() {
      parent::printDeniedHtml();
      return $this->readTpl("message.tpl");
    }

  }

?>
