<?php

  class zArchiveList {

    function getTpl($data) {

      // 메뉴나 테마가 지정되어 있지 않으면 return
      if(!$data->info->menu || !$data->theme) return;

      // db, smarty, svc의 instance 생성
      $oDB = &zDB::instance();
      $oSmarty = &zSmarty::instance();
      $oSvc = &zSvc::instance();

      // 메뉴, 테마, 현재 선택된 plugin을 변수 지정
      $menu = $oDB->addquotes($data->info->menu);
      $theme = $data->theme;
      $plugin = $data->plugin;
      $this->s_title = $data->info->s_title;
      $this->s_title_image = $data->info->s_title_image;
      $this->sid = $oSvc->root_sid;

      // 이 플러그인의 tpl 파일을 지정
      $tpl_file = sprintf("%s%s/theme/%s/archive_list.tpl", PLUGIN_DIR, $plugin, $theme);
      $this->image_path = sprintf("%s%s/theme/%s/images/", PLUGIN_DIR, $plugin, $theme);

      // 선택된 메뉴에 포함된 모든 모듈을 추출
      $oDB->select('module_srl','menu_tree',"menu_srl='{$menu}'");
      while($tmp = $oDB->fetch()) {
        $module_srl_list[] = $tmp->module_srl;
      }

      // 포함된 모듈이 없으면 return
      if(!count($module_srl_list)) return;
      $module_srls = implode(',',$module_srl_list);

      // 해당 모듈들에 포함된 글 수를 년월 에 맞춰서 가져온다
      $field_list = array('substr(regdate,1,6) as regdate','count(*) as cnt');
      $table_list = 'articles';
      $cond_list = array("module_srl in ({$module_srls})");
      $order_list = 'listorder';
      $group_list = 'substr(regdate,1,6)';
      $oDB->selectGroup($field_list, $table_list, $cond_list, $order_list, $group_list);

      while($tmp = $oDB->fetch()) $this->archive_list->{$tmp->regdate} = $tmp->cnt;

      // tpl 파일을 읽어와서 뿌려준다 (images 경로를 변경)
      return $oSmarty->assign_fetch($tpl_file, $this);
    }
  }

  // zSvc에서 사용할 수 있도록 클래스를 미리 선언한다
  $pluginObj = new zArchiveList();
?>
