<?php

  class zCalendar {

    function getTpl($data) {
      // 메뉴와 테마가 지정되어 있지 않으면 return
      if(!$data->info->menu || !$data->theme) return;

      // db, smarty 의 instance 생성
      $oDB = &zDB::instance();
      $oSmarty = &zSmarty::instance();
      $oSvc = &zSvc::instance();

      // 메뉴, 테마, 현재 선택된 plugin을 변수 지정
      $menu = $oDB->addquotes($data->info->menu);
      $theme = $data->theme;
      $plugin = $data->plugin;
      $this->s_title = $data->info->s_title;
      $this->s_title_image = $data->info->s_title_image;
      $this->sid = $oSvc->root_sid;

      // 이 플러그인의 tpl 파일을 지정
      $tpl_file = sprintf("%s%s/theme/%s/calendar.tpl", PLUGIN_DIR, $plugin, $theme);
      $this->image_path = sprintf("%s%s/theme/%s/images/", PLUGIN_DIR, $plugin, $theme);

      // 선택된 메뉴에 포함된 모든 모듈을 추출
      $oDB->select('module_srl','menu_tree',"menu_srl='{$menu}'");
      while($tmp = $oDB->fetch()) $module_srl_list[] = $tmp->module_srl;

      // 포함된 모듈이 없으면 return
      if(!count($module_srl_list)) return;
      $module_srls = implode(',',$module_srl_list);

      // 글보관함(archive) 대비하여 plugin에서 직접 GET 데이터를 읽는다
      $archive = $_GET['archive'];
      if(!$archive) {
        $this->year = date("Y");
        $this->month = sprintf("%02d",date("m"));
        $date = $this->year.$this->month;
      } else {
        $this->year = substr($archive,0,4);
        if(!$this->year) $this->year = date("Y");
        $this->month = substr($archive,4,2);
        if(!$this->month) $this->month = date("m");
      }

      // archive를 통해 선택된 년/월을 추출
      $selected_day = mktime(0,0,1,$this->month, 1, $this->year);

      // 이전 다음달 지정
      $this->prev_month = date("Ym", $selected_day-60*60*24);
      $this->next_month = date("Ym", $selected_day+60*60*24*(date("t")+1));

      // 메뉴에 포함된 module에서 선택된 년/월에 해당되는 글의 등록일과 cnt를 추출
      $field_list = array('substr(regdate,1,8) as regdate','count(*) as cnt');
      $table_list = 'articles';
      $cond_list = array("module_srl in ({$module_srls})","regdate like '{$date}%'");
      $order_list = 'listorder';
      $group_list = 'substr(regdate,1,8)';
      $oDB->selectGroup($field_list, $table_list, $cond_list, $order_list, $group_list);

      while($tmp = $oDB->fetch()) {
        $regdate = $tmp->regdate;
        $cnt = $tmp->cnt;
        $article_list->$regdate = $cnt;
      }

      // 이번달의 시작요일과 마지막 일자를 구해서 calendar 배열 변수에 지정
      $start_week = date("w", mktime(0,0,1,$this->month,1,$this->year));
      $last_day = date("t");

      for($i=0;$i<$start_week;$i++) $this->calendar[$i] = null;

      $day = 0;
      while($day < $last_day) {
        unset($obj);
        $day++;
        $day_str = sprintf("%s%s%02d",$this->year,$this->month,$day);
        if($day_str==date("Ymd")) $obj->today = true;
        $obj->regdate = $day_str;
        $obj->cnt = number_format($article_list->{$day_str});
        $obj->day = $day;
        $this->calendar[$start_week+$day-1] = $obj;
      }

      // tpl 파일을 읽어와서 뿌려준다 (images 경로를 변경)
      return $oSmarty->assign_fetch($tpl_file, $this);
    }
  }

  // zSvc에서 사용할 수 있도록 클래스를 미리 선언한다
  $pluginObj = new zCalendar();
?>
