<?php

  class zGetMultiArticles {

    function getTpl($data) {
      // 테마가 지정되어 있지 않으면 return
      if(!$data->theme) return;

      // 다중 모듈 srl을 추출하고 모듈 srl의 게시글 아이콘을 따로 빼둠
      for($i=1;$i<=10;$i++) {
        $module_name = "module_".$i;
        $icon_name = "module_icon_".$i;

        $module_srl = trim($data->info->{$module_name});
        if(!$module_srl) continue;
        $module_srl_list[] = $module_srl;
        $icon_list[$module_srl] = $data->info->{$icon_name};
      }

      if(!count($module_srl_list)) return;

      // db, smarty, svc의 instance 생성
      $oDB = &zDB::instance();
      $oSmarty = &zSmarty::instance();
      $oSvc = &zSvc::instance();

      // 기본 변수 추출
      $plugin = $data->plugin;
      $theme = $data->theme;
      $module_srl = $oDB->addquotes($data->info->module_srl);
      $rows = $data->info->rows;
      if(!$rows) $rows = 5;
      $order = $data->info->order;
      if($order == 'modified') $order = 'modify_order';
      else $order = 'listorder';

      // 제목과 제목이미지를 변수로 지정
      $this->plugin_title = $data->info->plugin_title;
      $this->title_image = $data->info->title_image;

      // where문에 쓰기 위한 변수 선언
      $module_srls = implode(",",$module_srl_list);

      // 모듈 이름을 추출
      $oDB->select(array('module_srl','title'),'module_manager',"module_srl in ({$module_srls})");
      while($tmp = $oDB->fetch()) {
        $module_srl = $tmp->module_srl;
        $title = $tmp->title;
        $module_title[$module_srl] = $title;
      }

      // 선택한 모듈들의 최근 데이터 추출
      $oDB->select('*','articles',"module_srl in ({$module_srls})",$order,0,$rows);
      while($tmp = $oDB->fetch()) {
        $module_srl = $tmp->module_srl;
        $tmp->module_url = zUrl::getModuleUrl($module_srl);
        $tmp->url = zUrl::getViewUrl($tmp->article_srl);
        $tmp->article = strip_tags($tmp->article);
        $tmp->module_title = $module_title[$module_srl];
        $tmp->icon = $icon_list[$module_srl];
        $this->list[] = $tmp;
      }
      $this->list_cnt = count($this->list);

      // 이 플러그인의 tpl 파일을 지정
      $tpl_file = sprintf("%s%s/theme/%s/multi_get_articles.tpl", PLUGIN_DIR, $plugin, $theme);
      $this->image_path = sprintf("%s%s/theme/%s/images/", PLUGIN_DIR, $plugin, $theme);
      
      // tpl 파일을 읽어와서 뿌려준다 (images 경로를 변경)
      return $oSmarty->assign_fetch($tpl_file, $this);
    }

  }

  // zSvc에서 사용할 수 있도록 클래스를 미리 선언한다
  $pluginObj = new zGetMultiArticles();
?>
